/* =================================
	RECEIVING LENS FINDER QUERY - version 6.1
================================= */


function rcvFinderQuery() {

}



/* =================================
	THROW DISTANCE CALCULATION
================================= */

/* ===

L1: Projection distance (from screen to mirror reflective surface)	- dist1_mm / dist1_in / dist1_ft
_L2: From screen to tip of lens	- dist2 - not used
_L3: From screen to front of set	- dist3 - not used
L2 (_L4): From screen to rear of set - dist4_mm / dist4_in / dist4_ft
A1: From bottom edge of screen to top of set - dist5_mm / dist5_in / dist5_ft
A2: From bottom edge of screen to bottom of set - dist6_mm / dist6_in / dist6_ft

=== */


function calcThrowDistance(form, currentField) {

	// definition for calculating values

	// screen size
	var	scrnDiag_mm = document.getElementById('scrn-diag-mm').value,
		scrnDiag_in = document.getElementById('scrn-diag-in').value,
		scrnDiag_ft = document.getElementById('scrn-diag-ft').value,
		scrnH_mm = document.getElementById('scrn-h-mm').value,
		scrnH_in = document.getElementById('scrn-h-in').value,
		scrnH_ft = document.getElementById('scrn-h-ft').value,
		scrnW_mm = document.getElementById('scrn-w-mm').value,
		scrnW_in = document.getElementById('scrn-w-in').value,
		scrnW_ft = document.getElementById('scrn-w-ft').value,
		// throw distance
		dist1_mm = document.getElementById('dist1-mm').value,	// L1
		dist1_in = document.getElementById('dist1-in').value,
		dist1_ft = document.getElementById('dist1-ft').value,
		dist2_mm,	// _L2
		dist2_in,
		dist2_ft,
		dist3_mm,	// _L3
		dist3_in,
		dist3_ft,
		dist4_mm,	// L2 (_L4)
		dist4_in,
		dist4_ft,
		dist5_mm,	// A1
		dist5_in,
		dist5_ft,
		dist6_mm,	// A2
		dist6_in,
		dist6_ft,

		// coefficient
		aspectLength = document.forms['aspect-selector-button'].aspect.length,
		coefD = 18.868,
		coefH = 10,
		coefW = 16;

	// coefficient for aspects

	for ( var i = 0 ; i < aspectLength ; i++ ) {

		if ( document.forms['aspect-selector-button'].aspect[i].checked == true ) {

			var	aspectRatio = document.forms['aspect-selector-button'].elements['aspect'][i].value;
			
			var	/*coefB = coefBcommon,*/	// coefB
				lensTip = coefLensTip,	// unitL
				pjFr = coefPjFront,	// unitL
				pjRr = coefPjRear,	// unitL
				topB = coefPjTopB, // htB
				pjH = coefPjHeight; // unitH

			if ( aspectRatio == 1610 ) {
				var	coefD = 18.868,
					coefH = 10,
					coefW = 16,
					specAspect = '16:10',
					pjOutput = lumensNative,
					coefA = coefA_1610,	// dstA
					coefB = coefB_1610,	// dstB
					topA = coefPjTopA_1610; // htA
			}
			else if ( aspectRatio == 169 ) {
				var	coefD = 18.358,
					coefH = 9,
					coefW = 16,
					specAspect = '16:9',
					pjOutput = lumens169,
					coefA = coefA_169,
					coefB = coefB_169,	// dstB
					topA = coefPjTopA_169;
			}
			else if ( aspectRatio == 43 ) {
					coefD = 5,
					coefH = 3,
					coefW = 4,
					specAspect = '4:3',
					pjOutput = lumens43,
					coefA = coefA_43,
					coefB = coefB_43,	// dstB
					topA = coefPjTopA_43;
			}
			else {
				var	coefD = 0;
				var	coefH = 0;
				var	coefW = 0;
			}
		}

	}

	// scrn-diag-in

	if ( currentField == 'scrn-diag-in' ) {

		scrnDiag_mm = Math.round( scrnDiag_in * 25.4 );
//		scrnDiag_in = null;
		scrnDiag_ft = Math.round( scrnDiag_in / 12 * 100 ) / 100;
		scrnH_mm = Math.round( scrnDiag_in * coefH / coefD * 25.4 );
		scrnH_in = Math.round( scrnDiag_in * coefH / coefD * 10 ) / 10;
		scrnH_ft = Math.round( scrnDiag_in * coefH / coefD / 12 * 100 ) / 100;
		scrnW_mm = Math.round( scrnDiag_in * coefW / coefD * 25.4 );
		scrnW_in = Math.round( scrnDiag_in * coefW / coefD * 10 ) / 10;
		scrnW_ft = Math.round( scrnDiag_in * coefW / coefD / 12 * 100 ) / 100;
		dist1_mm = Math.round( scrnDiag_in * coefA + coefB );
		dist1_in = Math.round(( scrnDiag_in * coefA + coefB ) / 25.4 * 10 ) / 10;
		dist1_ft = Math.round(( scrnDiag_in * coefA + coefB ) / 25.4 / 12 * 100 ) / 100;
		dist2_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip );
		dist2_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip ) / 25.4 * 10 ) / 10;
		dist2_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip ) / 25.4 / 12 * 100 ) / 100;
		dist3_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip - pjFr );
		dist3_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjFr ) / 25.4 * 10 ) / 10;
		dist3_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjFr ) / 25.4 / 12 * 100 ) / 100;
		dist4_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip - pjRr );
		dist4_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjRr ) / 25.4 * 10 ) / 10;
		dist4_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjRr ) / 25.4 / 12 * 100 ) / 100;
		dist5_mm = Math.round( scrnDiag_in * topA - topB );
		dist5_in = Math.round(( scrnDiag_in * topA - topB ) / 25.4 * 10 ) / 10;
		dist5_ft = Math.round(( scrnDiag_in * topA - topB ) / 25.4 / 12 * 100 ) / 100;
		dist6_mm = Math.round( scrnDiag_in * topA - topB + pjH );
		dist6_in = Math.round(( scrnDiag_in * topA - topB + pjH ) / 25.4 * 10 ) / 10;
		dist6_ft = Math.round(( scrnDiag_in * topA - topB + pjH ) / 25.4 / 12 * 100 ) / 100;

	}

	// scrn-diag-mm

	else if ( currentField == 'scrn-diag-mm' ) {

//		scrnDiag_mm = null;
		scrnDiag_in = Math.round( scrnDiag_mm / 25.4 * 10 ) / 10;
		scrnDiag_ft = Math.round( scrnDiag_mm / 25.4 / 12 * 100 ) / 100;
		scrnH_mm = Math.round( scrnDiag_mm * coefH / coefD );
		scrnH_in = Math.round( scrnDiag_mm * coefH / coefD / 25.4 * 10 ) / 10;
		scrnH_ft = Math.round( scrnDiag_mm * coefH / coefD / 25.4 / 12 * 100 ) / 100;
		scrnW_mm = Math.round( scrnDiag_mm * coefW / coefD );
		scrnW_in = Math.round( scrnDiag_mm * coefW / coefD / 25.4 * 10 ) / 10;
		scrnW_ft = Math.round( scrnDiag_mm * coefW / coefD / 25.4 / 12 * 100 ) / 100;
		dist1_mm = Math.round( scrnDiag_in * coefA + coefB );
		dist1_in = Math.round(( scrnDiag_in * coefA + coefB ) / 25.4 * 10 ) / 10;
		dist1_ft = Math.round(( scrnDiag_in * coefA + coefB ) / 25.4 / 12 * 100 ) / 100;
		dist2_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip );
		dist2_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip ) / 25.4 * 10 ) / 10;
		dist2_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip ) / 25.4 / 12 * 100 ) / 100;
		dist3_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip - pjFr );
		dist3_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjFr ) / 25.4 * 10 ) / 10;
		dist3_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjFr ) / 25.4 / 12 * 100 ) / 100;
		dist4_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip - pjRr );
		dist4_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjRr ) / 25.4 * 10 ) / 10;
		dist4_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjRr ) / 25.4 / 12 * 100 ) / 100;
		dist5_mm = Math.round( scrnDiag_in * topA - topB );
		dist5_in = Math.round(( scrnDiag_in * topA - topB ) / 25.4 * 10 ) / 10;
		dist5_ft = Math.round(( scrnDiag_in * topA - topB ) / 25.4 / 12 * 100 ) / 100;
		dist6_mm = Math.round( scrnDiag_in * topA - topB + pjH );
		dist6_in = Math.round(( scrnDiag_in * topA - topB + pjH ) / 25.4 * 10 ) / 10;
		dist6_ft = Math.round(( scrnDiag_in * topA - topB + pjH ) / 25.4 / 12 * 100 ) / 100;

	}

	// scrn-diag-ft

	else if ( currentField == 'scrn-diag-ft' ) {

		scrnDiag_mm = Math.round(scrnDiag_ft * 12 * 25.4 );
		scrnDiag_in = Math.round(scrnDiag_ft * 12 * 10 ) / 10;
//		scrnDiag_ft = null;
		scrnH_mm = Math.round( scrnDiag_in * coefH / coefD * 25.4 );
		scrnH_in = Math.round( scrnDiag_in * coefH / coefD * 10 ) / 10;
		scrnH_ft = Math.round( scrnDiag_in * coefH / coefD / 12 * 100 ) / 100;
		scrnW_mm = Math.round( scrnDiag_in * coefW / coefD * 25.4 );
		scrnW_in = Math.round( scrnDiag_in * coefW / coefD * 10 ) / 10;
		scrnW_ft = Math.round( scrnDiag_in * coefW / coefD / 12 * 100 ) / 100;
		dist1_mm = Math.round( scrnDiag_in * coefA + coefB );
		dist1_in = Math.round(( scrnDiag_in * coefA + coefB ) / 25.4 * 10 ) / 10;
		dist1_ft = Math.round(( scrnDiag_in * coefA + coefB ) / 25.4 / 12 * 100 ) / 100;
		dist2_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip );
		dist2_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip ) / 25.4 * 10 ) / 10;
		dist2_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip ) / 25.4 / 12 * 100 ) / 100;
		dist3_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip - pjFr );
		dist3_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjFr ) / 25.4 * 10 ) / 10;
		dist3_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjFr ) / 25.4 / 12 * 100 ) / 100;
		dist4_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip - pjRr );
		dist4_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjRr ) / 25.4 * 10 ) / 10;
		dist4_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjRr ) / 25.4 / 12 * 100 ) / 100;
		dist5_mm = Math.round( scrnDiag_in * topA - topB );
		dist5_in = Math.round(( scrnDiag_in * topA - topB ) / 25.4 * 10 ) / 10;
		dist5_ft = Math.round(( scrnDiag_in * topA - topB ) / 25.4 / 12 * 100 ) / 100;
		dist6_mm = Math.round( scrnDiag_in * topA - topB + pjH );
		dist6_in = Math.round(( scrnDiag_in * topA - topB + pjH ) / 25.4 * 10 ) / 10;
		dist6_ft = Math.round(( scrnDiag_in * topA - topB + pjH ) / 25.4 / 12 * 100 ) / 100;

	}

	// scrn-h-mm

	else if ( currentField == 'scrn-h-mm' ) {

		scrnDiag_mm = Math.round( scrnH_mm * coefD / coefH );
		scrnDiag_in = Math.round( scrnDiag_mm / 25.4 * 10 ) / 10;
		scrnDiag_ft = Math.round( scrnDiag_mm / 25.4 / 12 * 100 ) / 100;
//		scrnH_mm = null;
		scrnH_in = Math.round( scrnH_mm / 25.4 * 10 ) / 10;
		scrnH_ft = Math.round( scrnH_mm / 25.4 / 12 * 100 ) / 100;
		scrnW_mm = Math.round( scrnH_mm * coefW / coefH );
		scrnW_in = Math.round( scrnH_mm * coefW / coefH / 25.4 * 10 ) / 10;
		scrnW_ft = Math.round( scrnH_mm * coefW / coefH / 25.4 / 12 * 100 ) / 100;
		dist1_mm = Math.round( scrnDiag_in * coefA + coefB );
		dist1_in = Math.round(( scrnDiag_in * coefA + coefB ) / 25.4 * 10 ) / 10;
		dist1_ft = Math.round(( scrnDiag_in * coefA + coefB ) / 25.4 / 12 * 100 ) / 100;
		dist2_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip );
		dist2_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip ) / 25.4 * 10 ) / 10;
		dist2_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip ) / 25.4 / 12 * 100 ) / 100;
		dist3_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip - pjFr );
		dist3_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjFr ) / 25.4 * 10 ) / 10;
		dist3_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjFr ) / 25.4 / 12 * 100 ) / 100;
		dist4_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip - pjRr );
		dist4_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjRr ) / 25.4 * 10 ) / 10;
		dist4_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjRr ) / 25.4 / 12 * 100 ) / 100;
		dist5_mm = Math.round( scrnDiag_in * topA - topB );
		dist5_in = Math.round(( scrnDiag_in * topA - topB ) / 25.4 * 10 ) / 10;
		dist5_ft = Math.round(( scrnDiag_in * topA - topB ) / 25.4 / 12 * 100 ) / 100;
		dist6_mm = Math.round( scrnDiag_in * topA - topB + pjH );
		dist6_in = Math.round(( scrnDiag_in * topA - topB + pjH ) / 25.4 * 10 ) / 10;
		dist6_ft = Math.round(( scrnDiag_in * topA - topB + pjH ) / 25.4 / 12 * 100 ) / 100;

	}

	// scrn-h-in

	else if ( currentField == 'scrn-h-in' ) {

		scrnDiag_mm = Math.round( scrnH_in * coefD / coefH * 25.4 );
		scrnDiag_in = Math.round( scrnH_in * 10 * coefD / coefH ) / 10;
		scrnDiag_ft = Math.round( scrnDiag_mm / 25.4 / 12 * 100 ) / 100;
		scrnH_mm = Math.round( scrnH_in * 25.4 );
//		scrnH_in = null;
		scrnH_ft = Math.round( scrnH_in / 12 * 100 ) / 100;
		scrnW_mm = Math.round( scrnH_in * coefW / coefH * 25.4 );
		scrnW_in = Math.round( scrnH_in * coefW / coefH * 10 ) / 10;
		scrnW_ft = Math.round( scrnH_in * coefW / coefH / 12 * 100 ) / 100;
		dist1_mm = Math.round( scrnDiag_in * coefA + coefB );
		dist1_in = Math.round(( scrnDiag_in * coefA + coefB ) / 25.4 * 10 ) / 10;
		dist1_ft = Math.round(( scrnDiag_in * coefA + coefB ) / 25.4 / 12 * 100 ) / 100;
		dist2_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip );
		dist2_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip ) / 25.4 * 10 ) / 10;
		dist2_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip ) / 25.4 / 12 * 100 ) / 100;
		dist3_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip - pjFr );
		dist3_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjFr ) / 25.4 * 10 ) / 10;
		dist3_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjFr ) / 25.4 / 12 * 100 ) / 100;
		dist4_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip - pjRr );
		dist4_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjRr ) / 25.4 * 10 ) / 10;
		dist4_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjRr ) / 25.4 / 12 * 100 ) / 100;
		dist5_mm = Math.round( scrnDiag_in * topA - topB );
		dist5_in = Math.round(( scrnDiag_in * topA - topB ) / 25.4 * 10 ) / 10;
		dist5_ft = Math.round(( scrnDiag_in * topA - topB ) / 25.4 / 12 * 100 ) / 100;
		dist6_mm = Math.round( scrnDiag_in * topA - topB + pjH );
		dist6_in = Math.round(( scrnDiag_in * topA - topB + pjH ) / 25.4 * 10 ) / 10;
		dist6_ft = Math.round(( scrnDiag_in * topA - topB + pjH ) / 25.4 / 12 * 100 ) / 100;

	}

	// scrn-h-ft

	else if ( currentField == 'scrn-h-ft' ) {

		scrnDiag_mm = Math.round( scrnH_ft * coefD / coefH * 25.4 * 12 );
		scrnDiag_in = Math.round( scrnDiag_mm / 25.4 * 10 ) / 10;
		scrnDiag_ft = Math.round( scrnDiag_mm / 25.4 / 12 * 100 ) / 100;
		scrnH_mm = Math.round( scrnH_ft * 12 * 25.4 );
		scrnH_in = Math.round( scrnH_ft * 12 * 10 ) / 10;
//		scrnH_ft = null;
		scrnW_mm = Math.round( scrnH_ft * coefW / coefH * 12 * 25.4 );
		scrnW_in = Math.round( scrnH_ft * coefW / coefH * 12 * 10 ) / 10;
		scrnW_ft = Math.round( scrnH_ft * coefW / coefH * 100 ) / 100;
		dist1_mm = Math.round( scrnDiag_in * coefA + coefB );
		dist1_in = Math.round(( scrnDiag_in * coefA + coefB ) / 25.4 * 10 ) / 10;
		dist1_ft = Math.round(( scrnDiag_in * coefA + coefB ) / 25.4 / 12 * 100 ) / 100;
		dist2_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip );
		dist2_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip ) / 25.4 * 10 ) / 10;
		dist2_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip ) / 25.4 / 12 * 100 ) / 100;
		dist3_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip - pjFr );
		dist3_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjFr ) / 25.4 * 10 ) / 10;
		dist3_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjFr ) / 25.4 / 12 * 100 ) / 100;
		dist4_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip - pjRr );
		dist4_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjRr ) / 25.4 * 10 ) / 10;
		dist4_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjRr ) / 25.4 / 12 * 100 ) / 100;
		dist5_mm = Math.round( scrnDiag_in * topA - topB );
		dist5_in = Math.round(( scrnDiag_in * topA - topB ) / 25.4 * 10 ) / 10;
		dist5_ft = Math.round(( scrnDiag_in * topA - topB ) / 25.4 / 12 * 100 ) / 100;
		dist6_mm = Math.round( scrnDiag_in * topA - topB + pjH );
		dist6_in = Math.round(( scrnDiag_in * topA - topB + pjH ) / 25.4 * 10 ) / 10;
		dist6_ft = Math.round(( scrnDiag_in * topA - topB + pjH ) / 25.4 / 12 * 100 ) / 100;

	}

	// scrn-w-mm

	else if ( currentField == 'scrn-w-mm' ) {

		scrnDiag_mm = Math.round( scrnW_mm * coefD / coefW );
		scrnDiag_in = Math.round( scrnDiag_mm / 25.4 * 10 ) / 10;
		scrnDiag_ft = Math.round( scrnDiag_mm / 25.4 / 12 * 100 ) / 100;
		scrnH_mm = Math.round( scrnW_mm * coefH / coefW );
		scrnH_in = Math.round( scrnW_mm * coefH / coefW / 25.4 * 10 ) / 10;
		scrnH_ft = Math.round( scrnW_mm * coefH / coefW / 25.4 / 12 * 100 ) / 100;
//		scrnW_mm = null;
		scrnW_in = Math.round( scrnW_mm / 25.4 * 10 ) / 10;
		scrnW_ft = Math.round( scrnW_mm / 25.4 / 12 * 100 ) / 100;
		dist1_mm = Math.round( scrnDiag_in * coefA + coefB );
		dist1_in = Math.round(( scrnDiag_in * coefA + coefB ) / 25.4 * 10 ) / 10;
		dist1_ft = Math.round(( scrnDiag_in * coefA + coefB ) / 25.4 / 12 * 100 ) / 100;
		dist2_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip );
		dist2_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip ) / 25.4 * 10 ) / 10;
		dist2_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip ) / 25.4 / 12 * 100 ) / 100;
		dist3_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip - pjFr );
		dist3_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjFr ) / 25.4 * 10 ) / 10;
		dist3_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjFr ) / 25.4 / 12 * 100 ) / 100;
		dist4_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip - pjRr );
		dist4_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjRr ) / 25.4 * 10 ) / 10;
		dist4_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjRr ) / 25.4 / 12 * 100 ) / 100;
		dist5_mm = Math.round( scrnDiag_in * topA - topB );
		dist5_in = Math.round(( scrnDiag_in * topA - topB ) / 25.4 * 10 ) / 10;
		dist5_ft = Math.round(( scrnDiag_in * topA - topB ) / 25.4 / 12 * 100 ) / 100;
		dist6_mm = Math.round( scrnDiag_in * topA - topB + pjH );
		dist6_in = Math.round(( scrnDiag_in * topA - topB + pjH ) / 25.4 * 10 ) / 10;
		dist6_ft = Math.round(( scrnDiag_in * topA - topB + pjH ) / 25.4 / 12 * 100 ) / 100;

	}

	// scrn-w-in

	else if ( currentField == 'scrn-w-in' ) {

		scrnDiag_mm = Math.round( scrnW_in * coefD / coefW * 25.4 );
		scrnDiag_in = Math.round( scrnDiag_mm / 25.4 * 10 ) / 10;
		scrnDiag_ft = Math.round( scrnDiag_mm / 25.4 / 12 * 100 ) / 100;
		scrnH_mm = Math.round( scrnW_in * coefH / coefW * 25.4 );
		scrnH_in = Math.round( scrnW_in * coefH / coefW * 10 ) / 10;
		scrnH_ft = Math.round( scrnW_in * coefH / coefW / 12 * 100 ) / 100;
		scrnW_mm = Math.round( scrnW_in * 25.4 );
//		scrnW_in = null;
		scrnW_ft = Math.round( scrnW_in / 12 * 100 ) / 100;
		dist1_mm = Math.round( scrnDiag_in * coefA + coefB );
		dist1_in = Math.round(( scrnDiag_in * coefA + coefB ) / 25.4 * 10 ) / 10;
		dist1_ft = Math.round(( scrnDiag_in * coefA + coefB ) / 25.4 / 12 * 100 ) / 100;
		dist2_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip );
		dist2_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip ) / 25.4 * 10 ) / 10;
		dist2_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip ) / 25.4 / 12 * 100 ) / 100;
		dist3_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip - pjFr );
		dist3_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjFr ) / 25.4 * 10 ) / 10;
		dist3_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjFr ) / 25.4 / 12 * 100 ) / 100;
		dist4_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip - pjRr );
		dist4_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjRr ) / 25.4 * 10 ) / 10;
		dist4_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjRr ) / 25.4 / 12 * 100 ) / 100;
		dist5_mm = Math.round( scrnDiag_in * topA - topB );
		dist5_in = Math.round(( scrnDiag_in * topA - topB ) / 25.4 * 10 ) / 10;
		dist5_ft = Math.round(( scrnDiag_in * topA - topB ) / 25.4 / 12 * 100 ) / 100;
		dist6_mm = Math.round( scrnDiag_in * topA - topB + pjH );
		dist6_in = Math.round(( scrnDiag_in * topA - topB + pjH ) / 25.4 * 10 ) / 10;
		dist6_ft = Math.round(( scrnDiag_in * topA - topB + pjH ) / 25.4 / 12 * 100 ) / 100;

	}

	// scrn-w-ft

	else if ( currentField == 'scrn-w-ft' ) {

		scrnDiag_mm = Math.round( scrnW_ft * coefD / coefW * 25.4 * 12 );
		scrnDiag_in = Math.round( scrnDiag_mm / 25.4 * 10 ) / 10;
		scrnDiag_ft = Math.round( scrnDiag_mm / 25.4 / 12 * 100 ) / 100;
		scrnH_mm = Math.round( scrnW_ft * coefH / coefW * 12 * 25.4 );
		scrnH_in = Math.round( scrnW_ft * coefH / coefW * 12 * 10 ) / 10;
		scrnH_ft = Math.round( scrnW_ft * coefH / coefW * 100 ) / 100;
		scrnW_mm = Math.round( scrnW_ft * 12 * 25.4 );
		scrnW_in = Math.round( scrnW_ft * 12 * 10 ) / 10;
//		scrnW_ft = null;
		dist1_mm = Math.round( scrnDiag_in * coefA + coefB );
		dist1_in = Math.round(( scrnDiag_in * coefA + coefB ) / 25.4 * 10 ) / 10;
		dist1_ft = Math.round(( scrnDiag_in * coefA + coefB ) / 25.4 / 12 * 100 ) / 100;
		dist2_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip );
		dist2_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip ) / 25.4 * 10 ) / 10;
		dist2_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip ) / 25.4 / 12 * 100 ) / 100;
		dist3_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip - pjFr );
		dist3_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjFr ) / 25.4 * 10 ) / 10;
		dist3_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjFr ) / 25.4 / 12 * 100 ) / 100;
		dist4_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip - pjRr );
		dist4_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjRr ) / 25.4 * 10 ) / 10;
		dist4_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjRr ) / 25.4 / 12 * 100 ) / 100;
		dist5_mm = Math.round( scrnDiag_in * topA - topB );
		dist5_in = Math.round(( scrnDiag_in * topA - topB ) / 25.4 * 10 ) / 10;
		dist5_ft = Math.round(( scrnDiag_in * topA - topB ) / 25.4 / 12 * 100 ) / 100;
		dist6_mm = Math.round( scrnDiag_in * topA - topB + pjH );
		dist6_in = Math.round(( scrnDiag_in * topA - topB + pjH ) / 25.4 * 10 ) / 10;
		dist6_ft = Math.round(( scrnDiag_in * topA - topB + pjH ) / 25.4 / 12 * 100 ) / 100;

	}

	// dist1-mm

	else if ( currentField == 'dist1-mm' ) {

		scrnDiag_mm = Math.round(( eval( dist1_mm ) - coefB ) / coefA * 25.4 );
		scrnDiag_in = Math.round(( eval( dist1_mm ) - coefB ) / coefA * 10 ) / 10;
		scrnDiag_ft = Math.round(( eval( dist1_mm ) - coefB ) / coefA / 12 * 100 ) / 100;
		scrnH_mm = Math.round( scrnDiag_mm * coefH / coefD );
		scrnH_in = Math.round( scrnDiag_mm * coefH / coefD / 25.4 * 10 ) / 10;
		scrnH_ft = Math.round( scrnDiag_mm * coefH / coefD / 25.4 / 12 * 100 ) / 100;
		scrnW_mm = Math.round( scrnDiag_mm * coefW / coefD );
		scrnW_in = Math.round( scrnDiag_mm * coefW / coefD / 25.4 * 10 ) / 10;
		scrnW_ft = Math.round( scrnDiag_mm * coefW / coefD / 25.4 / 12 * 100 ) / 100;
//		dist1_mm = null;
		dist1_in = Math.round( dist1_mm / 25.4 * 10 ) / 10;
		dist1_ft = Math.round( dist1_mm / 25.4 / 12 * 100 ) / 100;
		dist2_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip );
		dist2_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip ) / 25.4 * 10 ) / 10;
		dist2_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip ) / 25.4 / 12 * 100 ) / 100;
		dist3_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip - pjFr );
		dist3_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjFr ) / 25.4 * 10 ) / 10;
		dist3_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjFr ) / 25.4 / 12 * 100 ) / 100;
		dist4_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip - pjRr );
		dist4_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjRr ) / 25.4 * 10 ) / 10;
		dist4_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjRr ) / 25.4 / 12 * 100 ) / 100;
		dist5_mm = Math.round( scrnDiag_in * topA - topB );
		dist5_in = Math.round(( scrnDiag_in * topA - topB ) / 25.4 * 10 ) / 10;
		dist5_ft = Math.round(( scrnDiag_in * topA - topB ) / 25.4 / 12 * 100 ) / 100;
		dist6_mm = Math.round( scrnDiag_in * topA - topB + pjH );
		dist6_in = Math.round(( scrnDiag_in * topA - topB + pjH ) / 25.4 * 10 ) / 10;
		dist6_ft = Math.round(( scrnDiag_in * topA - topB + pjH ) / 25.4 / 12 * 100 ) / 100;

	}

	// dist1-in

	else if ( currentField == 'dist1-in' ) {

		scrnDiag_mm = Math.round(( dist1_in * 25.4 - coefB ) / coefA * 25.4 );
		scrnDiag_in = Math.round(( dist1_in * 25.4 - coefB ) / coefA * 10 ) / 10;
		scrnDiag_ft = Math.round(( dist1_in * 25.4 - coefB ) / coefA / 12 * 100 ) / 100;
		scrnH_mm = Math.round( scrnDiag_mm * coefH / coefD );
		scrnH_in = Math.round( scrnDiag_mm * coefH / coefD / 25.4 * 10 ) / 10;
		scrnH_ft = Math.round( scrnDiag_mm * coefH / coefD / 25.4 / 12 * 100 ) / 100;
		scrnW_mm = Math.round( scrnDiag_mm * coefW / coefD );
		scrnW_in = Math.round( scrnDiag_mm * coefW / coefD / 25.4 * 10 ) / 10;
		scrnW_ft = Math.round( scrnDiag_mm * coefW / coefD / 25.4 / 12 * 100 ) / 100;
		dist1_mm = Math.round( dist1_in * 25.4 );
//		dist1_in = null;
		dist1_ft = Math.round( dist1_in / 12 * 100 ) / 100;
		dist2_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip );
		dist2_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip ) / 25.4 * 10 ) / 10;
		dist2_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip ) / 25.4 / 12 * 100 ) / 100;
		dist3_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip - pjFr );
		dist3_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjFr ) / 25.4 * 10 ) / 10;
		dist3_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjFr ) / 25.4 / 12 * 100 ) / 100;
		dist4_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip - pjRr );
		dist4_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjRr ) / 25.4 * 10 ) / 10;
		dist4_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjRr ) / 25.4 / 12 * 100 ) / 100;
		dist5_mm = Math.round( scrnDiag_in * topA - topB );
		dist5_in = Math.round(( scrnDiag_in * topA - topB ) / 25.4 * 10 ) / 10;
		dist5_ft = Math.round(( scrnDiag_in * topA - topB ) / 25.4 / 12 * 100 ) / 100;
		dist6_mm = Math.round( scrnDiag_in * topA - topB + pjH );
		dist6_in = Math.round(( scrnDiag_in * topA - topB + pjH ) / 25.4 * 10 ) / 10;
		dist6_ft = Math.round(( scrnDiag_in * topA - topB + pjH ) / 25.4 / 12 * 100 ) / 100;

	}

	// dist1-ft

	else if ( currentField == 'dist1-ft' ) {

		scrnDiag_mm = Math.round(( dist1_ft * 12 * 25.4 - coefB ) / coefA * 25.4 );
		scrnDiag_in = Math.round(( dist1_ft * 12 * 25.4 - coefB ) / coefA * 10 ) / 10;
		scrnDiag_ft = Math.round(( dist1_ft * 12 * 25.4 - coefB ) / coefA / 12 * 100 ) / 100;
		scrnH_mm = Math.round( scrnDiag_mm * coefH / coefD );
		scrnH_in = Math.round( scrnDiag_mm * coefH / coefD / 25.4 * 10 ) / 10;
		scrnH_ft = Math.round( scrnDiag_mm * coefH / coefD / 25.4 / 12 * 100 ) / 100;
		scrnW_mm = Math.round( scrnDiag_mm * coefW / coefD );
		scrnW_in = Math.round( scrnDiag_mm * coefW / coefD / 25.4 * 10 ) / 10;
		scrnW_ft = Math.round( scrnDiag_mm * coefW / coefD / 25.4 / 12 * 100 ) / 100;
		dist1_mm = Math.round( dist1_ft * 12 * 25.4 );
		dist1_in = Math.round( dist1_ft * 12 * 10 ) / 10;
//		dist1_ft = null;
		dist2_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip );
		dist2_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip ) / 25.4 * 10 ) / 10;
		dist2_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip ) / 25.4 / 12 * 100 ) / 100;
		dist3_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip - pjFr );
		dist3_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjFr ) / 25.4 * 10 ) / 10;
		dist3_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjFr ) / 25.4 / 12 * 100 ) / 100;
		dist4_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip - pjRr );
		dist4_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjRr ) / 25.4 * 10 ) / 10;
		dist4_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjRr ) / 25.4 / 12 * 100 ) / 100;
		dist5_mm = Math.round( scrnDiag_in * topA - topB );
		dist5_in = Math.round(( scrnDiag_in * topA - topB ) / 25.4 * 10 ) / 10;
		dist5_ft = Math.round(( scrnDiag_in * topA - topB ) / 25.4 / 12 * 100 ) / 100;
		dist6_mm = Math.round( scrnDiag_in * topA - topB + pjH );
		dist6_in = Math.round(( scrnDiag_in * topA - topB + pjH ) / 25.4 * 10 ) / 10;
		dist6_ft = Math.round(( scrnDiag_in * topA - topB + pjH ) / 25.4 / 12 * 100 ) / 100;

	}

// recalculation: calc button after tab/return

	else if ( scrnDiag_in != '' ) {

		dist2_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip );
		dist2_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip ) / 25.4 * 10 ) / 10;
		dist2_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip ) / 25.4 / 12 * 100 ) / 100;
		dist3_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip - pjFr );
		dist3_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjFr ) / 25.4 * 10 ) / 10;
		dist3_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjFr ) / 25.4 / 12 * 100 ) / 100;
		dist4_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip - pjRr );
		dist4_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjRr ) / 25.4 * 10 ) / 10;
		dist4_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjRr ) / 25.4 / 12 * 100 ) / 100;
		dist5_mm = Math.round( scrnDiag_in * topA - topB );
		dist5_in = Math.round(( scrnDiag_in * topA - topB ) / 25.4 * 10 ) / 10;
		dist5_ft = Math.round(( scrnDiag_in * topA - topB ) / 25.4 / 12 * 100 ) / 100;
		dist6_mm = Math.round( scrnDiag_in * topA - topB + pjH );
		dist6_in = Math.round(( scrnDiag_in * topA - topB + pjH ) / 25.4 * 10 ) / 10;
		dist6_ft = Math.round(( scrnDiag_in * topA - topB + pjH ) / 25.4 / 12 * 100 ) / 100;

	}

	// placing values into input boxes

	document.getElementById('scrn-diag-mm').value = scrnDiag_mm;
	document.getElementById('scrn-diag-in').value = scrnDiag_in;
	document.getElementById('scrn-diag-ft').value = scrnDiag_ft;
	document.getElementById('scrn-h-mm').value = scrnH_mm;
	document.getElementById('scrn-h-in').value = scrnH_in;
	document.getElementById('scrn-h-ft').value = scrnH_ft;
	document.getElementById('scrn-w-mm').value = scrnW_mm;
	document.getElementById('scrn-w-in').value = scrnW_in;
	document.getElementById('scrn-w-ft').value = scrnW_ft;
	document.getElementById('dist1-mm').value = dist1_mm;
	document.getElementById('dist1-in').value = dist1_in;
	document.getElementById('dist1-ft').value = dist1_ft;

	// optical shift range

	// brightness

	var scrnIlluminance = Math.round( pjOutput / ( scrnH_mm * scrnW_mm / 1000 / 1000 ) );


	//// result strings //////////////

	// toLocaleString()

	var	scrnDiag_mm = parseFloat(scrnDiag_mm).toLocaleString(),
		scrnDiag_in = parseFloat(scrnDiag_in).toLocaleString(),
		scrnDiag_ft = parseFloat(scrnDiag_ft).toLocaleString(),
		scrnH_mm = parseFloat(scrnH_mm).toLocaleString(),
		scrnH_in = parseFloat(scrnH_in).toLocaleString(),
		scrnH_ft = parseFloat(scrnH_ft).toLocaleString(),
		scrnW_mm = parseFloat(scrnW_mm).toLocaleString(),
		scrnW_in = parseFloat(scrnW_in).toLocaleString(),
		scrnW_ft = parseFloat(scrnW_ft).toLocaleString(),
		dist1_mm = parseFloat(dist1_mm).toLocaleString(),
		dist1_in = parseFloat(dist1_in).toLocaleString(),
		dist1_ft = parseFloat(dist1_ft).toLocaleString(),
		dist4_mm = parseFloat(dist4_mm).toLocaleString(),
		dist4_in = parseFloat(dist4_in).toLocaleString(),
		dist4_ft = parseFloat(dist4_ft).toLocaleString(),
		dist5_mm = parseFloat(dist5_mm).toLocaleString(),
		dist5_in = parseFloat(dist5_in).toLocaleString(),
		dist5_ft = parseFloat(dist5_ft).toLocaleString(),
		dist6_mm = parseFloat(dist6_mm).toLocaleString(),
		dist6_in = parseFloat(dist6_in).toLocaleString(),
		dist6_ft = parseFloat(dist6_ft).toLocaleString(),
		pjOutput = parseFloat(pjOutput).toLocaleString(),
		scrnIlluminance = parseFloat(scrnIlluminance).toLocaleString();

	// specs

	var	specsModel = 'Projector: '+pjModel,
		specsLens = 'Lens: '+lensModel,
		specsPjSize = '[Projection size]',
		specsAspectRatio = 'Aspect ratio: '+specAspect,
		specsPjSize_diag = 'Diagonal: '+scrnDiag_mm+' mm / '+scrnDiag_in+' in / '+scrnDiag_ft+' ft',
		specsPjSize_h = 'Height: '+scrnH_mm+' mm / '+scrnH_in+' in / '+scrnH_ft+' ft',
		specsPjSize_w = 'Width: '+scrnW_mm+' mm / '+scrnW_in+' in / '+scrnW_ft+' ft',
		specsDim = '[Projection distance]',
		specsDistL1 = 'L1: '+dist1_mm+' mm / '+dist1_in+' in / '+dist1_ft+' ft',
/*		specsDistL2 = 'L2: '+dist2_mm+' mm / '+dist2_in+' in / '+dist2_ft+' ft',
		specsDistL3 = 'L3: '+dist3_mm+' mm / '+dist3_in+' in / '+dist3_ft+' ft',
*/		specsDistL2 = 'L2: '+dist4_mm+' mm / '+dist4_in+' in / '+dist4_ft+' ft',
		specsDistA1_mm = 'A1: '+dist5_mm+' mm',
		specsDistA1_in = ' / '+dist5_in+' in',
		specsDistA1_ft = ' / '+dist5_ft+' ft',
		specsDistA2_mm = 'A2: '+dist6_mm+' mm',
		specsDistA2_in = ' / '+dist6_in+' in',
		specsDistA2_ft = ' / '+dist6_ft+' ft';

	var	specs = specsModel+'\n'+specsLens+'\n'+specsPjSize+'\n'+specsAspectRatio+'\n'+specsPjSize_diag+'\n'+specsPjSize_h+'\n'+specsPjSize_w+'\n'+specsDim+'\n'+specsDistL1+'\n'+specsDistL2+'\n'+specsDistA1_mm+specsDistA1_in+specsDistA1_ft+'\n'+specsDistA2_mm+specsDistA2_in+specsDistA2_ft;

	// shift range

	// brightness

	var	pjLumens = '[Brightness]\n'+'Projector output: '+pjOutput+' lm',
		scrnLux = 'Screen illuminance: '+scrnIlluminance+' lx';

	var	brightness = pjLumens+'\n'+scrnLux;
	
	// replace textarea

	var	tagTextareaStart = '<textarea id="result-list" rows=22>';
	var	tagTextareaEnd = '</textarea>';


	//// put results in textarea //////////////

	var	resultAll = tagTextareaStart+specs+'\n'+brightness+tagTextareaEnd;

	var	resultInTextarea = document.getElementById('show-result');
	resultInTextarea.innerHTML = resultAll;


	//// write results for printing //////////////

	var	tableStart = '<table>',
		tableEnd = '</table>',
		trStart = '<tr>',
		trEnd = '</tr>',
		tdStart = '<td>',
		tdEnd = '</td>',
		
		// spec
		specsModelPrn = '<tr><td>Projector: </td><td>'+pjModel+'</td></tr>',
		specsLensPrn = '<tr><td>Lens: </td><td>'+lensModel+'</td></tr>',
		// shift range

		// brightness
		pjBrightness = '[Brightness]';
		pjLumensPrn = 'Projector output: '+pjOutput+' lm';

	var	resultPrint = 
		tableStart + 
		specsModelPrn + specsLensPrn + 
		trStart + 
		tdStart + specsPjSize + tdEnd + 
		tdStart + specsAspectRatio + '<br>' + specsPjSize_diag + '<br>' + specsPjSize_h + '<br>' + specsPjSize_w + tdEnd + 
		trEnd + 
		trStart + 
		tdStart + specsDim + tdEnd + 
		tdStart + specsDistL1 + '<br>' + specsDistL2 + '<br>' + specsDistA1_mm + specsDistA1_in + specsDistA1_ft + '<br>' + specsDistA2_mm + specsDistA2_in + specsDistA2_ft + tdEnd + 
		trEnd + 
		trStart + 
		tdStart + pjBrightness + tdEnd + 
		tdEnd + tdStart + pjLumensPrn + '<br>' + scrnLux + tdEnd + 
		trEnd + 
		tableEnd;

		resultForPrint = document.getElementById('results-for-print');
		resultForPrint.innerHTML = resultPrint;


	//// Screen size alert - scrnalert.js //////////////

	if ( scrnDiag_in != '' ) {

		scrnAlert();

	}


}