/* =================================
	RECEIVING LENS FINDER QUERY - version 9
================================= */


/* ===

L1: Projection distance (from screen to mirror reflective surface)	- dist1_mm / dist1_in / dist1_ft
L2: From screen to tip of lens	- dist2_mm / dist2_in / dist2_ft
L3: From screen to front of set	- dist3_mm / dist3_in / dist3_ft
L4: From screen to rear of set - dist4_mm / dist4_in / dist4_ft
A1: From bottom edge of screen to top of set - min: dist5_mm (_in/_ft); max: dist6_mm (_in/_ft)
A2: From bottom edge of screen to bottom of set - min: dist7_mm (_in/_ft); max: dist8_mm (_in/_ft)

=== */


function rcvFinderQuery() {



	// definition for calculating values

	// screen size
	var	scrnDiag_mm = document.getElementById('scrn-diag-mm').value,
		scrnDiag_in = document.getElementById('scrn-diag-in').value,
		scrnDiag_ft = document.getElementById('scrn-diag-ft').value,
		scrnH_mm = document.getElementById('scrn-h-mm').value,
		scrnH_in = document.getElementById('scrn-h-in').value,
		scrnH_ft = document.getElementById('scrn-h-ft').value,
		scrnW_mm = document.getElementById('scrn-w-mm').value,
		scrnW_in = document.getElementById('scrn-w-in').value,
		scrnW_ft = document.getElementById('scrn-w-ft').value,
		// throw distance
		dist1_mm = document.getElementById('dist1-mm').value,	// L1
		dist1_in = document.getElementById('dist1-in').value,
		dist1_ft = document.getElementById('dist1-ft').value,
		dist2_mm,	// L2
		dist2_in,
		dist2_ft,
		dist3_mm,	// L3
		dist3_in,
		dist3_ft,
		dist4_mm,	// L4
		dist4_in,
		dist4_ft,
		dist5_mm,	// A1 min
		dist5_in,
		dist5_ft,
		dist6_mm,	// A1 max
		dist6_in,
		dist6_ft,
		dist7_mm,	// A2 min
		dist7_in,
		dist7_ft,
		dist8_mm,	// A2 max
		dist8_in,
		dist8_ft,
		dist9_mm,	// VS1
		dist9_in,
		dist9_ft,
		dist10_mm,	// HS1
		dist10_in,
		dist10_ft,

		// coefficient
		aspectLength = document.forms['aspect-selector-button'].aspect.length,
		coefD = 18.868,
		coefH = 10,
		coefW = 16,

		// receiving query (screen size and aspect ratio)
		aspect = document.getElementsByName('aspect'),
		query = location.search.substring(1, location.search.length),
		parameters = query.split('&'),
		userScrnSize = parameters[0],
		selAspectRatio = parameters[1],
		userScrnUnit = parameters[2],
		userScrnPortion = parameters[3];


/////	calculate when a query from lens finder is received

	if ( userScrnSize != '' ) {



		if ( userScrnUnit == 'in' ) {

			if ( userScrnPortion == 'diag' ) {
				scrnDiag_in = userScrnSize;
			} else if ( userScrnPortion == 'height' ) {
				scrnH_in = userScrnSize;
			} else if (userScrnPortion == 'width' ) {
				scrnW_in = userScrnSize;
			}

		} else if ( userScrnUnit == 'mm' ) {

			if ( userScrnPortion == 'diag' ) {
				scrnDiag_mm = userScrnSize;
			} else if ( userScrnPortion == 'height' ) {
				scrnH_mm = userScrnSize;
			} else if (userScrnPortion == 'width' ) {
				scrnW_mm = userScrnSize;
			}

		}

		for ( var i = 0; i < aspect.length; i++ ) {

			if ( selAspectRatio == aspect[i].value ) {
				aspect[i].checked = true;
			}

		}

		// coefficient for aspects

		for ( var i = 0 ; i < aspectLength ; i++ ) {

			if ( document.forms['aspect-selector-button'].aspect[i].checked == true ) {

				var	aspectRatio = document.forms['aspect-selector-button'].elements['aspect'][i].value;

				var	coefB = coefBcommon,	// coefB
					lensTip = coefLensTip,	// unitL
					pjFr = coefPjFront,	// unitL
					pjRr = coefPjRear,	// unitL
					topB = coefPjTopB, // htB
					pjH = coefPjHeight; // unitH

				if ( aspectRatio == 1610 ) {
					var	coefD = 18.868,
						coefH = 10,
						coefW = 16,
						specAspect = '16:10',
						pjOutput = lumensNative,
						coefA = coefA_1610,	// dstA
						topAmin = coefPjTopAmin_1610, // htA
						topAmax = coefPjTopAmax_1610; // htA
				} else if ( aspectRatio == 169 ) {
					var	coefD = 18.358,
						coefH = 9,
						coefW = 16,
						specAspect = '16:9',
						pjOutput = lumens169,
						coefA = coefA_169,
						topAmin = coefPjTopAmin_169,
						topAmax = coefPjTopAmax_169;
				} else if ( aspectRatio == 43 ) {
						coefD = 5,
						coefH = 3,
						coefW = 4,
						specAspect = '4:3',
						pjOutput = lumens43,
						coefA = coefA_43,
						topAmin = coefPjTopAmin_43,
						topAmax = coefPjTopAmax_43;
				} else {
					var	coefD = 0,
						coefH = 0,
						coefW = 0;
				}

			}

		}

		// throw distance calculation

		if ( userScrnPortion == 'diag' ) {

			if ( userScrnUnit == 'in' ) {
			scrnDiag_mm = Math.round( scrnDiag_in * 25.4 );
//			scrnDiag_in = null;
			} else if ( userScrnUnit == 'mm' ) {
//			scrnDiag_mm = null;
			scrnDiag_in = Math.round( scrnDiag_mm / 25.4 * 10 ) / 10;
			}
			scrnDiag_ft = Math.round( scrnDiag_in / 12 * 100 ) / 100;
			scrnH_mm = Math.round( scrnDiag_in * coefH / coefD * 25.4 );
			scrnH_in = Math.round( scrnDiag_in * coefH / coefD * 10 ) / 10;
			scrnH_ft = Math.round( scrnDiag_in * coefH / coefD / 12 * 100 ) / 100;
			scrnW_mm = Math.round( scrnDiag_in * coefW / coefD * 25.4 );
			scrnW_in = Math.round( scrnDiag_in * coefW / coefD * 10 ) / 10;
			scrnW_ft = Math.round( scrnDiag_in * coefW / coefD / 12 * 100 ) / 100;
			dist1_mm = Math.round( scrnDiag_in * coefA + coefB );
			dist1_in = Math.round(( scrnDiag_in * coefA + coefB ) / 25.4 * 10 ) / 10;
			dist1_ft = Math.round(( scrnDiag_in * coefA + coefB ) / 25.4 / 12 * 100 ) / 100;
			dist2_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip );
			dist2_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip ) / 25.4 * 10 ) / 10;
			dist2_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip ) / 25.4 / 12 * 100 ) / 100;
			dist3_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip - pjFr );
			dist3_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjFr ) / 25.4 * 10 ) / 10;
			dist3_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjFr ) / 25.4 / 12 * 100 ) / 100;
			dist4_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip - pjRr );
			dist4_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjRr ) / 25.4 * 10 ) / 10;
			dist4_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjRr ) / 25.4 / 12 * 100 ) / 100;
			dist5_mm = Math.round( scrnH_mm * topAmin - topB );
			dist5_in = Math.round(( scrnH_mm * topAmin - topB ) / 25.4 * 10 ) / 10;
			dist5_ft = Math.round(( scrnH_mm * topAmin - topB ) / 25.4 / 12 * 100 ) / 100;
			dist6_mm = Math.round( scrnH_mm * topAmax - topB );
			dist6_in = Math.round(( scrnH_mm * topAmax - topB ) / 25.4 * 10 ) / 10;
			dist6_ft = Math.round(( scrnH_mm * topAmax - topB ) / 25.4 / 12 * 100 ) / 100;
			dist7_mm = Math.round( scrnH_mm * topAmin - topB + pjH );
			dist7_in = Math.round(( scrnH_mm * topAmin - topB + pjH ) / 25.4 * 10 ) / 10;
			dist7_ft = Math.round(( scrnH_mm * topAmin - topB + pjH ) / 25.4 / 12 * 100 ) / 100;
			dist8_mm = Math.round( scrnH_mm * topAmax - topB + pjH );
			dist8_in = Math.round(( scrnH_mm * topAmax - topB + pjH ) / 25.4 * 10 ) / 10;
			dist8_ft = Math.round(( scrnH_mm * topAmax - topB + pjH ) / 25.4 / 12 * 100 ) / 100;

		}

		else if ( userScrnPortion == 'height' ) {

			if ( userScrnUnit == 'in' ) {
			scrnH_mm = Math.round( scrnH_in * 25.4 );
//			scrnH_in = null;
			} else if ( userScrnUnit == 'mm' ) {
//			scrnH_mm = null;
			scrnH_in = Math.round( scrnH_mm / 25.4 * 10 ) / 10;
			}
			scrnDiag_mm = Math.round( scrnH_mm * coefD / coefH );
			scrnDiag_in = Math.round( scrnDiag_mm / 25.4 * 10 ) / 10;
			scrnDiag_ft = Math.round( scrnDiag_mm / 25.4 / 12 * 100 ) / 100;
			scrnH_ft = Math.round( scrnH_mm / 25.4 / 12 * 100 ) / 100;
			scrnW_mm = Math.round( scrnH_mm * coefW / coefH );
			scrnW_in = Math.round( scrnH_mm * coefW / coefH / 25.4 * 10 ) / 10;
			scrnW_ft = Math.round( scrnH_mm * coefW / coefH / 25.4 / 12 * 100 ) / 100;
			dist1_mm = Math.round( scrnDiag_in * coefA + coefB );
			dist1_in = Math.round(( scrnDiag_in * coefA + coefB ) / 25.4 * 10 ) / 10;
			dist1_ft = Math.round(( scrnDiag_in * coefA + coefB ) / 25.4 / 12 * 100 ) / 100;
			dist2_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip );
			dist2_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip ) / 25.4 * 10 ) / 10;
			dist2_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip ) / 25.4 / 12 * 100 ) / 100;
			dist3_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip - pjFr );
			dist3_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjFr ) / 25.4 * 10 ) / 10;
			dist3_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjFr ) / 25.4 / 12 * 100 ) / 100;
			dist4_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip - pjRr );
			dist4_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjRr ) / 25.4 * 10 ) / 10;
			dist4_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjRr ) / 25.4 / 12 * 100 ) / 100;
			dist5_mm = Math.round( scrnH_mm * topAmin - topB );
			dist5_in = Math.round(( scrnH_mm * topAmin - topB ) / 25.4 * 10 ) / 10;
			dist5_ft = Math.round(( scrnH_mm * topAmin - topB ) / 25.4 / 12 * 100 ) / 100;
			dist6_mm = Math.round( scrnH_mm * topAmax - topB );
			dist6_in = Math.round(( scrnH_mm * topAmax - topB ) / 25.4 * 10 ) / 10;
			dist6_ft = Math.round(( scrnH_mm * topAmax - topB ) / 25.4 / 12 * 100 ) / 100;
			dist7_mm = Math.round( scrnH_mm * topAmin - topB + pjH );
			dist7_in = Math.round(( scrnH_mm * topAmin - topB + pjH ) / 25.4 * 10 ) / 10;
			dist7_ft = Math.round(( scrnH_mm * topAmin - topB + pjH ) / 25.4 / 12 * 100 ) / 100;
			dist8_mm = Math.round( scrnH_mm * topAmax - topB + pjH );
			dist8_in = Math.round(( scrnH_mm * topAmax - topB + pjH ) / 25.4 * 10 ) / 10;
			dist8_ft = Math.round(( scrnH_mm * topAmax - topB + pjH ) / 25.4 / 12 * 100 ) / 100;

		}

		else if ( userScrnPortion == 'width' ) {

			if ( userScrnUnit == 'in' ) {
			scrnW_mm = Math.round( scrnW_in * 25.4 );
//			scrnW_in = null;
			} else if ( userScrnUnit == 'mm' ) {
//			scrnW_mm = null;
			scrnW_in = Math.round( scrnW_mm / 25.4 * 10 ) / 10;
			}
			scrnDiag_mm = Math.round( scrnW_mm * coefD / coefW );
			scrnDiag_in = Math.round( scrnDiag_mm / 25.4 * 10 ) / 10;
			scrnDiag_ft = Math.round( scrnDiag_mm / 25.4 / 12 * 100 ) / 100;
			scrnH_mm = Math.round( scrnW_mm * coefH / coefW );
			scrnH_in = Math.round( scrnW_mm * coefH / coefW / 25.4 * 10 ) / 10;
			scrnH_ft = Math.round( scrnW_mm * coefH / coefW / 25.4 / 12 * 100 ) / 100;
			scrnW_ft = Math.round( scrnW_mm / 25.4 / 12 * 100 ) / 100;
			dist1_mm = Math.round( scrnDiag_in * coefA + coefB );
			dist1_in = Math.round(( scrnDiag_in * coefA + coefB ) / 25.4 * 10 ) / 10;
			dist1_ft = Math.round(( scrnDiag_in * coefA + coefB ) / 25.4 / 12 * 100 ) / 100;
			dist2_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip );
			dist2_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip ) / 25.4 * 10 ) / 10;
			dist2_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip ) / 25.4 / 12 * 100 ) / 100;
			dist3_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip - pjFr );
			dist3_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjFr ) / 25.4 * 10 ) / 10;
			dist3_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjFr ) / 25.4 / 12 * 100 ) / 100;
			dist4_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip - pjRr );
			dist4_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjRr ) / 25.4 * 10 ) / 10;
			dist4_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjRr ) / 25.4 / 12 * 100 ) / 100;
			dist5_mm = Math.round( scrnH_mm * topAmin - topB );
			dist5_in = Math.round(( scrnH_mm * topAmin - topB ) / 25.4 * 10 ) / 10;
			dist5_ft = Math.round(( scrnH_mm * topAmin - topB ) / 25.4 / 12 * 100 ) / 100;
			dist6_mm = Math.round( scrnH_mm * topAmax - topB );
			dist6_in = Math.round(( scrnH_mm * topAmax - topB ) / 25.4 * 10 ) / 10;
			dist6_ft = Math.round(( scrnH_mm * topAmax - topB ) / 25.4 / 12 * 100 ) / 100;
			dist7_mm = Math.round( scrnH_mm * topAmin - topB + pjH );
			dist7_in = Math.round(( scrnH_mm * topAmin - topB + pjH ) / 25.4 * 10 ) / 10;
			dist7_ft = Math.round(( scrnH_mm * topAmin - topB + pjH ) / 25.4 / 12 * 100 ) / 100;
			dist8_mm = Math.round( scrnH_mm * topAmax - topB + pjH );
			dist8_in = Math.round(( scrnH_mm * topAmax - topB + pjH ) / 25.4 * 10 ) / 10;
			dist8_ft = Math.round(( scrnH_mm * topAmax - topB + pjH ) / 25.4 / 12 * 100 ) / 100;

		}

		// placing values into input boxes

		document.getElementById('scrn-diag-mm').value = scrnDiag_mm;
		document.getElementById('scrn-diag-in').value = scrnDiag_in;
		document.getElementById('scrn-diag-ft').value = scrnDiag_ft;
		document.getElementById('scrn-h-mm').value = scrnH_mm;
		document.getElementById('scrn-h-in').value = scrnH_in;
		document.getElementById('scrn-h-ft').value = scrnH_ft;
		document.getElementById('scrn-w-mm').value = scrnW_mm;
		document.getElementById('scrn-w-in').value = scrnW_in;
		document.getElementById('scrn-w-ft').value = scrnW_ft;
		document.getElementById('dist1-mm').value = dist1_mm;
		document.getElementById('dist1-in').value = dist1_in;
		document.getElementById('dist1-ft').value = dist1_ft;

		// optical shift range calculation

		for ( var i = 0 ; i < aspectLength ; i++ ) {

			if ( document.forms['aspect-selector-button'].aspect[i].checked == true ) {

				var	aspectRatio = document.forms['aspect-selector-button'].elements['aspect'][i].value;

				if ( aspectRatio != 1610 ) {
					var	sftRangeV1 = '&emsp;&#42; Refer to the shift range of 16:10 aspect ratio.',
						sftRangeV2 = '',
						sftRangeH1 = '';
				} else {
					var	Vshift1_mm = Math.round(scrnH_mm * coefVsft1_1610),
						Vshift1_in = Math.round(scrnH_in * coefVsft1_1610 * 10 ) / 10,
						Vshift1_ft = Math.round(scrnH_ft * coefVsft1_1610 * 100 ) / 100,
						Vshift2_mm = Math.round(scrnH_mm * coefVsft2_1610),
						Vshift2_in = Math.round(scrnH_in * coefVsft2_1610 * 10 ) / 10,
						Vshift2_ft = Math.round(scrnH_ft * coefVsft2_1610 * 100 ) / 100,
						Hshift1_mm = Math.round(scrnW_mm * coefHsft1_1610),
						Hshift1_in = Math.round(scrnW_in * coefHsft1_1610 * 10 ) / 10,
						Hshift1_ft = Math.round(scrnW_ft * coefHsft1_1610 * 100 ) / 100,
					// toLocaleString()
						Vshift1_mm = Vshift1_mm.toLocaleString(),
						Vshift1_in = Vshift1_in.toLocaleString(),
						Vshift1_ft = Vshift1_ft.toLocaleString(),
						Vshift2_mm = Vshift2_mm.toLocaleString(),
						Vshift2_in = Vshift2_in.toLocaleString(),
						Vshift2_ft = Vshift2_ft.toLocaleString(),
						Hshift1_mm = Hshift1_mm.toLocaleString(),
						Hshift1_in = Hshift1_in.toLocaleString(),
						Hshift1_ft = Hshift1_ft.toLocaleString(),
					// shift range
						sftRangeV1 = 'VS1: '+Vshift1_mm+' mm / '+Vshift1_in+' in / '+Vshift1_ft+' ft\n',
						sftRangeV2 = 'VS2: '+Vshift2_mm+' mm / '+Vshift2_in+' in / '+Vshift2_ft+' ft\n',
						sftRangeH1 = 'HS1: '+Hshift1_mm+' mm / '+Hshift1_in+' in / '+Hshift1_ft+' ft';
				}

			}

		}

		// brightness

		var scrnIlluminance = Math.round( pjOutput / ( scrnH_mm * scrnW_mm / 1000 / 1000 ) );


		//// result strings //////////////

		// toLocaleString()

		var	scrnDiag_mm = parseFloat(scrnDiag_mm).toLocaleString(),
			scrnDiag_in = parseFloat(scrnDiag_in).toLocaleString(),
			scrnDiag_ft = parseFloat(scrnDiag_ft).toLocaleString(),
			scrnH_mm = parseFloat(scrnH_mm).toLocaleString(),
			scrnH_in = parseFloat(scrnH_in).toLocaleString(),
			scrnH_ft = parseFloat(scrnH_ft).toLocaleString(),
			scrnW_mm = parseFloat(scrnW_mm).toLocaleString(),
			scrnW_in = parseFloat(scrnW_in).toLocaleString(),
			scrnW_ft = parseFloat(scrnW_ft).toLocaleString(),
			dist1_mm = parseFloat(dist1_mm).toLocaleString(),
			dist1_in = parseFloat(dist1_in).toLocaleString(),
			dist1_ft = parseFloat(dist1_ft).toLocaleString(),
			dist2_mm = parseFloat(dist2_mm).toLocaleString(),
			dist2_in = parseFloat(dist2_in).toLocaleString(),
			dist2_ft = parseFloat(dist2_ft).toLocaleString(),
			dist3_mm = parseFloat(dist3_mm).toLocaleString(),
			dist3_in = parseFloat(dist3_in).toLocaleString(),
			dist3_ft = parseFloat(dist3_ft).toLocaleString(),
			dist4_mm = parseFloat(dist4_mm).toLocaleString(),
			dist4_in = parseFloat(dist4_in).toLocaleString(),
			dist4_ft = parseFloat(dist4_ft).toLocaleString(),
			dist5_mm = parseFloat(dist5_mm).toLocaleString(),
			dist5_in = parseFloat(dist5_in).toLocaleString(),
			dist5_ft = parseFloat(dist5_ft).toLocaleString(),
			dist6_mm = parseFloat(dist6_mm).toLocaleString(),
			dist6_in = parseFloat(dist6_in).toLocaleString(),
			dist6_ft = parseFloat(dist6_ft).toLocaleString(),
			dist7_mm = parseFloat(dist7_mm).toLocaleString(),
			dist7_in = parseFloat(dist7_in).toLocaleString(),
			dist7_ft = parseFloat(dist7_ft).toLocaleString(),
			dist8_mm = parseFloat(dist8_mm).toLocaleString(),
			dist8_in = parseFloat(dist8_in).toLocaleString(),
			dist8_ft = parseFloat(dist8_ft).toLocaleString(),
			pjOutput = parseFloat(pjOutput).toLocaleString(),
			scrnIlluminance = parseFloat(scrnIlluminance).toLocaleString();

		// specs

		var	specsModel = 'Projector: '+pjModel,
			specsLens = 'Lens: '+lensModel,
			specsPjSize = '[Projection size]',
			specsAspectRatio = 'Aspect ratio: '+specAspect,
			specsPjSize_diag = 'Diagonal: '+scrnDiag_mm+' mm / '+scrnDiag_in+' in / '+scrnDiag_ft+' ft',
			specsPjSize_h = 'Height: '+scrnH_mm+' mm / '+scrnH_in+' in / '+scrnH_ft+' ft',
			specsPjSize_w = 'Width: '+scrnW_mm+' mm / '+scrnW_in+' in / '+scrnW_ft+' ft',
			specsDim = '[Projection distance]',
			specsDistL1 = 'L1: '+dist1_mm+' mm / '+dist1_in+' in / '+dist1_ft+' ft',
			specsDistL2 = 'L2: '+dist2_mm+' mm / '+dist2_in+' in / '+dist2_ft+' ft',
			specsDistL3 = 'L3: '+dist3_mm+' mm / '+dist3_in+' in / '+dist3_ft+' ft',
			specsDistL4 = 'L4: '+dist4_mm+' mm / '+dist4_in+' in / '+dist4_ft+' ft',
			specsDistA1_mm = 'A1: '+dist5_mm+'&ndash;'+dist6_mm+' mm',
			specsDistA1_in = ' / '+dist5_in+'&ndash;'+dist6_in+' in',
			specsDistA1_ft = ' / '+dist5_ft+'&ndash;'+dist6_ft+' ft',
			specsDistA2_mm = 'A2: '+dist7_mm+'&ndash;'+dist8_mm+' mm',
			specsDistA2_in = ' / '+dist7_in+'&ndash;'+dist8_in+' in',
			specsDistA2_ft = ' / '+dist7_ft+'&ndash;'+dist8_ft+' ft';

		var	specs = specsModel+'\n'+specsLens+'\n'+specsPjSize+'\n'+specsAspectRatio+'\n'+specsPjSize_diag+'\n'+specsPjSize_h+'\n'+specsPjSize_w+'\n'+specsDim+'\n'+specsDistL1+'\n'+specsDistL2+'\n'+specsDistL3+'\n'+specsDistL4+'\n'+specsDistA1_mm+specsDistA1_in+specsDistA1_ft+'\n'+specsDistA2_mm+specsDistA2_in+specsDistA2_ft;

		// shift range

		var	shiftrange = '[Optical shift range]\n'+sftRangeV1+sftRangeV2+sftRangeH1;

		// brightness

		var	pjLumens = '[Brightness]\n'+'Projector output: '+pjOutput+' lm';
		var	scrnLux = 'Screen illuminance: '+scrnIlluminance+' lx';

		var	brightness = pjLumens+'\n'+scrnLux;

		// replace textarea

		var	tagTextareaStart = '<textarea id="result-list" rows=22>';
		var	tagTextareaEnd = '</textarea>';


		//// put results in textarea //////////////

		var	resultAll = tagTextareaStart+specs+'\n'+shiftrange+'\n'+brightness+tagTextareaEnd;

		var	resultInTextarea = document.getElementById('show-result');
		resultInTextarea.innerHTML = resultAll;


		//// write results for printing //////////////

		var	tableStart = '<table>',
			tableEnd = '</table>',
			trStart = '<tr>',
			trEnd = '</tr>',
			tdStart = '<td>',
			tdEnd = '</td>',
	
			// spec
			specsModelPrn = '<tr><td>Projector: </td><td>'+pjModel+'</td></tr>',
			specsLensPrn = '<tr><td>Lens: </td><td>'+lensModel+'</td></tr>',
			// shift range
			sftRange = '[Optical shift range]',
			// brightness
			pjBrightness = '[Brightness]';
			pjLumensPrn = 'Projector output: '+pjOutput+' lm';

		var	resultPrint = 
			tableStart + 
			specsModelPrn + specsLensPrn + 
			trStart + 
			tdStart + specsPjSize + tdEnd + 
			tdStart + specsAspectRatio + '<br>' + specsPjSize_diag + '<br>' + specsPjSize_h + '<br>' + specsPjSize_w + tdEnd + 
			trEnd + 
			trStart + 
			tdStart + specsDim + tdEnd + 
			tdStart + specsDistL1 + '<br>' + specsDistL2 + '<br>' + specsDistL3 + '<br>' + specsDistL4 + '<br>' + specsDistA1_mm + specsDistA1_in + specsDistA1_ft + '<br>' + specsDistA2_mm + specsDistA2_in + specsDistA2_ft + tdEnd + 
			trEnd + 
			trStart + 
			tdStart + sftRange + tdEnd + 
			tdStart + sftRangeV1 + '<br>' + sftRangeV2 + '<br>' + sftRangeH1 + tdEnd + 
			trEnd + 
			trStart + 
			tdStart + pjBrightness + tdEnd + 
			tdEnd + tdStart + pjLumensPrn + '<br>' + scrnLux + tdEnd + 
			trEnd + 
			tableEnd;

			resultForPrint = document.getElementById('results-for-print');
			resultForPrint.innerHTML = resultPrint;


	}



}



/* =================================
	THROW DISTANCE CALCULATION
================================= */


/* ===

L1: Projection distance (from screen to mirror reflective surface)	- dist1_mm / dist1_in / dist1_ft
L2: From screen to tip of lens	- dist2_mm / dist2_in / dist2_ft
L3: From screen to front of set	- dist3_mm / dist3_in / dist3_ft
L4: From screen to rear of set - dist4_mm / dist4_in / dist4_ft
A1: From bottom edge of screen to top of set - min: dist5_mm (_in/_ft); max: dist6_mm (_in/_ft)
A2: From bottom edge of screen to bottom of set - min: dist7_mm (_in/_ft); max: dist8_mm (_in/_ft)

=== */


function calcThrowDistance(form, currentField) {

	// definition for calculating values

	// screen size
	var	scrnDiag_mm = document.getElementById('scrn-diag-mm').value,
		scrnDiag_in = document.getElementById('scrn-diag-in').value,
		scrnDiag_ft = document.getElementById('scrn-diag-ft').value,
		scrnH_mm = document.getElementById('scrn-h-mm').value,
		scrnH_in = document.getElementById('scrn-h-in').value,
		scrnH_ft = document.getElementById('scrn-h-ft').value,
		scrnW_mm = document.getElementById('scrn-w-mm').value,
		scrnW_in = document.getElementById('scrn-w-in').value,
		scrnW_ft = document.getElementById('scrn-w-ft').value,
		// throw distance
		dist1_mm = document.getElementById('dist1-mm').value,	// L1
		dist1_in = document.getElementById('dist1-in').value,
		dist1_ft = document.getElementById('dist1-ft').value,
		dist2_mm,	// L2
		dist2_in,
		dist2_ft,
		dist3_mm,	// L3
		dist3_in,
		dist3_ft,
		dist4_mm,	// L4
		dist4_in,
		dist4_ft,
		dist5_mm,	// A1 min
		dist5_in,
		dist5_ft,
		dist6_mm,	// A1 max
		dist6_in,
		dist6_ft,
		dist7_mm,	// A2 min
		dist7_in,
		dist7_ft,
		dist8_mm,	// A2 max
		dist8_in,
		dist8_ft,
		dist9_mm,	// VS1
		dist9_in,
		dist9_ft,
		dist10_mm,	// HS1
		dist10_in,
		dist10_ft,

		// coefficient
		aspectLength = document.forms['aspect-selector-button'].aspect.length,
		coefD = 18.868,
		coefH = 10,
		coefW = 16;

	// coefficient for aspects

	for ( var i = 0 ; i < aspectLength ; i++ ) {

		if ( document.forms['aspect-selector-button'].aspect[i].checked == true ) {

			var	aspectRatio = document.forms['aspect-selector-button'].elements['aspect'][i].value;
		
			var	coefB = coefBcommon,	// coefB
				lensTip = coefLensTip,	// unitL
				pjFr = coefPjFront,	// unitL
				pjRr = coefPjRear,	// unitL
				topB = coefPjTopB, // htB
				pjH = coefPjHeight; // unitH

			if ( aspectRatio == 1610 ) {
				var	coefD = 18.868,
					coefH = 10,
					coefW = 16,
					specAspect = '16:10',
					pjOutput = lumensNative,
					coefA = coefA_1610,	// dstA
					topAmin = coefPjTopAmin_1610, // htA
					topAmax = coefPjTopAmax_1610; // htA
			}
			else if ( aspectRatio == 169 ) {
				var	coefD = 18.358,
					coefH = 9,
					coefW = 16,
					specAspect = '16:9',
					pjOutput = lumens169,
					coefA = coefA_169,
					topAmin = coefPjTopAmin_169,
					topAmax = coefPjTopAmax_169;
			}
			else if ( aspectRatio == 43 ) {
					coefD = 5,
					coefH = 3,
					coefW = 4,
					specAspect = '4:3',
					pjOutput = lumens43,
					coefA = coefA_43,
					topAmin = coefPjTopAmin_43,
					topAmax = coefPjTopAmax_43;
			}
			else {
				var	coefD = 0;
				var	coefH = 0;
				var	coefW = 0;
			}
		}

	}

	// scrn-diag-in

	if ( currentField == 'scrn-diag-in' ) {

		scrnDiag_mm = Math.round( scrnDiag_in * 25.4 );
//		scrnDiag_in = null;
		scrnDiag_ft = Math.round( scrnDiag_in / 12 * 100 ) / 100;
		scrnH_mm = Math.round( scrnDiag_in * coefH / coefD * 25.4 );
		scrnH_in = Math.round( scrnDiag_in * coefH / coefD * 10 ) / 10;
		scrnH_ft = Math.round( scrnDiag_in * coefH / coefD / 12 * 100 ) / 100;
		scrnW_mm = Math.round( scrnDiag_in * coefW / coefD * 25.4 );
		scrnW_in = Math.round( scrnDiag_in * coefW / coefD * 10 ) / 10;
		scrnW_ft = Math.round( scrnDiag_in * coefW / coefD / 12 * 100 ) / 100;
		dist1_mm = Math.round( scrnDiag_in * coefA + coefB );
		dist1_in = Math.round(( scrnDiag_in * coefA + coefB ) / 25.4 * 10 ) / 10;
		dist1_ft = Math.round(( scrnDiag_in * coefA + coefB ) / 25.4 / 12 * 100 ) / 100;
		dist2_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip );
		dist2_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip ) / 25.4 * 10 ) / 10;
		dist2_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip ) / 25.4 / 12 * 100 ) / 100;
		dist3_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip - pjFr );
		dist3_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjFr ) / 25.4 * 10 ) / 10;
		dist3_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjFr ) / 25.4 / 12 * 100 ) / 100;
		dist4_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip - pjRr );
		dist4_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjRr ) / 25.4 * 10 ) / 10;
		dist4_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjRr ) / 25.4 / 12 * 100 ) / 100;
		dist5_mm = Math.round( scrnH_mm * topAmin - topB );
		dist5_in = Math.round(( scrnH_mm * topAmin - topB ) / 25.4 * 10 ) / 10;
		dist5_ft = Math.round(( scrnH_mm * topAmin - topB ) / 25.4 / 12 * 100 ) / 100;
		dist6_mm = Math.round( scrnH_mm * topAmax - topB );
		dist6_in = Math.round(( scrnH_mm * topAmax - topB ) / 25.4 * 10 ) / 10;
		dist6_ft = Math.round(( scrnH_mm * topAmax - topB ) / 25.4 / 12 * 100 ) / 100;
		dist7_mm = Math.round( scrnH_mm * topAmin - topB + pjH );
		dist7_in = Math.round(( scrnH_mm * topAmin - topB + pjH ) / 25.4 * 10 ) / 10;
		dist7_ft = Math.round(( scrnH_mm * topAmin - topB + pjH ) / 25.4 / 12 * 100 ) / 100;
		dist8_mm = Math.round( scrnH_mm * topAmax - topB + pjH );
		dist8_in = Math.round(( scrnH_mm * topAmax - topB + pjH ) / 25.4 * 10 ) / 10;
		dist8_ft = Math.round(( scrnH_mm * topAmax - topB + pjH ) / 25.4 / 12 * 100 ) / 100;

	}

	// scrn-diag-mm

	else if ( currentField == 'scrn-diag-mm' ) {

//		scrnDiag_mm = null;
		scrnDiag_in = Math.round( scrnDiag_mm / 25.4 * 10 ) / 10;
		scrnDiag_ft = Math.round( scrnDiag_mm / 25.4 / 12 * 100 ) / 100;
		scrnH_mm = Math.round( scrnDiag_mm * coefH / coefD );
		scrnH_in = Math.round( scrnDiag_mm * coefH / coefD / 25.4 * 10 ) / 10;
		scrnH_ft = Math.round( scrnDiag_mm * coefH / coefD / 25.4 / 12 * 100 ) / 100;
		scrnW_mm = Math.round( scrnDiag_mm * coefW / coefD );
		scrnW_in = Math.round( scrnDiag_mm * coefW / coefD / 25.4 * 10 ) / 10;
		scrnW_ft = Math.round( scrnDiag_mm * coefW / coefD / 25.4 / 12 * 100 ) / 100;
		dist1_mm = Math.round( scrnDiag_in * coefA + coefB );
		dist1_in = Math.round(( scrnDiag_in * coefA + coefB ) / 25.4 * 10 ) / 10;
		dist1_ft = Math.round(( scrnDiag_in * coefA + coefB ) / 25.4 / 12 * 100 ) / 100;
		dist2_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip );
		dist2_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip ) / 25.4 * 10 ) / 10;
		dist2_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip ) / 25.4 / 12 * 100 ) / 100;
		dist3_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip - pjFr );
		dist3_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjFr ) / 25.4 * 10 ) / 10;
		dist3_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjFr ) / 25.4 / 12 * 100 ) / 100;
		dist4_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip - pjRr );
		dist4_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjRr ) / 25.4 * 10 ) / 10;
		dist4_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjRr ) / 25.4 / 12 * 100 ) / 100;
		dist5_mm = Math.round( scrnH_mm * topAmin - topB );
		dist5_in = Math.round(( scrnH_mm * topAmin - topB ) / 25.4 * 10 ) / 10;
		dist5_ft = Math.round(( scrnH_mm * topAmin - topB ) / 25.4 / 12 * 100 ) / 100;
		dist6_mm = Math.round( scrnH_mm * topAmax - topB );
		dist6_in = Math.round(( scrnH_mm * topAmax - topB ) / 25.4 * 10 ) / 10;
		dist6_ft = Math.round(( scrnH_mm * topAmax - topB ) / 25.4 / 12 * 100 ) / 100;
		dist7_mm = Math.round( scrnH_mm * topAmin - topB + pjH );
		dist7_in = Math.round(( scrnH_mm * topAmin - topB + pjH ) / 25.4 * 10 ) / 10;
		dist7_ft = Math.round(( scrnH_mm * topAmin - topB + pjH ) / 25.4 / 12 * 100 ) / 100;
		dist8_mm = Math.round( scrnH_mm * topAmax - topB + pjH );
		dist8_in = Math.round(( scrnH_mm * topAmax - topB + pjH ) / 25.4 * 10 ) / 10;
		dist8_ft = Math.round(( scrnH_mm * topAmax - topB + pjH ) / 25.4 / 12 * 100 ) / 100;

	}

	// scrn-diag-ft

	else if ( currentField == 'scrn-diag-ft' ) {

		scrnDiag_mm = Math.round(scrnDiag_ft * 12 * 25.4 );
		scrnDiag_in = Math.round(scrnDiag_ft * 12 * 10 ) / 10;
//		scrnDiag_ft = null;
		scrnH_mm = Math.round( scrnDiag_in * coefH / coefD * 25.4 );
		scrnH_in = Math.round( scrnDiag_in * coefH / coefD * 10 ) / 10;
		scrnH_ft = Math.round( scrnDiag_in * coefH / coefD / 12 * 100 ) / 100;
		scrnW_mm = Math.round( scrnDiag_in * coefW / coefD * 25.4 );
		scrnW_in = Math.round( scrnDiag_in * coefW / coefD * 10 ) / 10;
		scrnW_ft = Math.round( scrnDiag_in * coefW / coefD / 12 * 100 ) / 100;
		dist1_mm = Math.round( scrnDiag_in * coefA + coefB );
		dist1_in = Math.round(( scrnDiag_in * coefA + coefB ) / 25.4 * 10 ) / 10;
		dist1_ft = Math.round(( scrnDiag_in * coefA + coefB ) / 25.4 / 12 * 100 ) / 100;
		dist2_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip );
		dist2_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip ) / 25.4 * 10 ) / 10;
		dist2_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip ) / 25.4 / 12 * 100 ) / 100;
		dist3_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip - pjFr );
		dist3_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjFr ) / 25.4 * 10 ) / 10;
		dist3_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjFr ) / 25.4 / 12 * 100 ) / 100;
		dist4_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip - pjRr );
		dist4_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjRr ) / 25.4 * 10 ) / 10;
		dist4_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjRr ) / 25.4 / 12 * 100 ) / 100;
		dist5_mm = Math.round( scrnH_mm * topAmin - topB );
		dist5_in = Math.round(( scrnH_mm * topAmin - topB ) / 25.4 * 10 ) / 10;
		dist5_ft = Math.round(( scrnH_mm * topAmin - topB ) / 25.4 / 12 * 100 ) / 100;
		dist6_mm = Math.round( scrnH_mm * topAmax - topB );
		dist6_in = Math.round(( scrnH_mm * topAmax - topB ) / 25.4 * 10 ) / 10;
		dist6_ft = Math.round(( scrnH_mm * topAmax - topB ) / 25.4 / 12 * 100 ) / 100;
		dist7_mm = Math.round( scrnH_mm * topAmin - topB + pjH );
		dist7_in = Math.round(( scrnH_mm * topAmin - topB + pjH ) / 25.4 * 10 ) / 10;
		dist7_ft = Math.round(( scrnH_mm * topAmin - topB + pjH ) / 25.4 / 12 * 100 ) / 100;
		dist8_mm = Math.round( scrnH_mm * topAmax - topB + pjH );
		dist8_in = Math.round(( scrnH_mm * topAmax - topB + pjH ) / 25.4 * 10 ) / 10;
		dist8_ft = Math.round(( scrnH_mm * topAmax - topB + pjH ) / 25.4 / 12 * 100 ) / 100;

	}

	// scrn-h-mm

	else if ( currentField == 'scrn-h-mm' ) {

		scrnDiag_mm = Math.round( scrnH_mm * coefD / coefH );
		scrnDiag_in = Math.round( scrnDiag_mm / 25.4 * 10 ) / 10;
		scrnDiag_ft = Math.round( scrnDiag_mm / 25.4 / 12 * 100 ) / 100;
//		scrnH_mm = null;
		scrnH_in = Math.round( scrnH_mm / 25.4 * 10 ) / 10;
		scrnH_ft = Math.round( scrnH_mm / 25.4 / 12 * 100 ) / 100;
		scrnW_mm = Math.round( scrnH_mm * coefW / coefH );
		scrnW_in = Math.round( scrnH_mm * coefW / coefH / 25.4 * 10 ) / 10;
		scrnW_ft = Math.round( scrnH_mm * coefW / coefH / 25.4 / 12 * 100 ) / 100;
		dist1_mm = Math.round( scrnDiag_in * coefA + coefB );
		dist1_in = Math.round(( scrnDiag_in * coefA + coefB ) / 25.4 * 10 ) / 10;
		dist1_ft = Math.round(( scrnDiag_in * coefA + coefB ) / 25.4 / 12 * 100 ) / 100;
		dist2_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip );
		dist2_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip ) / 25.4 * 10 ) / 10;
		dist2_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip ) / 25.4 / 12 * 100 ) / 100;
		dist3_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip - pjFr );
		dist3_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjFr ) / 25.4 * 10 ) / 10;
		dist3_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjFr ) / 25.4 / 12 * 100 ) / 100;
		dist4_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip - pjRr );
		dist4_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjRr ) / 25.4 * 10 ) / 10;
		dist4_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjRr ) / 25.4 / 12 * 100 ) / 100;
		dist5_mm = Math.round( scrnH_mm * topAmin - topB );
		dist5_in = Math.round(( scrnH_mm * topAmin - topB ) / 25.4 * 10 ) / 10;
		dist5_ft = Math.round(( scrnH_mm * topAmin - topB ) / 25.4 / 12 * 100 ) / 100;
		dist6_mm = Math.round( scrnH_mm * topAmax - topB );
		dist6_in = Math.round(( scrnH_mm * topAmax - topB ) / 25.4 * 10 ) / 10;
		dist6_ft = Math.round(( scrnH_mm * topAmax - topB ) / 25.4 / 12 * 100 ) / 100;
		dist7_mm = Math.round( scrnH_mm * topAmin - topB + pjH );
		dist7_in = Math.round(( scrnH_mm * topAmin - topB + pjH ) / 25.4 * 10 ) / 10;
		dist7_ft = Math.round(( scrnH_mm * topAmin - topB + pjH ) / 25.4 / 12 * 100 ) / 100;
		dist8_mm = Math.round( scrnH_mm * topAmax - topB + pjH );
		dist8_in = Math.round(( scrnH_mm * topAmax - topB + pjH ) / 25.4 * 10 ) / 10;
		dist8_ft = Math.round(( scrnH_mm * topAmax - topB + pjH ) / 25.4 / 12 * 100 ) / 100;

	}

	// scrn-h-in

	else if ( currentField == 'scrn-h-in' ) {

		scrnDiag_mm = Math.round( scrnH_in * coefD / coefH * 25.4 );
		scrnDiag_in = Math.round( scrnH_in * 10 * coefD / coefH ) / 10;
		scrnDiag_ft = Math.round( scrnDiag_mm / 25.4 / 12 * 100 ) / 100;
		scrnH_mm = Math.round( scrnH_in * 25.4 );
//		scrnH_in = null;
		scrnH_ft = Math.round( scrnH_in / 12 * 100 ) / 100;
		scrnW_mm = Math.round( scrnH_in * coefW / coefH * 25.4 );
		scrnW_in = Math.round( scrnH_in * coefW / coefH * 10 ) / 10;
		scrnW_ft = Math.round( scrnH_in * coefW / coefH / 12 * 100 ) / 100;
		dist1_mm = Math.round( scrnDiag_in * coefA + coefB );
		dist1_in = Math.round(( scrnDiag_in * coefA + coefB ) / 25.4 * 10 ) / 10;
		dist1_ft = Math.round(( scrnDiag_in * coefA + coefB ) / 25.4 / 12 * 100 ) / 100;
		dist2_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip );
		dist2_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip ) / 25.4 * 10 ) / 10;
		dist2_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip ) / 25.4 / 12 * 100 ) / 100;
		dist3_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip - pjFr );
		dist3_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjFr ) / 25.4 * 10 ) / 10;
		dist3_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjFr ) / 25.4 / 12 * 100 ) / 100;
		dist4_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip - pjRr );
		dist4_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjRr ) / 25.4 * 10 ) / 10;
		dist4_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjRr ) / 25.4 / 12 * 100 ) / 100;
		dist5_mm = Math.round( scrnH_mm * topAmin - topB );
		dist5_in = Math.round(( scrnH_mm * topAmin - topB ) / 25.4 * 10 ) / 10;
		dist5_ft = Math.round(( scrnH_mm * topAmin - topB ) / 25.4 / 12 * 100 ) / 100;
		dist6_mm = Math.round( scrnH_mm * topAmax - topB );
		dist6_in = Math.round(( scrnH_mm * topAmax - topB ) / 25.4 * 10 ) / 10;
		dist6_ft = Math.round(( scrnH_mm * topAmax - topB ) / 25.4 / 12 * 100 ) / 100;
		dist7_mm = Math.round( scrnH_mm * topAmin - topB + pjH );
		dist7_in = Math.round(( scrnH_mm * topAmin - topB + pjH ) / 25.4 * 10 ) / 10;
		dist7_ft = Math.round(( scrnH_mm * topAmin - topB + pjH ) / 25.4 / 12 * 100 ) / 100;
		dist8_mm = Math.round( scrnH_mm * topAmax - topB + pjH );
		dist8_in = Math.round(( scrnH_mm * topAmax - topB + pjH ) / 25.4 * 10 ) / 10;
		dist8_ft = Math.round(( scrnH_mm * topAmax - topB + pjH ) / 25.4 / 12 * 100 ) / 100;

	}

	// scrn-h-ft

	else if ( currentField == 'scrn-h-ft' ) {

		scrnDiag_mm = Math.round( scrnH_ft * coefD / coefH * 25.4 * 12 );
		scrnDiag_in = Math.round( scrnDiag_mm / 25.4 * 10 ) / 10;
		scrnDiag_ft = Math.round( scrnDiag_mm / 25.4 / 12 * 100 ) / 100;
		scrnH_mm = Math.round( scrnH_ft * 12 * 25.4 );
		scrnH_in = Math.round( scrnH_ft * 12 * 10 ) / 10;
//		scrnH_ft = null;
		scrnW_mm = Math.round( scrnH_ft * coefW / coefH * 12 * 25.4 );
		scrnW_in = Math.round( scrnH_ft * coefW / coefH * 12 * 10 ) / 10;
		scrnW_ft = Math.round( scrnH_ft * coefW / coefH * 100 ) / 100;
		dist1_mm = Math.round( scrnDiag_in * coefA + coefB );
		dist1_in = Math.round(( scrnDiag_in * coefA + coefB ) / 25.4 * 10 ) / 10;
		dist1_ft = Math.round(( scrnDiag_in * coefA + coefB ) / 25.4 / 12 * 100 ) / 100;
		dist2_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip );
		dist2_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip ) / 25.4 * 10 ) / 10;
		dist2_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip ) / 25.4 / 12 * 100 ) / 100;
		dist3_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip - pjFr );
		dist3_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjFr ) / 25.4 * 10 ) / 10;
		dist3_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjFr ) / 25.4 / 12 * 100 ) / 100;
		dist4_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip - pjRr );
		dist4_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjRr ) / 25.4 * 10 ) / 10;
		dist4_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjRr ) / 25.4 / 12 * 100 ) / 100;
		dist5_mm = Math.round( scrnH_mm * topAmin - topB );
		dist5_in = Math.round(( scrnH_mm * topAmin - topB ) / 25.4 * 10 ) / 10;
		dist5_ft = Math.round(( scrnH_mm * topAmin - topB ) / 25.4 / 12 * 100 ) / 100;
		dist6_mm = Math.round( scrnH_mm * topAmax - topB );
		dist6_in = Math.round(( scrnH_mm * topAmax - topB ) / 25.4 * 10 ) / 10;
		dist6_ft = Math.round(( scrnH_mm * topAmax - topB ) / 25.4 / 12 * 100 ) / 100;
		dist7_mm = Math.round( scrnH_mm * topAmin - topB + pjH );
		dist7_in = Math.round(( scrnH_mm * topAmin - topB + pjH ) / 25.4 * 10 ) / 10;
		dist7_ft = Math.round(( scrnH_mm * topAmin - topB + pjH ) / 25.4 / 12 * 100 ) / 100;
		dist8_mm = Math.round( scrnH_mm * topAmax - topB + pjH );
		dist8_in = Math.round(( scrnH_mm * topAmax - topB + pjH ) / 25.4 * 10 ) / 10;
		dist8_ft = Math.round(( scrnH_mm * topAmax - topB + pjH ) / 25.4 / 12 * 100 ) / 100;

	}

	// scrn-w-mm

	else if ( currentField == 'scrn-w-mm' ) {

		scrnDiag_mm = Math.round( scrnW_mm * coefD / coefW );
		scrnDiag_in = Math.round( scrnDiag_mm / 25.4 * 10 ) / 10;
		scrnDiag_ft = Math.round( scrnDiag_mm / 25.4 / 12 * 100 ) / 100;
		scrnH_mm = Math.round( scrnW_mm * coefH / coefW );
		scrnH_in = Math.round( scrnW_mm * coefH / coefW / 25.4 * 10 ) / 10;
		scrnH_ft = Math.round( scrnW_mm * coefH / coefW / 25.4 / 12 * 100 ) / 100;
//		scrnW_mm = null;
		scrnW_in = Math.round( scrnW_mm / 25.4 * 10 ) / 10;
		scrnW_ft = Math.round( scrnW_mm / 25.4 / 12 * 100 ) / 100;
		dist1_mm = Math.round( scrnDiag_in * coefA + coefB );
		dist1_in = Math.round(( scrnDiag_in * coefA + coefB ) / 25.4 * 10 ) / 10;
		dist1_ft = Math.round(( scrnDiag_in * coefA + coefB ) / 25.4 / 12 * 100 ) / 100;
		dist2_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip );
		dist2_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip ) / 25.4 * 10 ) / 10;
		dist2_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip ) / 25.4 / 12 * 100 ) / 100;
		dist3_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip - pjFr );
		dist3_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjFr ) / 25.4 * 10 ) / 10;
		dist3_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjFr ) / 25.4 / 12 * 100 ) / 100;
		dist4_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip - pjRr );
		dist4_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjRr ) / 25.4 * 10 ) / 10;
		dist4_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjRr ) / 25.4 / 12 * 100 ) / 100;
		dist5_mm = Math.round( scrnH_mm * topAmin - topB );
		dist5_in = Math.round(( scrnH_mm * topAmin - topB ) / 25.4 * 10 ) / 10;
		dist5_ft = Math.round(( scrnH_mm * topAmin - topB ) / 25.4 / 12 * 100 ) / 100;
		dist6_mm = Math.round( scrnH_mm * topAmax - topB );
		dist6_in = Math.round(( scrnH_mm * topAmax - topB ) / 25.4 * 10 ) / 10;
		dist6_ft = Math.round(( scrnH_mm * topAmax - topB ) / 25.4 / 12 * 100 ) / 100;
		dist7_mm = Math.round( scrnH_mm * topAmin - topB + pjH );
		dist7_in = Math.round(( scrnH_mm * topAmin - topB + pjH ) / 25.4 * 10 ) / 10;
		dist7_ft = Math.round(( scrnH_mm * topAmin - topB + pjH ) / 25.4 / 12 * 100 ) / 100;
		dist8_mm = Math.round( scrnH_mm * topAmax - topB + pjH );
		dist8_in = Math.round(( scrnH_mm * topAmax - topB + pjH ) / 25.4 * 10 ) / 10;
		dist8_ft = Math.round(( scrnH_mm * topAmax - topB + pjH ) / 25.4 / 12 * 100 ) / 100;

	}

	// scrn-w-in

	else if ( currentField == 'scrn-w-in' ) {

		scrnDiag_mm = Math.round( scrnW_in * coefD / coefW * 25.4 );
		scrnDiag_in = Math.round( scrnDiag_mm / 25.4 * 10 ) / 10;
		scrnDiag_ft = Math.round( scrnDiag_mm / 25.4 / 12 * 100 ) / 100;
		scrnH_mm = Math.round( scrnW_in * coefH / coefW * 25.4 );
		scrnH_in = Math.round( scrnW_in * coefH / coefW * 10 ) / 10;
		scrnH_ft = Math.round( scrnW_in * coefH / coefW / 12 * 100 ) / 100;
		scrnW_mm = Math.round( scrnW_in * 25.4 );
//		scrnW_in = null;
		scrnW_ft = Math.round( scrnW_in / 12 * 100 ) / 100;
		dist1_mm = Math.round( scrnDiag_in * coefA + coefB );
		dist1_in = Math.round(( scrnDiag_in * coefA + coefB ) / 25.4 * 10 ) / 10;
		dist1_ft = Math.round(( scrnDiag_in * coefA + coefB ) / 25.4 / 12 * 100 ) / 100;
		dist2_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip );
		dist2_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip ) / 25.4 * 10 ) / 10;
		dist2_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip ) / 25.4 / 12 * 100 ) / 100;
		dist3_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip - pjFr );
		dist3_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjFr ) / 25.4 * 10 ) / 10;
		dist3_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjFr ) / 25.4 / 12 * 100 ) / 100;
		dist4_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip - pjRr );
		dist4_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjRr ) / 25.4 * 10 ) / 10;
		dist4_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjRr ) / 25.4 / 12 * 100 ) / 100;
		dist5_mm = Math.round( scrnH_mm * topAmin - topB );
		dist5_in = Math.round(( scrnH_mm * topAmin - topB ) / 25.4 * 10 ) / 10;
		dist5_ft = Math.round(( scrnH_mm * topAmin - topB ) / 25.4 / 12 * 100 ) / 100;
		dist6_mm = Math.round( scrnH_mm * topAmax - topB );
		dist6_in = Math.round(( scrnH_mm * topAmax - topB ) / 25.4 * 10 ) / 10;
		dist6_ft = Math.round(( scrnH_mm * topAmax - topB ) / 25.4 / 12 * 100 ) / 100;
		dist7_mm = Math.round( scrnH_mm * topAmin - topB + pjH );
		dist7_in = Math.round(( scrnH_mm * topAmin - topB + pjH ) / 25.4 * 10 ) / 10;
		dist7_ft = Math.round(( scrnH_mm * topAmin - topB + pjH ) / 25.4 / 12 * 100 ) / 100;
		dist8_mm = Math.round( scrnH_mm * topAmax - topB + pjH );
		dist8_in = Math.round(( scrnH_mm * topAmax - topB + pjH ) / 25.4 * 10 ) / 10;
		dist8_ft = Math.round(( scrnH_mm * topAmax - topB + pjH ) / 25.4 / 12 * 100 ) / 100;

	}

	// scrn-w-ft

	else if ( currentField == 'scrn-w-ft' ) {

		scrnDiag_mm = Math.round( scrnW_ft * coefD / coefW * 25.4 * 12 );
		scrnDiag_in = Math.round( scrnDiag_mm / 25.4 * 10 ) / 10;
		scrnDiag_ft = Math.round( scrnDiag_mm / 25.4 / 12 * 100 ) / 100;
		scrnH_mm = Math.round( scrnW_ft * coefH / coefW * 12 * 25.4 );
		scrnH_in = Math.round( scrnW_ft * coefH / coefW * 12 * 10 ) / 10;
		scrnH_ft = Math.round( scrnW_ft * coefH / coefW * 100 ) / 100;
		scrnW_mm = Math.round( scrnW_ft * 12 * 25.4 );
		scrnW_in = Math.round( scrnW_ft * 12 * 10 ) / 10;
//		scrnW_ft = null;
		dist1_mm = Math.round( scrnDiag_in * coefA + coefB );
		dist1_in = Math.round(( scrnDiag_in * coefA + coefB ) / 25.4 * 10 ) / 10;
		dist1_ft = Math.round(( scrnDiag_in * coefA + coefB ) / 25.4 / 12 * 100 ) / 100;
		dist2_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip );
		dist2_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip ) / 25.4 * 10 ) / 10;
		dist2_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip ) / 25.4 / 12 * 100 ) / 100;
		dist3_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip - pjFr );
		dist3_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjFr ) / 25.4 * 10 ) / 10;
		dist3_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjFr ) / 25.4 / 12 * 100 ) / 100;
		dist4_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip - pjRr );
		dist4_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjRr ) / 25.4 * 10 ) / 10;
		dist4_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjRr ) / 25.4 / 12 * 100 ) / 100;
		dist5_mm = Math.round( scrnH_mm * topAmin - topB );
		dist5_in = Math.round(( scrnH_mm * topAmin - topB ) / 25.4 * 10 ) / 10;
		dist5_ft = Math.round(( scrnH_mm * topAmin - topB ) / 25.4 / 12 * 100 ) / 100;
		dist6_mm = Math.round( scrnH_mm * topAmax - topB );
		dist6_in = Math.round(( scrnH_mm * topAmax - topB ) / 25.4 * 10 ) / 10;
		dist6_ft = Math.round(( scrnH_mm * topAmax - topB ) / 25.4 / 12 * 100 ) / 100;
		dist7_mm = Math.round( scrnH_mm * topAmin - topB + pjH );
		dist7_in = Math.round(( scrnH_mm * topAmin - topB + pjH ) / 25.4 * 10 ) / 10;
		dist7_ft = Math.round(( scrnH_mm * topAmin - topB + pjH ) / 25.4 / 12 * 100 ) / 100;
		dist8_mm = Math.round( scrnH_mm * topAmax - topB + pjH );
		dist8_in = Math.round(( scrnH_mm * topAmax - topB + pjH ) / 25.4 * 10 ) / 10;
		dist8_ft = Math.round(( scrnH_mm * topAmax - topB + pjH ) / 25.4 / 12 * 100 ) / 100;

	}

	// dist1-mm

	else if ( currentField == 'dist1-mm' ) {

		scrnDiag_mm = Math.round(( eval( dist1_mm ) - coefB ) / coefA * 25.4 );
		scrnDiag_in = Math.round(( eval( dist1_mm ) - coefB ) / coefA * 10 ) / 10;
		scrnDiag_ft = Math.round(( eval( dist1_mm ) - coefB ) / coefA / 12 * 100 ) / 100;
		scrnH_mm = Math.round( scrnDiag_mm * coefH / coefD );
		scrnH_in = Math.round( scrnDiag_mm * coefH / coefD / 25.4 * 10 ) / 10;
		scrnH_ft = Math.round( scrnDiag_mm * coefH / coefD / 25.4 / 12 * 100 ) / 100;
		scrnW_mm = Math.round( scrnDiag_mm * coefW / coefD );
		scrnW_in = Math.round( scrnDiag_mm * coefW / coefD / 25.4 * 10 ) / 10;
		scrnW_ft = Math.round( scrnDiag_mm * coefW / coefD / 25.4 / 12 * 100 ) / 100;
//		dist1_mm = null;
		dist1_in = Math.round( dist1_mm / 25.4 * 10 ) / 10;
		dist1_ft = Math.round( dist1_mm / 25.4 / 12 * 100 ) / 100;
		dist2_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip );
		dist2_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip ) / 25.4 * 10 ) / 10;
		dist2_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip ) / 25.4 / 12 * 100 ) / 100;
		dist3_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip - pjFr );
		dist3_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjFr ) / 25.4 * 10 ) / 10;
		dist3_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjFr ) / 25.4 / 12 * 100 ) / 100;
		dist4_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip - pjRr );
		dist4_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjRr ) / 25.4 * 10 ) / 10;
		dist4_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjRr ) / 25.4 / 12 * 100 ) / 100;
		dist5_mm = Math.round( scrnH_mm * topAmin - topB );
		dist5_in = Math.round(( scrnH_mm * topAmin - topB ) / 25.4 * 10 ) / 10;
		dist5_ft = Math.round(( scrnH_mm * topAmin - topB ) / 25.4 / 12 * 100 ) / 100;
		dist6_mm = Math.round( scrnH_mm * topAmax - topB );
		dist6_in = Math.round(( scrnH_mm * topAmax - topB ) / 25.4 * 10 ) / 10;
		dist6_ft = Math.round(( scrnH_mm * topAmax - topB ) / 25.4 / 12 * 100 ) / 100;
		dist7_mm = Math.round( scrnH_mm * topAmin - topB + pjH );
		dist7_in = Math.round(( scrnH_mm * topAmin - topB + pjH ) / 25.4 * 10 ) / 10;
		dist7_ft = Math.round(( scrnH_mm * topAmin - topB + pjH ) / 25.4 / 12 * 100 ) / 100;
		dist8_mm = Math.round( scrnH_mm * topAmax - topB + pjH );
		dist8_in = Math.round(( scrnH_mm * topAmax - topB + pjH ) / 25.4 * 10 ) / 10;
		dist8_ft = Math.round(( scrnH_mm * topAmax - topB + pjH ) / 25.4 / 12 * 100 ) / 100;

	}

	// dist1-in

	else if ( currentField == 'dist1-in' ) {

		scrnDiag_mm = Math.round(( dist1_in * 25.4 - coefB ) / coefA * 25.4 );
		scrnDiag_in = Math.round(( dist1_in * 25.4 - coefB ) / coefA * 10 ) / 10;
		scrnDiag_ft = Math.round(( dist1_in * 25.4 - coefB ) / coefA / 12 * 100 ) / 100;
		scrnH_mm = Math.round( scrnDiag_mm * coefH / coefD );
		scrnH_in = Math.round( scrnDiag_mm * coefH / coefD / 25.4 * 10 ) / 10;
		scrnH_ft = Math.round( scrnDiag_mm * coefH / coefD / 25.4 / 12 * 100 ) / 100;
		scrnW_mm = Math.round( scrnDiag_mm * coefW / coefD );
		scrnW_in = Math.round( scrnDiag_mm * coefW / coefD / 25.4 * 10 ) / 10;
		scrnW_ft = Math.round( scrnDiag_mm * coefW / coefD / 25.4 / 12 * 100 ) / 100;
		dist1_mm = Math.round( dist1_in * 25.4 );
//		dist1_in = null;
		dist1_ft = Math.round( dist1_in / 12 * 100 ) / 100;
		dist2_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip );
		dist2_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip ) / 25.4 * 10 ) / 10;
		dist2_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip ) / 25.4 / 12 * 100 ) / 100;
		dist3_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip - pjFr );
		dist3_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjFr ) / 25.4 * 10 ) / 10;
		dist3_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjFr ) / 25.4 / 12 * 100 ) / 100;
		dist4_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip - pjRr );
		dist4_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjRr ) / 25.4 * 10 ) / 10;
		dist4_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjRr ) / 25.4 / 12 * 100 ) / 100;
		dist5_mm = Math.round( scrnH_mm * topAmin - topB );
		dist5_in = Math.round(( scrnH_mm * topAmin - topB ) / 25.4 * 10 ) / 10;
		dist5_ft = Math.round(( scrnH_mm * topAmin - topB ) / 25.4 / 12 * 100 ) / 100;
		dist6_mm = Math.round( scrnH_mm * topAmax - topB );
		dist6_in = Math.round(( scrnH_mm * topAmax - topB ) / 25.4 * 10 ) / 10;
		dist6_ft = Math.round(( scrnH_mm * topAmax - topB ) / 25.4 / 12 * 100 ) / 100;
		dist7_mm = Math.round( scrnH_mm * topAmin - topB + pjH );
		dist7_in = Math.round(( scrnH_mm * topAmin - topB + pjH ) / 25.4 * 10 ) / 10;
		dist7_ft = Math.round(( scrnH_mm * topAmin - topB + pjH ) / 25.4 / 12 * 100 ) / 100;
		dist8_mm = Math.round( scrnH_mm * topAmax - topB + pjH );
		dist8_in = Math.round(( scrnH_mm * topAmax - topB + pjH ) / 25.4 * 10 ) / 10;
		dist8_ft = Math.round(( scrnH_mm * topAmax - topB + pjH ) / 25.4 / 12 * 100 ) / 100;

	}

	// dist1-ft

	else if ( currentField == 'dist1-ft' ) {

		scrnDiag_mm = Math.round(( dist1_ft * 12 * 25.4 - coefB ) / coefA * 25.4 );
		scrnDiag_in = Math.round(( dist1_ft * 12 * 25.4 - coefB ) / coefA * 10 ) / 10;
		scrnDiag_ft = Math.round(( dist1_ft * 12 * 25.4 - coefB ) / coefA / 12 * 100 ) / 100;
		scrnH_mm = Math.round( scrnDiag_mm * coefH / coefD );
		scrnH_in = Math.round( scrnDiag_mm * coefH / coefD / 25.4 * 10 ) / 10;
		scrnH_ft = Math.round( scrnDiag_mm * coefH / coefD / 25.4 / 12 * 100 ) / 100;
		scrnW_mm = Math.round( scrnDiag_mm * coefW / coefD );
		scrnW_in = Math.round( scrnDiag_mm * coefW / coefD / 25.4 * 10 ) / 10;
		scrnW_ft = Math.round( scrnDiag_mm * coefW / coefD / 25.4 / 12 * 100 ) / 100;
		dist1_mm = Math.round( dist1_ft * 12 * 25.4 );
		dist1_in = Math.round( dist1_ft * 12 * 10 ) / 10;
//		dist1_ft = null;
		dist2_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip );
		dist2_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip ) / 25.4 * 10 ) / 10;
		dist2_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip ) / 25.4 / 12 * 100 ) / 100;
		dist3_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip - pjFr );
		dist3_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjFr ) / 25.4 * 10 ) / 10;
		dist3_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjFr ) / 25.4 / 12 * 100 ) / 100;
		dist4_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip - pjRr );
		dist4_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjRr ) / 25.4 * 10 ) / 10;
		dist4_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjRr ) / 25.4 / 12 * 100 ) / 100;
		dist5_mm = Math.round( scrnH_mm * topAmin - topB );
		dist5_in = Math.round(( scrnH_mm * topAmin - topB ) / 25.4 * 10 ) / 10;
		dist5_ft = Math.round(( scrnH_mm * topAmin - topB ) / 25.4 / 12 * 100 ) / 100;
		dist6_mm = Math.round( scrnH_mm * topAmax - topB );
		dist6_in = Math.round(( scrnH_mm * topAmax - topB ) / 25.4 * 10 ) / 10;
		dist6_ft = Math.round(( scrnH_mm * topAmax - topB ) / 25.4 / 12 * 100 ) / 100;
		dist7_mm = Math.round( scrnH_mm * topAmin - topB + pjH );
		dist7_in = Math.round(( scrnH_mm * topAmin - topB + pjH ) / 25.4 * 10 ) / 10;
		dist7_ft = Math.round(( scrnH_mm * topAmin - topB + pjH ) / 25.4 / 12 * 100 ) / 100;
		dist8_mm = Math.round( scrnH_mm * topAmax - topB + pjH );
		dist8_in = Math.round(( scrnH_mm * topAmax - topB + pjH ) / 25.4 * 10 ) / 10;
		dist8_ft = Math.round(( scrnH_mm * topAmax - topB + pjH ) / 25.4 / 12 * 100 ) / 100;

	}

// recalculation: calc button after tab/return

	else if ( scrnDiag_in != '' ) {

/*		scrnDiag_mm = document.getElementById('scrn-diag-mm').value;
		scrnDiag_in = document.getElementById('scrn-diag-in').value;
		scrnH_mm = document.getElementById('scrn-h-mm').value;
		scrnH_in = document.getElementById('scrn-h-in').value;
		scrnW_mm = document.getElementById('scrn-w-mm').value;
		scrnW_in = document.getElementById('scrn-w-in').value;
		dist1_mm = document.getElementById('dist1-mm').value;
		dist1_ft = document.getElementById('dist1-ft').value;
*/		dist2_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip );
		dist2_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip ) / 25.4 * 10 ) / 10;
		dist2_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip ) / 25.4 / 12 * 100 ) / 100;
		dist3_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip - pjFr );
		dist3_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjFr ) / 25.4 * 10 ) / 10;
		dist3_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjFr ) / 25.4 / 12 * 100 ) / 100;
		dist4_mm = Math.round( scrnDiag_in * coefA + coefB + lensTip - pjRr );
		dist4_in = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjRr ) / 25.4 * 10 ) / 10;
		dist4_ft = Math.round(( scrnDiag_in * coefA + coefB + lensTip - pjRr ) / 25.4 / 12 * 100 ) / 100;
		dist5_mm = Math.round( scrnH_mm * topAmin - topB );
		dist5_in = Math.round(( scrnH_mm * topAmin - topB ) / 25.4 * 10 ) / 10;
		dist5_ft = Math.round(( scrnH_mm * topAmin - topB ) / 25.4 / 12 * 100 ) / 100;
		dist6_mm = Math.round( scrnH_mm * topAmax - topB );
		dist6_in = Math.round(( scrnH_mm * topAmax - topB ) / 25.4 * 10 ) / 10;
		dist6_ft = Math.round(( scrnH_mm * topAmax - topB ) / 25.4 / 12 * 100 ) / 100;
		dist7_mm = Math.round( scrnH_mm * topAmin - topB + pjH );
		dist7_in = Math.round(( scrnH_mm * topAmin - topB + pjH ) / 25.4 * 10 ) / 10;
		dist7_ft = Math.round(( scrnH_mm * topAmin - topB + pjH ) / 25.4 / 12 * 100 ) / 100;
		dist8_mm = Math.round( scrnH_mm * topAmax - topB + pjH );
		dist8_in = Math.round(( scrnH_mm * topAmax - topB + pjH ) / 25.4 * 10 ) / 10;
		dist8_ft = Math.round(( scrnH_mm * topAmax - topB + pjH ) / 25.4 / 12 * 100 ) / 100;

	}

	// placing values into input boxes

	document.getElementById('scrn-diag-mm').value = scrnDiag_mm;
	document.getElementById('scrn-diag-in').value = scrnDiag_in;
	document.getElementById('scrn-diag-ft').value = scrnDiag_ft;
	document.getElementById('scrn-h-mm').value = scrnH_mm;
	document.getElementById('scrn-h-in').value = scrnH_in;
	document.getElementById('scrn-h-ft').value = scrnH_ft;
	document.getElementById('scrn-w-mm').value = scrnW_mm;
	document.getElementById('scrn-w-in').value = scrnW_in;
	document.getElementById('scrn-w-ft').value = scrnW_ft;
	document.getElementById('dist1-mm').value = dist1_mm;
	document.getElementById('dist1-in').value = dist1_in;
	document.getElementById('dist1-ft').value = dist1_ft;

	// optical shift range

	for ( var i = 0 ; i < aspectLength ; i++ ) {

		if ( document.forms['aspect-selector-button'].aspect[i].checked == true ) {

			var	aspectRatio = document.forms['aspect-selector-button'].elements['aspect'][i].value;

			if ( aspectRatio != 1610 ) {
				var	sftRangeV1 = '&emsp;&#42; Refer to the shift range of 16:10 aspect ratio.',
					sftRangeV2 = '',
					sftRangeH1 = '';
			}
			else {
				var	Vshift1_mm = Math.round(scrnH_mm * coefVsft1_1610),
					Vshift1_in = Math.round(scrnH_in * coefVsft1_1610 * 10 ) / 10,
					Vshift1_ft = Math.round(scrnH_ft * coefVsft1_1610 * 100 ) / 100,
					Vshift2_mm = Math.round(scrnH_mm * coefVsft2_1610),
					Vshift2_in = Math.round(scrnH_in * coefVsft2_1610 * 10 ) / 10,
					Vshift2_ft = Math.round(scrnH_ft * coefVsft2_1610 * 100 ) / 100,
					Hshift1_mm = Math.round(scrnW_mm * coefHsft1_1610),
					Hshift1_in = Math.round(scrnW_in * coefHsft1_1610 * 10 ) / 10,
					Hshift1_ft = Math.round(scrnW_ft * coefHsft1_1610 * 100 ) / 100,
				// toLocaleString()
					Vshift1_mm = Vshift1_mm.toLocaleString(),
					Vshift1_in = Vshift1_in.toLocaleString(),
					Vshift1_ft = Vshift1_ft.toLocaleString(),
					Vshift2_mm = Vshift2_mm.toLocaleString(),
					Vshift2_in = Vshift2_in.toLocaleString(),
					Vshift2_ft = Vshift2_ft.toLocaleString(),
					Hshift1_mm = Hshift1_mm.toLocaleString(),
					Hshift1_in = Hshift1_in.toLocaleString(),
					Hshift1_ft = Hshift1_ft.toLocaleString(),
				// shift range
					sftRangeV1 = 'VS1: '+Vshift1_mm+' mm / '+Vshift1_in+' in / '+Vshift1_ft+' ft\n',
					sftRangeV2 = 'VS2: '+Vshift2_mm+' mm / '+Vshift2_in+' in / '+Vshift2_ft+' ft\n',
					sftRangeH1 = 'HS1: '+Hshift1_mm+' mm / '+Hshift1_in+' in / '+Hshift1_ft+' ft';
			}

		}

	}

	// brightness

	var scrnIlluminance = Math.round( pjOutput / ( scrnH_mm * scrnW_mm / 1000 / 1000 ) );


	//// result strings //////////////

	// toLocaleString()

	var	scrnDiag_mm = parseFloat(scrnDiag_mm).toLocaleString(),
		scrnDiag_in = parseFloat(scrnDiag_in).toLocaleString(),
		scrnDiag_ft = parseFloat(scrnDiag_ft).toLocaleString(),
		scrnH_mm = parseFloat(scrnH_mm).toLocaleString(),
		scrnH_in = parseFloat(scrnH_in).toLocaleString(),
		scrnH_ft = parseFloat(scrnH_ft).toLocaleString(),
		scrnW_mm = parseFloat(scrnW_mm).toLocaleString(),
		scrnW_in = parseFloat(scrnW_in).toLocaleString(),
		scrnW_ft = parseFloat(scrnW_ft).toLocaleString(),
		dist1_mm = parseFloat(dist1_mm).toLocaleString(),
		dist1_in = parseFloat(dist1_in).toLocaleString(),
		dist1_ft = parseFloat(dist1_ft).toLocaleString(),
		dist2_mm = parseFloat(dist2_mm).toLocaleString(),
		dist2_in = parseFloat(dist2_in).toLocaleString(),
		dist2_ft = parseFloat(dist2_ft).toLocaleString(),
		dist3_mm = parseFloat(dist3_mm).toLocaleString(),
		dist3_in = parseFloat(dist3_in).toLocaleString(),
		dist3_ft = parseFloat(dist3_ft).toLocaleString(),
		dist4_mm = parseFloat(dist4_mm).toLocaleString(),
		dist4_in = parseFloat(dist4_in).toLocaleString(),
		dist4_ft = parseFloat(dist4_ft).toLocaleString(),
		dist5_mm = parseFloat(dist5_mm).toLocaleString(),
		dist5_in = parseFloat(dist5_in).toLocaleString(),
		dist5_ft = parseFloat(dist5_ft).toLocaleString(),
		dist6_mm = parseFloat(dist6_mm).toLocaleString(),
		dist6_in = parseFloat(dist6_in).toLocaleString(),
		dist6_ft = parseFloat(dist6_ft).toLocaleString(),
		dist7_mm = parseFloat(dist7_mm).toLocaleString(),
		dist7_in = parseFloat(dist7_in).toLocaleString(),
		dist7_ft = parseFloat(dist7_ft).toLocaleString(),
		dist8_mm = parseFloat(dist8_mm).toLocaleString(),
		dist8_in = parseFloat(dist8_in).toLocaleString(),
		dist8_ft = parseFloat(dist8_ft).toLocaleString(),
		pjOutput = parseFloat(pjOutput).toLocaleString(),
		scrnIlluminance = parseFloat(scrnIlluminance).toLocaleString();

	// specs

	var	specsModel = 'Projector: '+pjModel,
		specsLens = 'Lens: '+lensModel,
		specsPjSize = '[Projection size]',
		specsAspectRatio = 'Aspect ratio: '+specAspect,
		specsPjSize_diag = 'Diagonal: '+scrnDiag_mm+' mm / '+scrnDiag_in+' in / '+scrnDiag_ft+' ft',
		specsPjSize_h = 'Height: '+scrnH_mm+' mm / '+scrnH_in+' in / '+scrnH_ft+' ft',
		specsPjSize_w = 'Width: '+scrnW_mm+' mm / '+scrnW_in+' in / '+scrnW_ft+' ft',
		specsDim = '[Projection distance]',
		specsDistL1 = 'L1: '+dist1_mm+' mm / '+dist1_in+' in / '+dist1_ft+' ft',
		specsDistL2 = 'L2: '+dist2_mm+' mm / '+dist2_in+' in / '+dist2_ft+' ft',
		specsDistL3 = 'L3: '+dist3_mm+' mm / '+dist3_in+' in / '+dist3_ft+' ft',
		specsDistL4 = 'L4: '+dist4_mm+' mm / '+dist4_in+' in / '+dist4_ft+' ft',
		specsDistA1_mm = 'A1: '+dist5_mm+'&ndash;'+dist6_mm+' mm',
		specsDistA1_in = ' / '+dist5_in+'&ndash;'+dist6_in+' in',
		specsDistA1_ft = ' / '+dist5_ft+'&ndash;'+dist6_ft+' ft',
		specsDistA2_mm = 'A2: '+dist7_mm+'&ndash;'+dist8_mm+' mm',
		specsDistA2_in = ' / '+dist7_in+'&ndash;'+dist8_in+' in',
		specsDistA2_ft = ' / '+dist7_ft+'&ndash;'+dist8_ft+' ft';

	var	specs = specsModel+'\n'+specsLens+'\n'+specsPjSize+'\n'+specsAspectRatio+'\n'+specsPjSize_diag+'\n'+specsPjSize_h+'\n'+specsPjSize_w+'\n'+specsDim+'\n'+specsDistL1+'\n'+specsDistL2+'\n'+specsDistL3+'\n'+specsDistL4+'\n'+specsDistA1_mm+specsDistA1_in+specsDistA1_ft+'\n'+specsDistA2_mm+specsDistA2_in+specsDistA2_ft;

	// shift range

	var	shiftrange = '[Optical shift range]\n'+sftRangeV1+sftRangeV2+sftRangeH1;

	// brightness

	var	pjLumens = '[Brightness]\n'+'Projector output: '+pjOutput+' lm',
		scrnLux = 'Screen illuminance: '+scrnIlluminance+' lx';

	var	brightness = pjLumens+'\n'+scrnLux;

	// replace textarea

	var	tagTextareaStart = '<textarea id="result-list" rows=22>';
	var	tagTextareaEnd = '</textarea>';


	//// put results in textarea //////////////

	var	resultAll = tagTextareaStart+specs+'\n'+shiftrange+'\n'+brightness+tagTextareaEnd;

	var	resultInTextarea = document.getElementById('show-result');
	resultInTextarea.innerHTML = resultAll;


	//// write results for printing //////////////

	var	tableStart = '<table>',
		tableEnd = '</table>',
		trStart = '<tr>',
		trEnd = '</tr>',
		tdStart = '<td>',
		tdEnd = '</td>',
	
		// spec
		specsModelPrn = '<tr><td>Projector: </td><td>'+pjModel+'</td></tr>',
		specsLensPrn = '<tr><td>Lens: </td><td>'+lensModel+'</td></tr>',
		// shift range
		sftRange = '[Optical shift range]',
		// brightness
		pjBrightness = '[Brightness]';
		pjLumensPrn = 'Projector output: '+pjOutput+' lm';

	var	resultPrint = 
		tableStart + 
		specsModelPrn + specsLensPrn + 
		trStart + 
		tdStart + specsPjSize + tdEnd + 
		tdStart + specsAspectRatio + '<br>' + specsPjSize_diag + '<br>' + specsPjSize_h + '<br>' + specsPjSize_w + tdEnd + 
		trEnd + 
		trStart + 
		tdStart + specsDim + tdEnd + 
		tdStart + specsDistL1 + '<br>' + specsDistL2 + '<br>' + specsDistL3 + '<br>' + specsDistL4 + '<br>' + specsDistA1_mm + specsDistA1_in + specsDistA1_ft + '<br>' + specsDistA2_mm + specsDistA2_in + specsDistA2_ft + tdEnd + 
		trEnd + 
		trStart + 
		tdStart + sftRange + tdEnd + 
		tdStart + sftRangeV1 + '<br>' + sftRangeV2 + '<br>' + sftRangeH1 + tdEnd + 
		trEnd + 
		trStart + 
		tdStart + pjBrightness + tdEnd + 
		tdEnd + tdStart + pjLumensPrn + '<br>' + scrnLux + tdEnd + 
		trEnd + 
		tableEnd;

		resultForPrint = document.getElementById('results-for-print');
		resultForPrint.innerHTML = resultPrint;


	//// Screen size alert - scrnalert.js //////////////

	if ( scrnDiag_in != '' ) {

		scrnAlert();

	}


}