/* =================================
	COEFFICIENT FOR LENS FINDER CALCULATION
	PT-DW100
================================= */


// definition for optional lens ===========

var	optLens05 = 'ET-D75LE5',	/*	0.8 (0.742-0.785)	trBp01 to trBp02	*/
	optLens06 = 'ET-D75LE6',	/*	1.0	to	1.2 (1.006-1.246)	trBp03 to trBp04	*/
	optLens10 = 'ET-D75LE10',	/*	1.4	to	1.9 (1.408-1.885 )	trBp05 to trBp08	*/
	optLens01 = 'ET-D75LE1',	/*	1.5	to	2.0 (1.498-2.060 )	trBp06 to trBp10	*/
	optLens20 = 'ET-D75LE20',	/*	1.8	to	2.7 (1.818-2.713)	trBp07 to trBp12	*/
	optLens02 = 'ET-D75LE2',	/*	2.1	to	3.1 (2.023-3.106)	trBp09 to trBp14	*/
	optLens30 = 'ET-D75LE30',	/*	2.7	to	5.2 (2.628-5.228)	trBp11 to trBp17	*/
	optLens03 = 'ET-D75LE3',	/*	3.1	to	5.2 (3.050-5.192)	trBp13 to trBp16	*/
	optLens04 = 'ET-D75LE4',	/*	5.2	to	8.2 (5.124-8.263)	trBp15 to trBp19	*/
	optLens08 = 'ET-D75LE8';	/*	8.2	to	15.4 (8.019-15.469)	trBp18 to trBp20	*/


// coefficient for projection range ===========

var	optLens = [ 'ET-D75LE5', 'ET-D75LE6', 'ET-D75LE10', 'ET-D75LE1', 'ET-D75LE20', 'ET-D75LE2', 'ET-D75LE30', 'ET-D75LE3', 'ET-D75LE4', 'ET-D75LE8' ];

var	coefAmin = [ 17.64, 23.1, 32.408, 34.257, 41.464, 45.957, 59.818, 68.935, 115.125, 183.09 ],
	coefBmin = [ 83.5, 56.6, 85.7, 76.4, 83.2, 79.8, 113.14, 96.2, 115.5, 386.23 ],
	coefAmax = [  , 27.7, 41.888, 45.768, 60.248, 68.927, 116.01, 115.125, 183.073, 343.03 ],
	coefBmax = [  , 73.6, 108.5, 100.9, 116.2, 105.6, 176.47, 121.5, 101.7, 359.77 ];


// link to throw distance calculator ===========

var	linkLens = [ 'le5', 'le6', 'le10', 'le1', 'le20', 'le2', 'le30', 'le3', 'le4', 'le8' ],
	linkLens1,
	linkLens2,
	linkLens3;


// option lens throw ratio range ===========

var	trRange = [
	[ '0.8',  ],
	[ '1.0', '1.2' ],
	[ '1.4', '1.9' ],
	[ '1.5', '2.0' ],
	[ '1.8', '2.7' ],
	[ '2.1', '3.1' ],
	[ '2.7', '5.2' ],
	[ '3.1', '5.2' ],
	[ '5.2', '8.2' ],
	[ '8.2', '15.4' ]
	];


// break point of projection range (throw ratio break point) ===========

		// 'No lens found' (optLens05)
var	trBp01 = 0.742,
		// (optLens05)
	trBp02 = 0.785,
		// 'No lens found' (optLens05)
	trBp03 = 1.006,
		// optLens06
	trBp04 = 1.246,
		// 'No lens found'
	trBp05 = 1.408,
		// optLens10
	trBp06 = 1.498,
		// optLens10 + optLens01
	trBp07 = 1.818,
		// optLens10 + optLens01 + optLens20
	trBp08 = 1.885,
		// optLens01 + optLens20
	trBp09 = 2.023,
		// optLens01 + optLens20 + optLens02
	trBp10 = 2.060,
		// optLens20 + optLens02
	trBp11 = 2.628,
		// optLens20 + optLens02 + optLens30
	trBp12 = 2.713,
		// optLens02 + optLens30
	trBp13 = 3.050,
		// optLens02 + optLens30 + optLens03 
	trBp14 = 3.106,
		// optLens30 + optLens03
	trBp15 = 5.124,
		// optLens30 + optLens03 + optLens04
	trBp16 = 5.192,
		// optLens30 + optLens04
	trBp17 = 5.228,
		// optLens04
	trBp18 = 8.019,
		// optLens04 + optLens08
	trBp19 = 8.263,
		// optLens08
	trBp20 = 15.469;
		// 'No lens found'


// option lens throw ratio range for canvas indicator ===========

var	trRangeBar = trRange
/*
var	trRangeBar = [
	[ trBp01, trBp02 ],
	[ trBp03, trBp04 ],
	[ trBp05, trBp08 ],
	[ trBp06, trBp10 ],
	[ trBp07, trBp12 ],
	[ trBp09, trBp14 ],
	[ trBp11, trBp17 ],
	[ trBp13, trBp16 ],
	[ trBp15, trBp19 ],
	[ trBp18, trBp20 ]
	];
*/


// size limitation ===========

var	scrnSizeMin = 70,
	scrnSizeMax = 600,
	scrnSizeMinMm = scrnSizeMin * 25.4,
	scrnSizeMaxMm = scrnSizeMax * 25.4;

	scrnSizeMax = String( scrnSizeMax ).replace( /(\d)(?=(\d\d\d)+(?!\d))/g, '$1,' );
	scrnSizeMinMm = String( scrnSizeMinMm ).replace( /(\d)(?=(\d\d\d)+(?!\d))/g, '$1,' );
	scrnSizeMaxMm = String( scrnSizeMaxMm ).replace( /(\d)(?=(\d\d\d)+(?!\d))/g, '$1,' );


// maximum projection distance limitation: ET-D75LE8 ===========
/*
var	maxDistMm169 = 205458,
	maxDistFt169 = parseFloat( Math.round ( maxDistMm169 / 304.8 * 100 ) / 100 );

	maxDistMm169Str = String( maxDistMm169 ).replace( /(\d)(?=(\d\d\d)+(?!\d))/g, '$1,' );
*/


// CALCULATION FOR SUITABLE LENS /////////////////////////


function lensFinder() {



	var	stLens1 = '',
		stLens2 = '',
		stLens3 = '',
		trMin1 = 0,
		trMax1 = 0,
		trLens1 = 0,
		trMin2 = 0,
		trMax2 = 0,
		trLens2 = 0,
		trMin3 = 0,
		trMax3 = 0,
		trLens3 = 0,
		coefAmin1 = 0,
		coefBmin1 = 0,
		coefAmax1 = 0,
		coefBmax1 = 0,
		coefAmin2 = 0,
		coefBmin2 = 0,
		coefAmax2 = 0,
		coefBmax2 = 0,
		coefAmin3 = 0,
		coefBmin3 = 0,
		coefAmax3 = 0,
		coefBmax3 = 0;


	// aspect ratio

	var	aspectRatio = (function() {

		var	aspect = document.getElementsByName('aspect');

		for ( var i = 0; i < aspect.length; i++ ) {

			if ( aspect[i].checked == true ) {
				var	aspectRatio = aspect[i].value;
				return aspectRatio;		// ESSENTIAL
			}
		}

	}());


	// calculation

	if ( throwRatio < trBp01 ) {
		stLens1 = 'No lens was found.';
		linkLens1 = linkLens[0];
	} else if ( throwRatio <= trBp02 ) {
		stLens1 = optLens05;
//		stLens2 = 'Also check the ' + optLens90 + '.';
		linkLens1 = linkLens[0];
		trMin1 = trRange[0][0];
		coefAmin1 = coefAmin[0];
		coefBmin1 = coefBmin[0];
	} else if ( throwRatio < trBp03 ) {
		stLens1 = 'No lens was found.';
		linkLens1 = linkLens[0];
	} else if ( throwRatio <= trBp04 ) {
		stLens1 = optLens06;
		linkLens1 = linkLens[1];
		trMin1 = trRange[1][0];
		trMax1 = trRange[1][1];
		coefAmin1 = coefAmin[1];
		coefBmin1 = coefBmin[1];
		coefAmax1 = coefAmax[1];
		coefBmax1 = coefBmax[1];
	} else if ( throwRatio < trBp05 ) {
		stLens1 = 'No lens was found.';
		linkLens1 = linkLens[2];
	} else if ( throwRatio <= trBp06 ) {
		stLens1 = optLens10;
		linkLens1 = linkLens[2];
		trMin1 = trRange[2][0];
		trMax1 = trRange[2][1];
		coefAmin1 = coefAmin[2];
		coefBmin1 = coefBmin[2];
		coefAmax1 = coefAmax[2];
		coefBmax1 = coefBmax[2];
	} else if ( throwRatio <= trBp07 ) {
		// lens1
		stLens1 = optLens10;
		linkLens1 = linkLens[2];
		trMin1 = trRange[2][0];
		trMax1 = trRange[2][1];
		coefAmin1 = coefAmin[2];
		coefBmin1 = coefBmin[2];
		coefAmax1 = coefAmax[2];
		coefBmax1 = coefBmax[2];
		// lens2
		stLens2 = optLens01;
		linkLens2 = linkLens[3];
		trMin2 = trRange[3][0];
		trMax2 = trRange[3][1];
		coefAmin2 = coefAmin[3];
		coefBmin2 = coefBmin[3];
		coefAmax2 = coefAmax[3];
		coefBmax2 = coefBmax[3];
	} else if ( throwRatio <= trBp08 ) {
		// lens1
		stLens1 = optLens10;
		linkLens1 = linkLens[2];
		trMin1 = trRange[2][0];
		trMax1 = trRange[2][1];
		coefAmin1 = coefAmin[2];
		coefBmin1 = coefBmin[2];
		coefAmax1 = coefAmax[2];
		coefBmax1 = coefBmax[2];
		// lens2
		stLens2 = optLens01;
		linkLens2 = linkLens[3];
		trMin2 = trRange[3][0];
		trMax2 = trRange[3][1];
		coefAmin2 = coefAmin[3];
		coefBmin2 = coefBmin[3];
		coefAmax2 = coefAmax[3];
		coefBmax2 = coefBmax[3];
		// lens3
		stLens3 = optLens20;
		linkLens3 = linkLens[4];
		trMin3 = trRange[4][0];
		trMax3 = trRange[4][1];
		coefAmin3 = coefAmin[4];
		coefBmin3 = coefBmin[4];
		coefAmax3 = coefAmax[4];
		coefBmax3 = coefBmax[4];
	} else if ( throwRatio <= trBp09 ) {
		// lens1
		stLens1 = optLens01;
		linkLens1 = linkLens[3];
		trMin1 = trRange[3][0];
		trMax1 = trRange[3][1];
		coefAmin1 = coefAmin[3];
		coefBmin1 = coefBmin[3];
		coefAmax1 = coefAmax[3];
		coefBmax1 = coefBmax[3];
		// lens2
		stLens2 = optLens20;
		linkLens2 = linkLens[4];
		trMin2 = trRange[4][0];
		trMax2 = trRange[4][1];
		coefAmin2 = coefAmin[4];
		coefBmin2 = coefBmin[4];
		coefAmax2 = coefAmax[4];
		coefBmax2 = coefBmax[4];
	} else if ( throwRatio <= trBp10 ) {
		// lens1
		stLens1 = optLens01;
		linkLens1 = linkLens[3];
		trMin1 = trRange[3][0];
		trMax1 = trRange[3][1];
		coefAmin1 = coefAmin[3];
		coefBmin1 = coefBmin[3];
		coefAmax1 = coefAmax[3];
		coefBmax1 = coefBmax[3];
		// lens2
		stLens2 = optLens20;
		linkLens2 = linkLens[4];
		trMin2 = trRange[4][0];
		trMax2 = trRange[4][1];
		coefAmin2 = coefAmin[4];
		coefBmin2 = coefBmin[4];
		coefAmax2 = coefAmax[4];
		coefBmax2 = coefBmax[4];
		// lens3
		stLens3 = optLens02;
		linkLens3 = linkLens[5];
		trMin3 = trRange[5][0];
		trMax3 = trRange[5][1];
		coefAmin3 = coefAmin[5];
		coefBmin3 = coefBmin[5];
		coefAmax3 = coefAmax[5];
		coefBmax3 = coefBmax[5];
	} else if ( throwRatio <= trBp11 ) {
		// lens1
		stLens1 = optLens20;
		linkLens1 = linkLens[4];
		trMin1 = trRange[4][0];
		trMax1 = trRange[4][1];
		coefAmin1 = coefAmin[4];
		coefBmin1 = coefBmin[4];
		coefAmax1 = coefAmax[4];
		coefBmax1 = coefBmax[4];
		// lens2
		stLens2 = optLens02;
		linkLens2 = linkLens[5];
		trMin2 = trRange[5][0];
		trMax2 = trRange[5][1];
		coefAmin2 = coefAmin[5];
		coefBmin2 = coefBmin[5];
		coefAmax2 = coefAmax[5];
		coefBmax2 = coefBmax[5];
	} else if ( throwRatio <= trBp12 ) {
		// lens1
		stLens1 = optLens20;
		linkLens1 = linkLens[4];
		trMin1 = trRange[4][0];
		trMax1 = trRange[4][1];
		coefAmin1 = coefAmin[4];
		coefBmin1 = coefBmin[4];
		coefAmax1 = coefAmax[4];
		coefBmax1 = coefBmax[4];
		// lens2
		stLens2 = optLens02;
		linkLens2 = linkLens[5];
		trMin2 = trRange[5][0];
		trMax2 = trRange[5][1];
		coefAmin2 = coefAmin[5];
		coefBmin2 = coefBmin[5];
		coefAmax2 = coefAmax[5];
		coefBmax2 = coefBmax[5];
		// lens3
		stLens3 = optLens30;
		linkLens3 = linkLens[6];
		trMin3 = trRange[6][0];
		trMax3 = trRange[6][1];
		coefAmin3 = coefAmin[6];
		coefBmin3 = coefBmin[6];
		coefAmax3 = coefAmax[6];
		coefBmax3 = coefBmax[6];
	} else if ( throwRatio <= trBp13 ) {
		// lens1
		stLens1 = optLens02;
		linkLens1 = linkLens[5];
		trMin1 = trRange[5][0];
		trMax1 = trRange[5][1];
		coefAmin1 = coefAmin[5];
		coefBmin1 = coefBmin[5];
		coefAmax1 = coefAmax[5];
		coefBmax1 = coefBmax[5];
		// lens2
		stLens2 = optLens30;
		linkLens2 = linkLens[6];
		trMin2 = trRange[6][0];
		trMax2 = trRange[6][1];
		coefAmin2 = coefAmin[6];
		coefBmin2 = coefBmin[6];
		coefAmax2 = coefAmax[6];
		coefBmax2 = coefBmax[6];
	} else if ( throwRatio <= trBp14 ) {
		// lens1
		stLens1 = optLens02;
		linkLens1 = linkLens[5];
		trMin1 = trRange[5][0];
		trMax1 = trRange[5][1];
		coefAmin1 = coefAmin[5];
		coefBmin1 = coefBmin[5];
		coefAmax1 = coefAmax[5];
		coefBmax1 = coefBmax[5];
		// lens2
		stLens2 = optLens30;
		linkLens2 = linkLens[6];
		trMin2 = trRange[6][0];
		trMax2 = trRange[6][1];
		coefAmin2 = coefAmin[6];
		coefBmin2 = coefBmin[6];
		coefAmax2 = coefAmax[6];
		coefBmax2 = coefBmax[6];
		// lens3
		stLens3 = optLens03;
		linkLens3 = linkLens[7];
		trMin3 = trRange[7][0];
		trMax3 = trRange[7][1];
		coefAmin3 = coefAmin[7];
		coefBmin3 = coefBmin[7];
		coefAmax3 = coefAmax[7];
		coefBmax3 = coefBmax[7];
	} else if ( throwRatio <= trBp15 ) {
		// lens1
		stLens1 = optLens30;
		linkLens1 = linkLens[6];
		trMin1 = trRange[6][0];
		trMax1 = trRange[6][1];
		coefAmin1 = coefAmin[6];
		coefBmin1 = coefBmin[6];
		coefAmax1 = coefAmax[6];
		coefBmax1 = coefBmax[6];
		// lens2
		stLens2 = optLens03;
		linkLens2 = linkLens[7];
		trMin2 = trRange[7][0];
		trMax2 = trRange[7][1];
		coefAmin2 = coefAmin[7];
		coefBmin2 = coefBmin[7];
		coefAmax2 = coefAmax[7];
		coefBmax2 = coefBmax[7];
	} else if ( throwRatio <= trBp16 ) {
		// lens1
		stLens1 = optLens30;
		linkLens1 = linkLens[6];
		trMin1 = trRange[6][0];
		trMax1 = trRange[6][1];
		coefAmin1 = coefAmin[6];
		coefBmin1 = coefBmin[6];
		coefAmax1 = coefAmax[6];
		coefBmax1 = coefBmax[6];
		// lens2
		stLens2 = optLens03;
		linkLens2 = linkLens[7];
		trMin2 = trRange[7][0];
		trMax2 = trRange[7][1];
		coefAmin2 = coefAmin[7];
		coefBmin2 = coefBmin[7];
		coefAmax2 = coefAmax[7];
		coefBmax2 = coefBmax[7];
		// lens3
		stLens3 = optLens04;
		linkLens3 = linkLens[8];
		trMin3 = trRange[8][0];
		trMax3 = trRange[8][1];
		coefAmin3 = coefAmin[8];
		coefBmin3 = coefBmin[8];
		coefAmax3 = coefAmax[8];
		coefBmax3 = coefBmax[8];
	} else if ( throwRatio <= trBp17 ) {
		// lens1
		stLens1 = optLens30;
		linkLens1 = linkLens[6];
		trMin1 = trRange[6][0];
		trMax1 = trRange[6][1];
		coefAmin1 = coefAmin[6];
		coefBmin1 = coefBmin[6];
		coefAmax1 = coefAmax[6];
		coefBmax1 = coefBmax[6];
		// lens2
		stLens2 = optLens04;
		linkLens2 = linkLens[8];
		trMin2 = trRange[8][0];
		trMax2 = trRange[8][1];
		coefAmin2 = coefAmin[8];
		coefBmin2 = coefBmin[8];
		coefAmax2 = coefAmax[8];
		coefBmax2 = coefBmax[8];
	} else if ( throwRatio <= trBp18 ) {
		// lens1
		stLens1 = optLens04;
		linkLens1 = linkLens[8];
		trMin1 = trRange[8][0];
		trMax1 = trRange[8][1];
		coefAmin1 = coefAmin[8];
		coefBmin1 = coefBmin[8];
		coefAmax1 = coefAmax[8];
		coefBmax1 = coefBmax[8];
	} else if ( throwRatio <= trBp19 ) {
		// lens1
		stLens1 = optLens04;
		linkLens1 = linkLens[8];
		trMin1 = trRange[8][0];
		trMax1 = trRange[8][1];
		coefAmin1 = coefAmin[8];
		coefBmin1 = coefBmin[8];
		coefAmax1 = coefAmax[8];
		coefBmax1 = coefBmax[8];
		// lens2
		stLens2 = optLens08;
		linkLens2 = linkLens[9];
		trMin2 = trRange[9][0];
		trMax2 = trRange[9][1];
		coefAmin2 = coefAmin[9];
		coefBmin2 = coefBmin[9];
		coefAmax2 = coefAmax[9];
		coefBmax2 = coefBmax[9];
	} else if ( throwRatio <= trBp20 ) {
		stLens1 = optLens08;
		linkLens1 = linkLens[9];
		trMin1 = trRange[9][0];
		trMax1 = trRange[9][1];
		coefAmin1 = coefAmin[9];
		coefBmin1 = coefBmin[9];
		coefAmax1 = coefAmax[9];
		coefBmax1 = coefBmax[9];
	}
	else {
		stLens1 = 'No lens was found.';
		linkLens1 = linkLens[9];
	}

	var	pjRange1 = 0,
		pjRange1Ft = 0,
		pjRmin1 = 0,
		pjRmin1Ft = 0,
		pjRmax1 = 0,
		pjRmax1Ft = 0,
		pjRange2 = 0,
		pjRange2Ft = 0,
		pjRmin2 = 0,
		pjRmin2Ft = 0,
		pjRmax2 = 0,
		pjRmax2Ft = 0,
		pjRange3 = 0,
		pjRange3Ft = 0,
		pjRmin3 = 0,
		pjRmin3Ft = 0,
		pjRmax3 = 0,
		pjRmax3Ft = 0;

	// projection range

		pjRmin1 = Math.round( scrnDiag / 25.4 * coefAmin1 - coefBmin1 );
		pjRmin1Ft = Math.round(( scrnDiag / 25.4 * coefAmin1 - coefBmin1 ) / 25.4 / 12 * 100 ) / 100;
		pjRmax1 = Math.round( scrnDiag / 25.4 * coefAmax1 - coefBmax1 );
		pjRmax1Ft = Math.round(( scrnDiag / 25.4 * coefAmax1 - coefBmax1 ) / 25.4 / 12 * 100 ) / 100;
		pjRmin2 = Math.round( scrnDiag / 25.4 * coefAmin2 - coefBmin2 );
		pjRmin2Ft = Math.round(( scrnDiag / 25.4 * coefAmin2 - coefBmin2 ) / 25.4 / 12 * 100 ) / 100;
		pjRmax2 = Math.round( scrnDiag / 25.4 * coefAmax2 - coefBmax2 );
		pjRmax2Ft = Math.round(( scrnDiag / 25.4 * coefAmax2 - coefBmax2 ) / 25.4 / 12 * 100 ) / 100;
		pjRmin3 = Math.round( scrnDiag / 25.4 * coefAmin3 - coefBmin3 );
		pjRmin3Ft = Math.round(( scrnDiag / 25.4 * coefAmin3 - coefBmin3 ) / 25.4 / 12 * 100 ) / 100;
		pjRmax3 = Math.round( scrnDiag / 25.4 * coefAmax3 - coefBmax3 );
		pjRmax3Ft = Math.round(( scrnDiag / 25.4 * coefAmax3 - coefBmax3 ) / 25.4 / 12 * 100 ) / 100;

		// zoom lens

		if ( pjRmax1 != 0 ) {

			trLens1 = ' (' + trMin1 + '–' + trMax1 + ':1)';
			pjRange1 = pjRmin1.toLocaleString() + '–' + pjRmax1.toLocaleString() + ' millimeters';
			pjRange1Ft = pjRmin1Ft.toLocaleString() + '–' + pjRmax1Ft.toLocaleString() + ' feet';

			if ( pjRmin2 != 0 ) {
				trLens2 = ' (' + trMin2 + '–' + trMax2 + ':1)';
				pjRange2 = pjRmin2.toLocaleString() + '–' + pjRmax2.toLocaleString() + ' millimeters';
				pjRange2Ft = pjRmin2Ft.toLocaleString() + '–' + pjRmax2Ft.toLocaleString() + ' feet';

				if ( pjRmin3 != 0 ) {
					trLens3 = ' (' + trMin3 + '–' + trMax3 + ':1)';
					pjRange3 = pjRmin3.toLocaleString() + '–' + pjRmax3.toLocaleString() + ' millimeters';
					pjRange3Ft = pjRmin3Ft.toLocaleString() + '–' + pjRmax3Ft.toLocaleString() + ' feet';
				}

			}

		}

		// fixed lens or no suitable lens

		else if ( pjRmin1 != 0 ) {
			trLens1 = ' (' + trMin1 + ':1)';
			pjRange1 = pjRmin1 + ' millimeters';
			pjRange1Ft = pjRmin1Ft + ' feet';
		}


	var	stLensH2= document.getElementById('option-lens-title');
		stLensDiv1 = document.getElementById('option-lens-1'),
		stLensDiv2 = document.getElementById('option-lens-2'),
		stLensDiv3 = document.getElementById('option-lens-3'),
		throwRatioDiv = document.getElementById('calculated-throw-ratio'),
		pjRangeDiv = document.getElementById('projection-range-title'),
		pjRangeDiv1 = document.getElementById('projection-range-1'),
		pjRangeDiv2 = document.getElementById('projection-range-2'),
		pjRangeDiv3 = document.getElementById('projection-range-3'),
		elBr1 = document.createElement('br'),
		elBr2 = document.createElement('br'),
		elBr3 = document.createElement('br'),
		aLens1 = document.createElement('a'),
		aLens2 = document.createElement('a'),
		aLens3 = document.createElement('a'),
		// for recalculation
		stLensOldTitle = document.getElementById('option-lens-title').firstChild,
		stLensOldText1 = document.getElementById('option-lens-1').firstChild,
		stLensOldText2 = document.getElementById('option-lens-2').firstChild,
		stLensOldText3 = document.getElementById('option-lens-3').firstChild,
		throwRatioOldText = document.getElementById('calculated-throw-ratio').firstChild,
		pjRangeOldTitle = document.getElementById('projection-range-title').firstChild,
		pjRangeOldText1 = document.getElementById('projection-range-1').firstChild,
		pjRangeOldText2 = document.getElementById('projection-range-2').firstChild,
		pjRangeOldText3 = document.getElementById('projection-range-3').firstChild,
		// results
		stLensTitle = document.createTextNode('Suitable Lens: ');
		if ( stLens1 == 'ET-D75LE5' ) {
			var	stLensText1 = document.createTextNode('The ' + stLens1 + ' can be suitable.');
		} else {
			var	stLensText1 = document.createTextNode(stLens1);
		}
	var	stLensText2 = document.createTextNode(stLens2),
		stLensText3 = document.createTextNode(stLens3),
		// link to throw distance calculator
		linkCalc1 = '../previous/dw100' + linkLens1 + '.html?' + encodeURIComponent(scrnSize) + '&' + encodeURIComponent(aspectRatio) + '&' + encodeURIComponent(scrnUnit) + '&' + encodeURIComponent(scrnPortion),
		linkCalc2 = '../previous/dw100' + linkLens2 + '.html?' + encodeURIComponent(scrnSize) + '&' + encodeURIComponent(aspectRatio) + '&' + encodeURIComponent(scrnUnit) + '&' + encodeURIComponent(scrnPortion),
		linkCalc3 = '../previous/dw100' + linkLens3 + '.html?' + encodeURIComponent(scrnSize) + '&' + encodeURIComponent(aspectRatio) + '&' + encodeURIComponent(scrnUnit) + '&' + encodeURIComponent(scrnPortion);

		aLens1.href = linkCalc1;
		aLens2.href = linkCalc2;
		aLens3.href = linkCalc3;
		throwRatioText = document.createTextNode('Approximate throw ratio of this condition: ' + (Math.round(throwRatio * 10) / 10).toFixed(1) + ':1');
		pjRangeTitle = document.createTextNode('Projection distance for the requested image size: ');
		lensModel1 = document.createTextNode(stLens1 + trLens1 + ': ');
		pjRangeText1 = document.createTextNode(pjRange1 +'; ' + pjRange1Ft);
		lensModel2 = document.createTextNode(stLens2 + trLens2 + ': ');
		pjRangeText2 = document.createTextNode(pjRange2 +'; ' + pjRange2Ft);
		lensModel3 = document.createTextNode(stLens3 + trLens3 + ': ');
		pjRangeText3 = document.createTextNode(pjRange3 +'; ' + pjRange3Ft);


	// reset on change

	if ( stLensOldText1 != null ) {

		stLensH2.removeChild(stLensOldTitle);
		stLensDiv1.removeChild(stLensOldText1);
		throwRatioDiv.removeChild(throwRatioOldText);

		if ( pjRangeOldTitle != null ) {
		pjRangeDiv.removeChild(pjRangeOldTitle);

			while ( pjRangeDiv1.lastChild ) {
			  pjRangeDiv1.removeChild(pjRangeDiv1.lastChild);
			}

		}

		if ( stLensOldText2 != null ) {

			stLensDiv2.removeChild(stLensOldText2);

			while ( pjRangeDiv2.lastChild ) {
			  pjRangeDiv2.removeChild(pjRangeDiv2.lastChild);

			}

		}
		if ( stLensOldText3 != null ) {

			stLensDiv3.removeChild(stLensOldText3);

			while ( pjRangeDiv3.lastChild ) {
			  pjRangeDiv3.removeChild(pjRangeDiv3.lastChild);

			}

		}

	}


	// OUTPUT ////////////

	stLensH2.appendChild(stLensTitle);	// Suitable Lens:
	throwRatioDiv.appendChild(throwRatioText);
	if ( stLens1 == 'No lens was found.' ) {

		stLensDiv1.appendChild(aLens1);		// lens model with link 1
		aLens1.appendChild(stLensText1);	// lens model 1

	} else if ( stLens1 != '' ) {

		stLensDiv1.appendChild(aLens1);		// lens model with link 1
		aLens1.appendChild(stLensText1);	// lens model 1
		pjRangeDiv.appendChild(pjRangeTitle);
		pjRangeDiv1.appendChild(lensModel1);
		pjRangeDiv1.appendChild(elBr1);
		pjRangeDiv1.appendChild(pjRangeText1);

		if ( stLens2 != '' ) {

			stLensDiv2.appendChild(aLens2);		// lens model with link 2
			aLens2.appendChild(stLensText2);	// lens model 2
			pjRangeDiv2.appendChild(lensModel2);
			pjRangeDiv2.appendChild(elBr2);
			pjRangeDiv2.appendChild(pjRangeText2);

			if ( stLens3 != '' ) {

				stLensDiv3.appendChild(aLens3);		// lens model with link 3
				aLens3.appendChild(stLensText3);	// lens model 3
				pjRangeDiv3.appendChild(lensModel3);
				pjRangeDiv3.appendChild(elBr3);
				pjRangeDiv3.appendChild(pjRangeText3);

			}

		}

	}



}