/* =================================
	COEFFICIENT FOR LENS FINDER CALCULATION
	PT-DW10000
================================= */


// definition for optional lens ===========

var	optLens05 = 'ET-D75LE5',	/*	0.7 (0.641-0.684)	trBp01 to trBp02	*/
	optLens06 = 'ET-D75LE6',	/*	0.9	to	1.1 (0.904-1.122)	trBp03 to trBp04	*/
	optLens01 = 'ET-D75LE1',	/*	1.4	to	1.8 (1.298-1.794)	trBp05 to trBp07	*/
	optLens02 = 'ET-D75LE2',	/*	1.8	to	2.8 (1.756-2.706)	trBp06 to trBp09	*/
	optLens03 = 'ET-D75LE3',	/*	2.8	to	4.6 (2.650-4.522)	trBp08 to trBp11	*/
	optLens04 = 'ET-D75LE4',	/*	4.6	to	7.4 (4.454-7.198)	trBp10 to trBp12	*/
	optLens08 = 'ET-D75LE8';	/*	7.3	to	13.8 (7.201-13.937)	trBp13 to trBp14	*/


// coefficient for projection range ===========

var	optLens = [ 'ET-D75LE5', 'ET-D75LE6', 'ET-D75LE1', 'ET-D75LE2', 'ET-D75LE3', 'ET-D75LE4', 'ET-D75LE8' ];

var	coefAmin = [ 15.4, 20.83, 29.846, 40.04, 60.058, 100.3, 164.974 ],
	coefBmin = [ 83.5, 56.6, 76.6, 80, 95.8, 115.8, 386.23 ],
	coefAmax = [  , 24.954, 39.876, 60.06, 100.304, 159.5, 309.098 ],
	coefBmax = [  , 73.6, 100.6, 107, 121.4, 101.3, 359.77 ];


// link to throw distance calculator ===========

var	linkLens = [ 'le5', 'le6', 'le1', 'le2', 'le3', 'le4', 'le8' ],
	linkLens1,
	linkLens2;


// option lens throw ratio range ===========

var	trRange = [
	[ '0.7',  ],
	[ '0.9', '1.1' ],
	[ '1.4', '1.8' ],
	[ '1.8', '2.8' ],
	[ '2.8', '4.6' ],
	[ '4.6', '7.4' ],
	[ '7.3', '13.8' ]
	];


// break point of projection range (throw ratio break point) ===========

		// 'No lens found' (optLens50)
var	trBp01 = 0.641,
		// (optLens05)
	trBp02 = 0.684,
		// 'No lens found'
	trBp03 = 0.904,
		// optLens06
	trBp04 = 1.122,
		// 'No lens found'
	trBp05 = 1.298,
		// optLens01
	trBp06 = 1.756,
		// optLens01 + optLens02
	trBp07 = 1.794,
		// optLens02
	trBp08 = 2.650,
		// optLens02 + optLens03
	trBp09 = 2.706,
		// optLens03
	trBp10 = 4.454,
		// optLens03 + optLens04
	trBp11 = 4.522,
		// optLens04
	trBp12 = 7.198,
		// 'No lens found'
	trBp13 = 7.201,
		// optLens08
	trBp14 = 13.937;
		// 'No lens found'


// option lens throw ratio range for canvas indicator ===========

var	trRangeBar = trRange
/*
var	trRangeBar = [
	[ trBp01, trBp02 ],
	[ trBp03, trBp04 ],
	[ trBp05, trBp07 ],
	[ trBp06, trBp09 ],
	[ trBp08, trBp11 ],
	[ trBp10, trBp12 ],
	[ trBp13, trBp14 ]
	];
*/


// size limitation ===========

var	scrnSizeMin = 70,
	scrnSizeMax = 600,
	scrnSizeMinMm = scrnSizeMin * 25.4,
	scrnSizeMaxMm = scrnSizeMax * 25.4;

	scrnSizeMax = String( scrnSizeMax ).replace( /(\d)(?=(\d\d\d)+(?!\d))/g, '$1,' );
	scrnSizeMinMm = String( scrnSizeMinMm ).replace( /(\d)(?=(\d\d\d)+(?!\d))/g, '$1,' );
	scrnSizeMaxMm = String( scrnSizeMaxMm ).replace( /(\d)(?=(\d\d\d)+(?!\d))/g, '$1,' );


// maximum projection distance limitation: ET-D75LE8 ===========
/*
var	maxDistMm169 = 205458,
	maxDistFt169 = parseFloat( Math.round ( maxDistMm169 / 304.8 * 100 ) / 100 );

	maxDistMm169Str = String( maxDistMm169 ).replace( /(\d)(?=(\d\d\d)+(?!\d))/g, '$1,' );
*/


// CALCULATION FOR SUITABLE LENS /////////////////////////


function lensFinder() {



	var	stLens1 = '',
		stLens2 = '',
		trMin1 = 0,
		trMax1 = 0,
		trLens1 = 0,
		trMin2 = 0,
		trMax2 = 0,
		trLens2 = 0,
		coefAmin1 = 0,
		coefBmin1 = 0,
		coefAmax1 = 0,
		coefBmax1 = 0,
		coefAmin2 = 0,
		coefBmin2 = 0,
		coefAmax2 = 0,
		coefBmax2 = 0;


	// aspect ratio

	var	aspectRatio = (function() {

		var	aspect = document.getElementsByName('aspect');

		for ( var i = 0; i < aspect.length; i++ ) {

			if ( aspect[i].checked == true ) {
				var	aspectRatio = aspect[i].value;
				return aspectRatio;		// ESSENTIAL
			}
		}

	}());


	// calculation

	if ( throwRatio < trBp01 ) {
		stLens1 = 'No lens was found.';
		linkLens1 = linkLens[0];
	} else if ( throwRatio <= trBp02 ) {
		stLens1 = optLens05;
//		stLens2 = 'Also check the ' + optLens90 + '.';
		linkLens1 = linkLens[0];
		trMin1 = trRange[0][0];
		coefAmin1 = coefAmin[0];
		coefBmin1 = coefBmin[0];
	} else if ( throwRatio < trBp03 ) {
		stLens1 = 'No lens was found.';
		linkLens1 = linkLens[0];
	} else if ( throwRatio <= trBp04 ) {
		stLens1 = optLens06;
		linkLens1 = linkLens[1];
		trMin1 = trRange[1][0];
		trMax1 = trRange[1][1];
		coefAmin1 = coefAmin[1];
		coefBmin1 = coefBmin[1];
		coefAmax1 = coefAmax[1];
		coefBmax1 = coefBmax[1];
	} else if ( throwRatio < trBp05 ) {
		stLens1 = 'No lens was found.';
		linkLens1 = linkLens[0];
	} else if ( throwRatio <= trBp06 ) {
		stLens1 = optLens01;
		linkLens1 = linkLens[2];
		trMin1 = trRange[2][0];
		trMax1 = trRange[2][1];
		coefAmin1 = coefAmin[2];
		coefBmin1 = coefBmin[2];
		coefAmax1 = coefAmax[2];
		coefBmax1 = coefBmax[2];
	} else if ( throwRatio <= trBp07 ) {
		// lens1
		stLens1 = optLens01;
		linkLens1 = linkLens[2];
		trMin1 = trRange[2][0];
		trMax1 = trRange[2][1];
		coefAmin1 = coefAmin[2];
		coefBmin1 = coefBmin[2];
		coefAmax1 = coefAmax[2];
		coefBmax1 = coefBmax[2];
		// lens2
		stLens2 = optLens02;
		linkLens2 = linkLens[3];
		trMin2 = trRange[3][0];
		trMax2 = trRange[3][1];
		coefAmin2 = coefAmin[3];
		coefBmin2 = coefBmin[3];
		coefAmax2 = coefAmax[3];
		coefBmax2 = coefBmax[3];
	} else if ( throwRatio <= trBp08 ) {
		stLens1 = optLens02;
		linkLens1 = linkLens[3];
		trMin1 = trRange[3][0];
		trMax1 = trRange[3][1];
		coefAmin1 = coefAmin[3];
		coefBmin1 = coefBmin[3];
		coefAmax1 = coefAmax[3];
		coefBmax1 = coefBmax[3];
	} else if ( throwRatio <= trBp09 ) {
		// lens1
		stLens1 = optLens02;
		linkLens1 = linkLens[3];
		trMin1 = trRange[3][0];
		trMax1 = trRange[3][1];
		coefAmin1 = coefAmin[3];
		coefBmin1 = coefBmin[3];
		coefAmax1 = coefAmax[3];
		coefBmax1 = coefBmax[3];
		// lens2
		stLens2 = optLens03;
		linkLens2 = linkLens[4];
		trMin2 = trRange[4][0];
		trMax2 = trRange[4][1];
		coefAmin2 = coefAmin[4];
		coefBmin2 = coefBmin[4];
		coefAmax2 = coefAmax[4];
		coefBmax2 = coefBmax[4];
	} else if ( throwRatio <= trBp10 ) {
		stLens1 = optLens03;
		linkLens1 = linkLens[4];
		trMin1 = trRange[4][0];
		trMax1 = trRange[4][1];
		coefAmin1 = coefAmin[4];
		coefBmin1 = coefBmin[4];
		coefAmax1 = coefAmax[4];
		coefBmax1 = coefBmax[4];
	} else if ( throwRatio <= trBp11 ) {
		// lens1
		stLens1 = optLens03;
		linkLens1 = linkLens[4];
		trMin1 = trRange[4][0];
		trMax1 = trRange[4][1];
		coefAmin1 = coefAmin[4];
		coefBmin1 = coefBmin[4];
		coefAmax1 = coefAmax[4];
		coefBmax1 = coefBmax[4];
		// lens2
		stLens2 = optLens04;
		linkLens2 = linkLens[5];
		trMin2 = trRange[5][0];
		trMax2 = trRange[5][1];
		coefAmin2 = coefAmin[5];
		coefBmin2 = coefBmin[5];
		coefAmax2 = coefAmax[5];
		coefBmax2 = coefBmax[5];
	} else if ( throwRatio <= trBp12 ) {
		stLens1 = optLens04;
		linkLens1 = linkLens[5];
		trMin1 = trRange[5][0];
		trMax1 = trRange[5][1];
		coefAmin1 = coefAmin[5];
		coefBmin1 = coefBmin[5];
		coefAmax1 = coefAmax[5];
		coefBmax1 = coefBmax[5];
	} else if ( throwRatio <= trBp13 ) {
		stLens1 = 'No lens was found.';
		linkLens1 = linkLens[0];
	} else if ( throwRatio <= trBp14 ) {
		stLens1 = optLens08;
		linkLens1 = linkLens[6];
		trMin1 = trRange[6][0];
		trMax1 = trRange[6][1];
		coefAmin1 = coefAmin[6];
		coefBmin1 = coefBmin[6];
		coefAmax1 = coefAmax[6];
		coefBmax1 = coefBmax[6];
	}
	else {
		stLens1 = 'No lens was found.';
		linkLens1 = linkLens[6];
	}

	var	pjRange1 = 0,
		pjRange1Ft = 0,
		pjRmin1 = 0,
		pjRmin1Ft = 0,
		pjRmax1 = 0,
		pjRmax1Ft = 0,
		pjRange2 = 0,
		pjRange2Ft = 0,
		pjRmin2 = 0,
		pjRmin2Ft = 0,
		pjRmax2 = 0,
		pjRmax2Ft = 0;

	// projection range

		pjRmin1 = Math.round( scrnDiag / 25.4 * coefAmin1 - coefBmin1 );
		pjRmin1Ft = Math.round(( scrnDiag / 25.4 * coefAmin1 - coefBmin1 ) / 25.4 / 12 * 100 ) / 100;
		pjRmax1 = Math.round( scrnDiag / 25.4 * coefAmax1 - coefBmax1 );
		pjRmax1Ft = Math.round(( scrnDiag / 25.4 * coefAmax1 - coefBmax1 ) / 25.4 / 12 * 100 ) / 100;
		pjRmin2 = Math.round( scrnDiag / 25.4 * coefAmin2 - coefBmin2 );
		pjRmin2Ft = Math.round(( scrnDiag / 25.4 * coefAmin2 - coefBmin2 ) / 25.4 / 12 * 100 ) / 100;
		pjRmax2 = Math.round( scrnDiag / 25.4 * coefAmax2 - coefBmax2 );
		pjRmax2Ft = Math.round(( scrnDiag / 25.4 * coefAmax2 - coefBmax2 ) / 25.4 / 12 * 100 ) / 100;

		// zoom lens

		if ( pjRmax1 != 0 ) {

			trLens1 = ' (' + trMin1 + '–' + trMax1 + ':1)';
			pjRange1 = pjRmin1.toLocaleString() + '–' + pjRmax1.toLocaleString() + ' millimeters';
			pjRange1Ft = pjRmin1Ft.toLocaleString() + '–' + pjRmax1Ft.toLocaleString() + ' feet';

			if ( pjRmin2 != 0 ) {
				trLens2 = ' (' + trMin2 + '–' + trMax2 + ':1)';
				pjRange2 = pjRmin2.toLocaleString() + '–' + pjRmax2.toLocaleString() + ' millimeters';
				pjRange2Ft = pjRmin2Ft.toLocaleString() + '–' + pjRmax2Ft.toLocaleString() + ' feet';
			}

		}

		// fixed lens or no suitable lens

		else if ( pjRmin1 != 0 ) {
			trLens1 = ' (' + trMin1 + ':1)';
			pjRange1 = pjRmin1 + ' millimeters';
			pjRange1Ft = pjRmin1Ft + ' feet';
		}


	var	stLensH2= document.getElementById('option-lens-title');
		stLensDiv1 = document.getElementById('option-lens-1'),
		stLensDiv2 = document.getElementById('option-lens-2'),
		throwRatioDiv = document.getElementById('calculated-throw-ratio'),
		pjRangeDiv = document.getElementById('projection-range-title'),
		pjRangeDiv1 = document.getElementById('projection-range-1'),
		pjRangeDiv2 = document.getElementById('projection-range-2'),
		elBr1 = document.createElement('br'),
		elBr2 = document.createElement('br'),
		aLens1 = document.createElement('a'),
		aLens2 = document.createElement('a'),
		// for recalculation
		stLensOldTitle = document.getElementById('option-lens-title').firstChild,
		stLensOldText1 = document.getElementById('option-lens-1').firstChild,
		stLensOldText2 = document.getElementById('option-lens-2').firstChild,
		throwRatioOldText = document.getElementById('calculated-throw-ratio').firstChild,
		pjRangeOldTitle = document.getElementById('projection-range-title').firstChild,
		pjRangeOldText1 = document.getElementById('projection-range-1').firstChild,
		pjRangeOldText2 = document.getElementById('projection-range-2').firstChild,
		// results
		stLensTitle = document.createTextNode('Suitable Lens: ');
		if ( stLens1 == 'ET-D75LE5' ) {
			var	stLensText1 = document.createTextNode('The ' + stLens1 + ' can be suitable.');
		} else {
			var	stLensText1 = document.createTextNode(stLens1);
		}
	var	stLensText2 = document.createTextNode(stLens2),
		// link to throw distance calculator
		linkCalc1 = '../previous/dw10000' + linkLens1 + '.html?' + encodeURIComponent(scrnSize) + '&' + encodeURIComponent(aspectRatio) + '&' + encodeURIComponent(scrnUnit) + '&' + encodeURIComponent(scrnPortion),
		linkCalc2 = '../previous/dw10000' + linkLens2 + '.html?' + encodeURIComponent(scrnSize) + '&' + encodeURIComponent(aspectRatio) + '&' + encodeURIComponent(scrnUnit) + '&' + encodeURIComponent(scrnPortion);

		aLens1.href = linkCalc1;
		aLens2.href = linkCalc2;
		throwRatioText = document.createTextNode('Approximate throw ratio of this condition: ' + (Math.round(throwRatio * 10) / 10).toFixed(1) + ':1');
		pjRangeTitle = document.createTextNode('Projection distance for the requested image size: ');
		lensModel1 = document.createTextNode(stLens1 + trLens1 + ': ');
		pjRangeText1 = document.createTextNode(pjRange1 +'; ' + pjRange1Ft);
		lensModel2 = document.createTextNode(stLens2 + trLens2 + ': ');
		pjRangeText2 = document.createTextNode(pjRange2 +'; ' + pjRange2Ft);


	// reset on change

	if ( stLensOldText1 != null ) {

		stLensH2.removeChild(stLensOldTitle);
		stLensDiv1.removeChild(stLensOldText1);
		throwRatioDiv.removeChild(throwRatioOldText);

		if ( pjRangeOldTitle != null ) {
		pjRangeDiv.removeChild(pjRangeOldTitle);

			while ( pjRangeDiv1.lastChild ) {
			  pjRangeDiv1.removeChild(pjRangeDiv1.lastChild);
			}

			if ( stLensOldText2 != null ) {
				stLensDiv2.removeChild(stLensOldText2);
				while ( pjRangeDiv2.lastChild ) {
				  pjRangeDiv2.removeChild(pjRangeDiv2.lastChild);
				}

			}

		}

	}


	// OUTPUT ////////////

	stLensH2.appendChild(stLensTitle);	// Suitable Lens:
	throwRatioDiv.appendChild(throwRatioText);
	if ( stLens1 == 'No lens was found.' ) {

		stLensDiv1.appendChild(aLens1);		// lens model with link 1
		aLens1.appendChild(stLensText1);	// lens model 1

	} else if ( stLens1 != '' ) {

		stLensDiv1.appendChild(aLens1);		// lens model with link 1
		aLens1.appendChild(stLensText1);	// lens model 1
		pjRangeDiv.appendChild(pjRangeTitle);
		pjRangeDiv1.appendChild(lensModel1);
		pjRangeDiv1.appendChild(elBr1);
		pjRangeDiv1.appendChild(pjRangeText1);

		if ( stLens2 != '' ) {

			stLensDiv2.appendChild(aLens2);		// lens model with link 2
			aLens2.appendChild(stLensText2);	// lens model 2
			pjRangeDiv2.appendChild(lensModel2);
			pjRangeDiv2.appendChild(elBr2);
			pjRangeDiv2.appendChild(pjRangeText2);

		}

	}



}