/* =================================
	COEFFICIENT FOR LENS FINDER CALCULATION
	PT-DW11K
================================= */


// definition for optional lens ===========

var	optLens95 = 'ET-D75LE95',	/*	0.4 (0.398-0.405)	trBp01 to trBp02	*/
	optLens90 = 'ET-D75LE90',	/*	0.4 (0.398-0.405)	trBp01 to trBp02	*/
	optLens50 = 'ET-D75LE50',	/*	0.8 (0.748-0.792)	trBp03 to trBp04	*/
	optLens06 = 'ET-D75LE6',	/*	1.0	to	1.2 (1.006-1.248)	trBp05 to trBp06	*/
	optLens10 = 'ET-D75LE10',	/*	1.4	to	1.9 (1.408-1.888)	trBp07 to trBp09	*/
	optLens20 = 'ET-D75LE20',	/*	1.8	to	2.7 (1.818-2.7164)	trBp08 to trBp11	*/
	optLens30 = 'ET-D75LE30',	/*	2.7	to	5.2 (2.628-5.233)	trBp10 to trBp13	*/
	optLens40 = 'ET-D75LE40',	/*	5.1	to	8.2 (5.07-8.242)	trBp12 to trBp15	*/
	optLens08 = 'ET-D75LE8';	/*	8.2	to	15.4 (8.019-15.469)	trBp14 to trBp16	*/


// coefficient for projection range ===========

var	optLens = [ 'ET-D75LE95', 'ET-D75LE90', 'ET-D75LE50', 'ET-D75LE6', 'ET-D75LE10', 'ET-D75LE20', 'ET-D75LE30', 'ET-D75LE40', 'ET-D75LE8' ];

var	coefAmin = [ 8.783, 8.783, 17.59, 23.1, 32.408, 41.464, 59.818, 114.534, 183.09 ],
	coefBmin = [ -20, -20, 71, 56.6, 85.7, 83.2, 113.14, 157.7, 386.23 ],
	coefAmax = [  , , , 27.7, 41.888, 60.248, 116.01, 182.604, 343.03 ],
	coefBmax = [  , , , 73.6, 108.5, 116.2, 176.47, 161.48, 359.77 ];


// link to throw distance calculator ===========

var	linkLens = [ 'le95', 'le90', 'le50', 'le6', 'le10', 'le20', 'le30', 'le40', 'le8' ],
	linkLens1,
	linkLens2;


// option lens throw ratio range ===========

var	trRange = [
	[ '0.4',  ],
	[ '0.4',  ],
	[ '0.8',  ],
	[ '1.0', '1.2' ],
	[ '1.4', '1.9' ],
	[ '1.8', '2.7' ],
	[ '2.7', '5.2' ],
	[ '5.1', '8.2' ],
	[ '8.2', '15.4' ]
	];


// break point of projection range (throw ratio break point) ===========

		// 'No lens found' (optLens95)
var	trBp01 = 0.398,
		// (optLens95) + (optLens90)
	trBp02 = 0.405,
		// 'No lens found' (optLens95)
	trBp03 = 0.748,
		// (optLens50)
	trBp04 = 0.792,
		// 'No lens found'
	trBp05 = 1.006,
		// optLens06
	trBp06 = 1.248,
		// 'No lens found'
	trBp07 = 1.408,
		// optLens10
	trBp08 = 1.818,
		// optLens10 + optLens20
	trBp09 = 1.888,
		// optLens20
	trBp10 = 2.628,
		// optLens20 + optLens30
	trBp11 = 2.7164,
		// optLens30
	trBp12 = 5.07,
		// optLens30 + optLens40
	trBp13 = 5.233,
		// optLens40
	trBp14 = 8.019,
		// optLens40 + optLens08
	trBp15 = 8.242,
		// optLens08
	trBp16 = 15.469;
		// 'No lens found'


// option lens throw ratio range for canvas indicator ===========

var	trRangeBar = trRange
/*
var	trRangeBar = [
	[ trBp01, trBp02 ],
	[ trBp01, trBp02 ],
	[ trBp03, trBp04 ],
	[ trBp05, trBp06 ],
	[ trBp07, trBp09 ],
	[ trBp08, trBp11 ],
	[ trBp10, trBp12 ],
	[ trBp11, trBp14 ],
	[ trBp13, trBp15 ]
	];
*/


// size limitation ===========

var	scrnSizeMin = 70,
	scrnSizeMax = 1000,
	scrnSizeMinMm = scrnSizeMin * 25.4,
	scrnSizeMaxMm = scrnSizeMax * 25.4;

	scrnSizeMax = String( scrnSizeMax ).replace( /(\d)(?=(\d\d\d)+(?!\d))/g, '$1,' );
	scrnSizeMinMm = String( scrnSizeMinMm ).replace( /(\d)(?=(\d\d\d)+(?!\d))/g, '$1,' );
	scrnSizeMaxMm = String( scrnSizeMaxMm ).replace( /(\d)(?=(\d\d\d)+(?!\d))/g, '$1,' );


// maximum projection distance limitation: ET-D75LE8 ===========

var	maxDistMm169 = 205458,
	maxDistFt169 = parseFloat( Math.round ( maxDistMm169 / 304.8 * 100 ) / 100 );

	maxDistMm169Str = String( maxDistMm169 ).replace( /(\d)(?=(\d\d\d)+(?!\d))/g, '$1,' );



// CALCULATION FOR SUITABLE LENS /////////////////////////


function lensFinder() {



	var	stLens1 = '',
		stLens2 = '',
		trMin1 = 0,
		trMax1 = 0,
		trLens1 = 0,
		trMin2 = 0,
		trMax2 = 0,
		trLens2 = 0,
		coefAmin1 = 0,
		coefBmin1 = 0,
		coefAmax1 = 0,
		coefBmax1 = 0,
		coefAmin2 = 0,
		coefBmin2 = 0,
		coefAmax2 = 0,
		coefBmax2 = 0;


	// aspect ratio

	var	aspectRatio = (function() {

		var	aspect = document.getElementsByName('aspect');

		for ( var i = 0; i < aspect.length; i++ ) {

			if ( aspect[i].checked == true ) {
				var	aspectRatio = aspect[i].value;
				return aspectRatio;		// ESSENTIAL
			}
		}

	}());


	// calculation

	if ( throwRatio < trBp01 ) {
		stLens1 = 'No lens was found.';
		linkLens1 = linkLens[0];
	} else if ( throwRatio <= trBp02 ) {
		// ET-D75LE95: Screen size limitaion
		if ( Math.round(scrnWidth) < Math.round( 120 / coefScrnPortion * 25.4 ) || Math.round( 600 / coefScrnPortion * 25.4 ) < Math.round(scrnWidth) ) {
			stLens1 = 'No lens was found.';
			linkLens1 = linkLens[0];
		} else {
			// lens1
			stLens1 = optLens95;
			linkLens1 = linkLens[0];
			trMin1 = trRange[0][0];
			coefAmin1 = coefAmin[0];
			coefBmin1 = coefBmin[0];
			// lens2
			stLens2 = optLens90;
			linkLens2 = linkLens[1];
			trMin2 = trRange[1][0];
			coefAmin2 = coefAmin[1];
			coefBmin2 = coefBmin[1];
		}
	} else if ( throwRatio < trBp03 ) {
		stLens1 = 'No lens was found.';
		linkLens1 = linkLens[0];
	} else if ( throwRatio <= trBp04 ) {
		stLens1 = optLens50;
//		stLens2 = 'Also check the ' + optLens90 + '.';
		linkLens1 = linkLens[2];
		trMin1 = trRange[2][0];
		coefAmin1 = coefAmin[2];
		coefBmin1 = coefBmin[2];
	} else if ( throwRatio < trBp05 ) {
		stLens1 = 'No lens was found.';
		linkLens1 = linkLens[3];
	} else if ( throwRatio <= trBp06 ) {
		stLens1 = optLens06;
		linkLens1 = linkLens[3];
		trMin1 = trRange[3][0];
		trMax1 = trRange[3][1];
		coefAmin1 = coefAmin[3];
		coefBmin1 = coefBmin[3];
		coefAmax1 = coefAmax[3];
		coefBmax1 = coefBmax[3];
	} else if ( throwRatio < trBp07 ) {
		stLens1 = 'No lens was found.';
		linkLens1 = linkLens[3];
	} else if ( throwRatio <= trBp08 ) {
		stLens1 = optLens10;
		linkLens1 = linkLens[4];
		trMin1 = trRange[4][0];
		trMax1 = trRange[4][1];
		coefAmin1 = coefAmin[4];
		coefBmin1 = coefBmin[4];
		coefAmax1 = coefAmax[4];
		coefBmax1 = coefBmax[4];
	} else if ( throwRatio <= trBp09 ) {
		// lens1
		stLens1 = optLens10;
		linkLens1 = linkLens[4];
		trMin1 = trRange[4][0];
		trMax1 = trRange[4][1];
		coefAmin1 = coefAmin[4];
		coefBmin1 = coefBmin[4];
		coefAmax1 = coefAmax[4];
		coefBmax1 = coefBmax[4];
		// lens2
		stLens2 = optLens20;
		linkLens2 = linkLens[5];
		trMin2 = trRange[5][0];
		trMax2 = trRange[5][1];
		coefAmin2 = coefAmin[5];
		coefBmin2 = coefBmin[5];
		coefAmax2 = coefAmax[5];
		coefBmax2 = coefBmax[5];
	} else if ( throwRatio <= trBp10 ) {
		stLens1 = optLens20;
		linkLens1 = linkLens[5];
		trMin1 = trRange[5][0];
		trMax1 = trRange[5][1];
		coefAmin1 = coefAmin[5];
		coefBmin1 = coefBmin[5];
		coefAmax1 = coefAmax[5];
		coefBmax1 = coefBmax[5];
	} else if ( throwRatio <= trBp11 ) {
		// lens1
		stLens1 = optLens20;
		linkLens1 = linkLens[5];
		trMin1 = trRange[5][0];
		trMax1 = trRange[5][1];
		coefAmin1 = coefAmin[5];
		coefBmin1 = coefBmin[5];
		coefAmax1 = coefAmax[5];
		coefBmax1 = coefBmax[5];
		// lens2
		stLens2 = optLens30;
		linkLens2 = linkLens[6];
		trMin2 = trRange[6][0];
		trMax2 = trRange[6][1];
		coefAmin2 = coefAmin[6];
		coefBmin2 = coefBmin[6];
		coefAmax2 = coefAmax[6];
		coefBmax2 = coefBmax[6];
	} else if ( throwRatio <= trBp12 ) {
		stLens1 = optLens30;
		linkLens1 = linkLens[6];
		trMin1 = trRange[6][0];
		trMax1 = trRange[6][1];
		coefAmin1 = coefAmin[6];
		coefBmin1 = coefBmin[6];
		coefAmax1 = coefAmax[6];
		coefBmax1 = coefBmax[6];
	} else if ( throwRatio <= trBp13 ) {
		// lens1
		stLens1 = optLens30;
		linkLens1 = linkLens[6];
		trMin1 = trRange[6][0];
		trMax1 = trRange[6][1];
		coefAmin1 = coefAmin[6];
		coefBmin1 = coefBmin[6];
		coefAmax1 = coefAmax[6];
		coefBmax1 = coefBmax[6];
		// lens2
		stLens2 = optLens40;
		linkLens2 = linkLens[7];
		trMin2 = trRange[7][0];
		trMax2 = trRange[7][1];
		coefAmin2 = coefAmin[7];
		coefBmin2 = coefBmin[7];
		coefAmax2 = coefAmax[7];
		coefBmax2 = coefBmax[7];
	} else if ( throwRatio <= trBp14 ) {
		stLens1 = optLens40;
		linkLens1 = linkLens[7];
		trMin1 = trRange[7][0];
		trMax1 = trRange[7][1];
		coefAmin1 = coefAmin[7];
		coefBmin1 = coefBmin[7];
		coefAmax1 = coefAmax[7];
		coefBmax1 = coefBmax[7];
	} else if ( throwRatio <= trBp15 ) {
		// lens1
		stLens1 = optLens40;
		linkLens1 = linkLens[7];
		trMin1 = trRange[7][0];
		trMax1 = trRange[7][1];
		coefAmin1 = coefAmin[7];
		coefBmin1 = coefBmin[7];
		coefAmax1 = coefAmax[7];
		coefBmax1 = coefBmax[7];
		// lens2
		stLens2 = optLens08;
		linkLens2 = linkLens[8];
		trMin2 = trRange[8][0];
		trMax2 = trRange[8][1];
		coefAmin2 = coefAmin[8];
		coefBmin2 = coefBmin[8];
		coefAmax2 = coefAmax[8];
		coefBmax2 = coefBmax[8];
	} else if ( throwRatio <= trBp16 ) {
		stLens1 = optLens08;
		linkLens1 = linkLens[8];
		trMin1 = trRange[8][0];
		trMax1 = trRange[8][1];
		coefAmin1 = coefAmin[8];
		coefBmin1 = coefBmin[8];
		coefAmax1 = coefAmax[8];
		coefBmax1 = coefBmax[8];
	}
	else {
		stLens1 = 'No lens was found.';
		linkLens1 = linkLens[8];
	}

	var	pjRange1 = 0,
		pjRange1Ft = 0,
		pjRmin1 = 0,
		pjRmin1Ft = 0,
		pjRmax1 = 0,
		pjRmax1Ft = 0,
		pjRange2 = 0,
		pjRange2Ft = 0,
		pjRmin2 = 0,
		pjRmin2Ft = 0,
		pjRmax2 = 0,
		pjRmax2Ft = 0;

	// projection range

		pjRmin1 = Math.round( scrnDiag / 25.4 * coefAmin1 - coefBmin1 );
		pjRmin1Ft = Math.round(( scrnDiag / 25.4 * coefAmin1 - coefBmin1 ) / 25.4 / 12 * 100 ) / 100;
		pjRmax1 = Math.round( scrnDiag / 25.4 * coefAmax1 - coefBmax1 );
		pjRmax1Ft = Math.round(( scrnDiag / 25.4 * coefAmax1 - coefBmax1 ) / 25.4 / 12 * 100 ) / 100;
		pjRmin2 = Math.round( scrnDiag / 25.4 * coefAmin2 - coefBmin2 );
		pjRmin2Ft = Math.round(( scrnDiag / 25.4 * coefAmin2 - coefBmin2 ) / 25.4 / 12 * 100 ) / 100;
		pjRmax2 = Math.round( scrnDiag / 25.4 * coefAmax2 - coefBmax2 );
		pjRmax2Ft = Math.round(( scrnDiag / 25.4 * coefAmax2 - coefBmax2 ) / 25.4 / 12 * 100 ) / 100;

		// zoom lens

		if ( pjRmax1 != 0 ) {

			trLens1 = ' (' + trMin1 + '–' + trMax1 + ':1)';
			pjRange1 = pjRmin1.toLocaleString() + '–' + pjRmax1.toLocaleString() + ' millimeters';
			pjRange1Ft = pjRmin1Ft.toLocaleString() + '–' + pjRmax1Ft.toLocaleString() + ' feet';

			if ( pjRmin2 != 0 ) {
				trLens2 = ' (' + trMin2 + '–' + trMax2 + ':1)';
				pjRange2 = pjRmin2.toLocaleString() + '–' + pjRmax2.toLocaleString() + ' millimeters';
				pjRange2Ft = pjRmin2Ft.toLocaleString() + '–' + pjRmax2Ft.toLocaleString() + ' feet';
			}

		}

		// fixed lens or no suitable lens

		else if ( pjRmin1 != 0 ) {
			trLens1 = ' (' + trMin1 + ':1)';
			pjRange1 = pjRmin1 + ' millimeters';
			pjRange1Ft = pjRmin1Ft + ' feet';

			if ( pjRmin2 != 0 ) {
				trLens2 = ' (' + trMin2 + ':1)';
				pjRange2 = pjRmin2 + ' millimeters';
				pjRange2Ft = pjRmin2Ft + ' feet';
			}

		}


	var	stLensH2= document.getElementById('option-lens-title');
		stLensDiv1 = document.getElementById('option-lens-1'),
		stLensDiv2 = document.getElementById('option-lens-2'),
		throwRatioDiv = document.getElementById('calculated-throw-ratio'),
		pjRangeDiv = document.getElementById('projection-range-title'),
		pjRangeDiv1 = document.getElementById('projection-range-1'),
		pjRangeDiv2 = document.getElementById('projection-range-2'),
		elBr1 = document.createElement('br'),
		elBr2 = document.createElement('br'),
		aLens1 = document.createElement('a'),
		aLens2 = document.createElement('a'),
		// for recalculation
		stLensOldTitle = document.getElementById('option-lens-title').firstChild,
		stLensOldText1 = document.getElementById('option-lens-1').firstChild,
		stLensOldText2 = document.getElementById('option-lens-2').firstChild,
		throwRatioOldText = document.getElementById('calculated-throw-ratio').firstChild,
		pjRangeOldTitle = document.getElementById('projection-range-title').firstChild,
		pjRangeOldText1 = document.getElementById('projection-range-1').firstChild,
		pjRangeOldText2 = document.getElementById('projection-range-2').firstChild,
		// results
		stLensTitle = document.createTextNode('Suitable Lens: ');
		if ( stLens1 == 'ET-D75LE50' ) {
			var	stLensText1 = document.createTextNode('The ' + stLens1 + ' can be suitable.');
		} else {
			var	stLensText1 = document.createTextNode(stLens1);
		}
	var	stLensText2 = document.createTextNode(stLens2),
		// link to throw distance calculator
		linkCalc1 = '../largevenue/dw11k' + linkLens1 + '.html?' + encodeURIComponent(scrnSize) + '&' + encodeURIComponent(aspectRatio) + '&' + encodeURIComponent(scrnUnit) + '&' + encodeURIComponent(scrnPortion),
		linkCalc2 = '../largevenue/dw11k' + linkLens2 + '.html?' + encodeURIComponent(scrnSize) + '&' + encodeURIComponent(aspectRatio) + '&' + encodeURIComponent(scrnUnit) + '&' + encodeURIComponent(scrnPortion);

		aLens1.href = linkCalc1;
		aLens2.href = linkCalc2;
		throwRatioText = document.createTextNode('Approximate throw ratio of this condition: ' + (Math.round(throwRatio * 10) / 10).toFixed(1) + ':1');
		pjRangeTitle = document.createTextNode('Projection distance for the requested image size: ');
		lensModel1 = document.createTextNode(stLens1 + trLens1 + ': ');
		pjRangeText1 = document.createTextNode(pjRange1 +'; ' + pjRange1Ft);
		lensModel2 = document.createTextNode(stLens2 + trLens2 + ': ');
		pjRangeText2 = document.createTextNode(pjRange2 +'; ' + pjRange2Ft);


	// reset on change

	if ( stLensOldText1 != null ) {

		stLensH2.removeChild(stLensOldTitle);
		stLensDiv1.removeChild(stLensOldText1);
		throwRatioDiv.removeChild(throwRatioOldText);

		if ( pjRangeOldTitle != null ) {
		pjRangeDiv.removeChild(pjRangeOldTitle);

			while ( pjRangeDiv1.lastChild ) {
			  pjRangeDiv1.removeChild(pjRangeDiv1.lastChild);
			}

			if ( stLensOldText2 != null ) {
				stLensDiv2.removeChild(stLensOldText2);
				while ( pjRangeDiv2.lastChild ) {
				  pjRangeDiv2.removeChild(pjRangeDiv2.lastChild);
				}

			}

		}

	}


	// OUTPUT ////////////

	stLensH2.appendChild(stLensTitle);	// Suitable Lens:
	throwRatioDiv.appendChild(throwRatioText);
	if ( stLens1 == 'No lens was found.' ) {

		stLensDiv1.appendChild(aLens1);		// lens model with link 1
		aLens1.appendChild(stLensText1);	// lens model 1

	} else if ( stLens1 != '' ) {

		stLensDiv1.appendChild(aLens1);		// lens model with link 1
		aLens1.appendChild(stLensText1);	// lens model 1
		pjRangeDiv.appendChild(pjRangeTitle);
		pjRangeDiv1.appendChild(lensModel1);
		pjRangeDiv1.appendChild(elBr1);
		pjRangeDiv1.appendChild(pjRangeText1);

		if ( stLens2 != '' ) {

			stLensDiv2.appendChild(aLens2);		// lens model with link 2
			aLens2.appendChild(stLensText2);	// lens model 2
			pjRangeDiv2.appendChild(lensModel2);
			pjRangeDiv2.appendChild(elBr2);
			pjRangeDiv2.appendChild(pjRangeText2);

		}

	}



}