/* =================================
	COEFFICIENT FOR LENS FINDER CALCULATION
	PT-EX16K
================================= */


// definition for optional lens ===========

var	optLens01 = 'ET-ELW03',	/*	0.8 (0.736-0.815)	trBp01 to trBp02	*/
	optLens02 = 'ET-ELW06',	/*	1.2 to 1.5 (1.119-1.552)	trBp03 to trBp06	*/
	optLens03 = 'ET-ELW02',	/*	1.4 to 1.8	(1.316-1.849)	trBp04 to trBp08	*/
	optLens04 = 'ET-ELW04',	/*	1.5 to 2.0	(1.411-2.056)	trBp05 to trBp09	*/
	optLens05 = 'ET-ELS02',	/*	2.0 to 2.6	(1.815-2.567)	trBp07 to trBp11	*/
	optLens06 = 'ET-ELS03',	/*	2.6 to 3.5	(2.440-3.56)	trBp10 to trBp13	*/
	optLens07 = 'ET-ELM01',	/*	3.5 to 4.5	(3.423-4.603)	trBp12 to trBp15	*/
	optLens08 = 'ET-ELT02',	/*	4.4 to 6.2	(4.347-6.481)	trBp14 to trBp17	*/
	optLens09 = 'ET-ELT03';	/*	6.3 to 9.0	(6.078-9.315)	trBp16 to trBp18	*/


// coefficient for projection range ===========

var	optLens = [ 'ET-ELW03', 'ET-ELW06', 'ET-ELW02', 'ET-ELW04', 'ET-ELS02', 'ET-ELS03', 'ET-ELM01', 'ET-ELT02', 'ET-ELT03' ];

var	coefAmin = [ 16.666, 24.389, 28.982, 32.144, 42.086, 53.914, 69.44, 87.982, 122.945 ],
	coefBmin = [ 67.361, 65.097, 89.642, 139.232, 208.493, 175.76, -86.8, -221.978, -350.492 ],
	coefAmax = [  , 31.71, 37.722, 41.988, 54.69, 72.616, 89.871, 123.396, 180.688 ],
	coefBmax = [  , 99.56, 89.627, 123.04, 203.992, 163.096, -86.816, -173.741, -343.253 ];


// link to throw distance calculator ===========

var	linkLens = [ 'elw03', 'elw06', 'elw02', 'elw04', 'els02', 'els03', 'elm01', 'elt02', 'elt03' ],
	linkLens1,
	linkLens2,
	linkLens3;


// option lens throw ratio range ===========

var	trRange = [
	[ '0.8',  ],
	[ '1.2', '1.5' ],
	[ '1.4', '1.8' ],
	[ '1.5', '2.0' ],
	[ '2.0', '2.6' ],
	[ '2.6', '3.5' ],
	[ '3.5', '4.5' ],
	[ '4.4', '6.2' ],
	[ '6.3', '9.0' ]
	];


// break point of projection range (throw ratio break point) ===========

		// 'No lens found'
var	trBp01 = 0.736,
		// optLens01
	trBp02 = 0.815,
		// 'No lens found'
	trBp03 = 1.119,
		// optLens02
	trBp04 = 1.316,
		// optLens02 + optLens03
	trBp05 = 1.411,
		// optLens02 + optLens03 + optLens04
	trBp06 = 1.552,
		// optLens03 + optLens04
	trBp07 = 1.815,
		// optLens03 + optLens04 + optLens05
	trBp08 = 1.849,
		// optLens04 + optLens05
	trBp09 = 2.056,
		// optLens05
	trBp10 = 2.440,
		// optLens05 + optLens06
	trBp11 = 2.567,
		// optLens06
	trBp12 = 3.423,
		// optLens06 + optLens07
	trBp13 = 3.56,
		// optLens07
	trBp14 = 4.347,
		// optLens07 + optLens08
	trBp15 = 4.603,
		// optLens08
	trBp16 = 6.078,
		// optLens08 + optLens09
	trBp17 = 6.481,
		// optLens09
	trBp18 = 9.315;
		// 'No lens found'


// option lens throw ratio range for canvas indicator ===========

var	trRangeBar = trRange
/*
var	trRangeBar = [
	[ trBp01, trBp02 ],
	[ trBp03, trBp06 ],
	[ trBp04, trBp08 ],
	[ trBp05, trBp09 ],
	[ trBp07, trBp11 ],
	[ trBp10, trBp13 ],
	[ trBp12, trBp15 ],
	[ trBp14, trBp17],
	[ trBp16, trBp18 ]
	];
*/


// size limitation ===========

var	scrnSizeMin = 40,
	scrnSizeMax = 600,
	scrnSizeMinMm = scrnSizeMin * 25.4,
	scrnSizeMaxMm = scrnSizeMax * 25.4;

	scrnSizeMax = String( scrnSizeMax ).replace( /(\d)(?=(\d\d\d)+(?!\d))/g, '$1,' );
	scrnSizeMinMm = String( scrnSizeMinMm ).replace( /(\d)(?=(\d\d\d)+(?!\d))/g, '$1,' );
	scrnSizeMaxMm = String( scrnSizeMaxMm ).replace( /(\d)(?=(\d\d\d)+(?!\d))/g, '$1,' );


// CALCULATION FOR SUITABLE LENS /////////////////////////


function lensFinder() {



	var	stLens1 = '',
		stLens2 = '',
		stLens3 = '',
		trMin1 = 0,
		trMax1 = 0,
		trLens1 = 0,
		trMin2 = 0,
		trMax2 = 0,
		trLens2 = 0,
		trMin3 = 0,
		trMax3 = 0,
		trLens3 = 0,
		coefAmin1 = 0,
		coefBmin1 = 0,
		coefAmax1 = 0,
		coefBmax1 = 0,
		coefAmin2 = 0,
		coefBmin2 = 0,
		coefAmax2 = 0,
		coefBmax2 = 0,
		coefAmin3 = 0,
		coefBmin3 = 0,
		coefAmax3 = 0,
		coefBmax3 = 0;


	// aspect ratio

	var	aspectRatio = (function() {

		var	aspect = document.getElementsByName('aspect');

		for ( var i = 0; i < aspect.length; i++ ) {

			if ( aspect[i].checked == true ) {
				var	aspectRatio = aspect[i].value;
				return aspectRatio;		// ESSENTIAL
			}
		}

	}());


	// calculation

	if ( throwRatio < trBp01 ) {
		stLens1 = 'No lens was found.';
		linkLens1 = linkLens[0];
	} else if ( throwRatio <= trBp02 ) {
		stLens1 = optLens01;
//		stLens2 = 'Also check the ' + optLens90 + '.';
		linkLens1 = linkLens[0];
		trMin1 = trRange[0][0];
		coefAmin1 = coefAmin[0];
		coefBmin1 = coefBmin[0];
	} else if ( throwRatio < trBp03 ) {
		stLens1 = 'No lens was found.';
		linkLens1 = linkLens[2];
	} else if ( throwRatio <= trBp04 ) {
		stLens1 = optLens02;
		linkLens1 = linkLens[1];
		trMin1 = trRange[1][0];
		trMax1 = trRange[1][1];
		coefAmin1 = coefAmin[1];
		coefBmin1 = coefBmin[1];
		coefAmax1 = coefAmax[1];
		coefBmax1 = coefBmax[1];
	} else if ( throwRatio <= trBp05 ) {
		// lens1
		stLens1 = optLens02;
		linkLens1 = linkLens[1];
		trMin1 = trRange[1][0];
		trMax1 = trRange[1][1];
		coefAmin1 = coefAmin[1];
		coefBmin1 = coefBmin[1];
		coefAmax1 = coefAmax[1];
		coefBmax1 = coefBmax[1];
		// lens2
		stLens2 = optLens03;
		linkLens2 = linkLens[2];
		trMin2 = trRange[2][0];
		trMax2 = trRange[2][1];
		coefAmin2 = coefAmin[2];
		coefBmin2 = coefBmin[2];
		coefAmax2 = coefAmax[2];
		coefBmax2 = coefBmax[2];
	} else if ( throwRatio <= trBp06 ) {
		// lens1
		stLens1 = optLens02;
		linkLens1 = linkLens[1];
		trMin1 = trRange[1][0];
		trMax1 = trRange[1][1];
		coefAmin1 = coefAmin[1];
		coefBmin1 = coefBmin[1];
		coefAmax1 = coefAmax[1];
		coefBmax1 = coefBmax[1];
		// lens2
		stLens2 = optLens03;
		linkLens2 = linkLens[2];
		trMin2 = trRange[2][0];
		trMax2 = trRange[2][1];
		coefAmin2 = coefAmin[2];
		coefBmin2 = coefBmin[2];
		coefAmax2 = coefAmax[2];
		coefBmax2 = coefBmax[2];
		// lens3
		stLens3 = optLens04;
		linkLens3 = linkLens[3];
		trMin3 = trRange[3][0];
		trMax3 = trRange[3][1];
		coefAmin3 = coefAmin[3];
		coefBmin3 = coefBmin[3];
		coefAmax3 = coefAmax[3];
		coefBmax3 = coefBmax[3];
	} else if ( throwRatio <= trBp07 ) {
		// lens1
		stLens1 = optLens03;
		linkLens1 = linkLens[2];
		trMin1 = trRange[2][0];
		trMax1 = trRange[2][1];
		coefAmin1 = coefAmin[2];
		coefBmin1 = coefBmin[2];
		coefAmax1 = coefAmax[2];
		coefBmax1 = coefBmax[2];
		// lens2
		stLens2 = optLens04;
		linkLens2 = linkLens[3];
		trMin2 = trRange[3][0];
		trMax2 = trRange[3][1];
		coefAmin2 = coefAmin[3];
		coefBmin2 = coefBmin[3];
		coefAmax2 = coefAmax[3];
		coefBmax2 = coefBmax[3];
	} else if ( throwRatio <= trBp08 ) {
		// lens1
		stLens1 = optLens03;
		linkLens1 = linkLens[2];
		trMin1 = trRange[2][0];
		trMax1 = trRange[2][1];
		coefAmin1 = coefAmin[2];
		coefBmin1 = coefBmin[2];
		coefAmax1 = coefAmax[2];
		coefBmax1 = coefBmax[2];
		// lens2
		stLens2 = optLens04;
		linkLens2 = linkLens[3];
		trMin2 = trRange[3][0];
		trMax2 = trRange[3][1];
		coefAmin2 = coefAmin[3];
		coefBmin2 = coefBmin[3];
		coefAmax2 = coefAmax[3];
		coefBmax2 = coefBmax[3];
		// lens3
		stLens3 = optLens05;
		linkLens3 = linkLens[4];
		trMin3 = trRange[4][0];
		trMax3 = trRange[4][1];
		coefAmin3 = coefAmin[4];
		coefBmin3 = coefBmin[4];
		coefAmax3 = coefAmax[4];
		coefBmax3 = coefBmax[4];
	} else if ( throwRatio <= trBp09 ) {
		// lens1
		stLens1 = optLens04;
		linkLens1 = linkLens[3];
		trMin1 = trRange[3][0];
		trMax1 = trRange[3][1];
		coefAmin1 = coefAmin[3];
		coefBmin1 = coefBmin[3];
		coefAmax1 = coefAmax[3];
		coefBmax1 = coefBmax[3];
		// lens2
		stLens2 = optLens05;
		linkLens2 = linkLens[4];
		trMin2 = trRange[4][0];
		trMax2 = trRange[4][1];
		coefAmin2 = coefAmin[4];
		coefBmin2 = coefBmin[4];
		coefAmax2 = coefAmax[4];
		coefBmax2 = coefBmax[4];
	} else if ( throwRatio <= trBp10 ) {
		stLens1 = optLens05;
		linkLens1 = linkLens[4];
		trMin1 = trRange[4][0];
		trMax1 = trRange[4][1];
		coefAmin1 = coefAmin[4];
		coefBmin1 = coefBmin[4];
		coefAmax1 = coefAmax[4];
		coefBmax1 = coefBmax[4];
	} else if ( throwRatio <= trBp11 ) {
		// lens1
		stLens1 = optLens05;
		linkLens1 = linkLens[4];
		trMin1 = trRange[4][0];
		trMax1 = trRange[4][1];
		coefAmin1 = coefAmin[4];
		coefBmin1 = coefBmin[4];
		coefAmax1 = coefAmax[4];
		coefBmax1 = coefBmax[4];
		// lens2
		stLens2 = optLens06;
		linkLens2 = linkLens[5];
		trMin2 = trRange[5][0];
		trMax2 = trRange[5][1];
		coefAmin2 = coefAmin[5];
		coefBmin2 = coefBmin[5];
		coefAmax2 = coefAmax[5];
		coefBmax2 = coefBmax[5];
	} else if ( throwRatio <= trBp12 ) {
		stLens1 = optLens06;
		linkLens1 = linkLens[5];
		trMin1 = trRange[5][0];
		trMax1 = trRange[5][1];
		coefAmin1 = coefAmin[5];
		coefBmin1 = coefBmin[5];
		coefAmax1 = coefAmax[5];
		coefBmax1 = coefBmax[5];
	} else if ( throwRatio <= trBp13 ) {
		// lens1
		stLens1 = optLens06;
		linkLens1 = linkLens[5];
		trMin1 = trRange[5][0];
		trMax1 = trRange[5][1];
		coefAmin1 = coefAmin[5];
		coefBmin1 = coefBmin[5];
		coefAmax1 = coefAmax[5];
		coefBmax1 = coefBmax[5];
		// lens2
		stLens2 = optLens07;
		linkLens2 = linkLens[6];
		trMin2 = trRange[6][0];
		trMax2 = trRange[6][1];
		coefAmin2 = coefAmin[6];
		coefBmin2 = coefBmin[6];
		coefAmax2 = coefAmax[6];
		coefBmax2 = coefBmax[6];
	} else if ( throwRatio <= trBp14 ) {
		stLens1 = optLens07;
		linkLens1 = linkLens[6];
		trMin1 = trRange[6][0];
		trMax1 = trRange[6][1];
		coefAmin1 = coefAmin[6];
		coefBmin1 = coefBmin[6];
		coefAmax1 = coefAmax[6];
		coefBmax1 = coefBmax[6];
	} else if ( throwRatio <= trBp15 ) {
		// lens1
		stLens1 = optLens07;
		linkLens1 = linkLens[6];
		trMin1 = trRange[6][0];
		trMax1 = trRange[6][1];
		coefAmin1 = coefAmin[6];
		coefBmin1 = coefBmin[6];
		coefAmax1 = coefAmax[6];
		coefBmax1 = coefBmax[6];
		// lens2
		stLens2 = optLens08;
		linkLens2 = linkLens[7];
		trMin2 = trRange[7][0];
		trMax2 = trRange[7][1];
		coefAmin2 = coefAmin[7];
		coefBmin2 = coefBmin[7];
		coefAmax2 = coefAmax[7];
		coefBmax2 = coefBmax[7];
	} else if ( throwRatio <= trBp16 ) {
		stLens1 = optLens08;
		linkLens1 = linkLens[7];
		trMin1 = trRange[7][0];
		trMax1 = trRange[7][1];
		coefAmin1 = coefAmin[7];
		coefBmin1 = coefBmin[7];
		coefAmax1 = coefAmax[7];
		coefBmax1 = coefBmax[7];
	} else if ( throwRatio <= trBp17 ) {
		// lens1
		stLens1 = optLens08;
		linkLens1 = linkLens[7];
		trMin1 = trRange[7][0];
		trMax1 = trRange[7][1];
		coefAmin1 = coefAmin[7];
		coefBmin1 = coefBmin[7];
		coefAmax1 = coefAmax[7];
		coefBmax1 = coefBmax[7];
		// lens2
		stLens2 = optLens09;
		linkLens2 = linkLens[8];
		trMin2 = trRange[8][0];
		trMax2 = trRange[8][1];
		coefAmin2 = coefAmin[8];
		coefBmin2 = coefBmin[8];
		coefAmax2 = coefAmax[8];
		coefBmax2 = coefBmax[8];
	} else if ( throwRatio <= trBp18 ) {
		stLens1 = optLens09
		linkLens1 = linkLens[8];
		trMin1 = trRange[8][0];
		trMax1 = trRange[8][1];
		coefAmin1 = coefAmin[8];
		coefBmin1 = coefBmin[8];
		coefAmax1 = coefAmax[8];
		coefBmax1 = coefBmax[8];
	}
	else {
		stLens1 = 'No lens was found.';
		linkLens1 = linkLens[7];
	}

	var	pjRange1 = 0,
		pjRange1Ft = 0,
		pjRmin1 = 0,
		pjRmin1Ft = 0,
		pjRmax1 = 0,
		pjRmax1Ft = 0,
		pjRange2 = 0,
		pjRange2Ft = 0,
		pjRmin2 = 0,
		pjRmin2Ft = 0,
		pjRmax2 = 0,
		pjRmax2Ft = 0,
		pjRange3 = 0,
		pjRange3Ft = 0,
		pjRmin3 = 0,
		pjRmin3Ft = 0,
		pjRmax3 = 0,
		pjRmax3Ft = 0;

	// projection range

		pjRmin1 = Math.round( scrnDiag / 25.4 * coefAmin1 - coefBmin1 );
		pjRmin1Ft = Math.round(( scrnDiag / 25.4 * coefAmin1 - coefBmin1 ) / 25.4 / 12 * 100 ) / 100;
		pjRmax1 = Math.round( scrnDiag / 25.4 * coefAmax1 - coefBmax1 );
		pjRmax1Ft = Math.round(( scrnDiag / 25.4 * coefAmax1 - coefBmax1 ) / 25.4 / 12 * 100 ) / 100;
		pjRmin2 = Math.round( scrnDiag / 25.4 * coefAmin2 - coefBmin2 );
		pjRmin2Ft = Math.round(( scrnDiag / 25.4 * coefAmin2 - coefBmin2 ) / 25.4 / 12 * 100 ) / 100;
		pjRmax2 = Math.round( scrnDiag / 25.4 * coefAmax2 - coefBmax2 );
		pjRmax2Ft = Math.round(( scrnDiag / 25.4 * coefAmax2 - coefBmax2 ) / 25.4 / 12 * 100 ) / 100;
		pjRmin3 = Math.round( scrnDiag / 25.4 * coefAmin3 - coefBmin3 );
		pjRmin3Ft = Math.round(( scrnDiag / 25.4 * coefAmin3 - coefBmin3 ) / 25.4 / 12 * 100 ) / 100;
		pjRmax3 = Math.round( scrnDiag / 25.4 * coefAmax3 - coefBmax3 );
		pjRmax3Ft = Math.round(( scrnDiag / 25.4 * coefAmax3 - coefBmax3 ) / 25.4 / 12 * 100 ) / 100;

		// zoom lens

		if ( pjRmax1 != 0 ) {

			trLens1 = ' (' + trMin1 + '–' + trMax1 + ':1)';
			pjRange1 = pjRmin1.toLocaleString() + '–' + pjRmax1.toLocaleString() + ' millimeters';
			pjRange1Ft = pjRmin1Ft.toLocaleString() + '–' + pjRmax1Ft.toLocaleString() + ' feet';

			if ( pjRmin2 != 0 ) {
				trLens2 = ' (' + trMin2 + '–' + trMax2 + ':1)';
				pjRange2 = pjRmin2.toLocaleString() + '–' + pjRmax2.toLocaleString() + ' millimeters';
				pjRange2Ft = pjRmin2Ft.toLocaleString() + '–' + pjRmax2Ft.toLocaleString() + ' feet';

				if ( pjRmin3 != 0 ) {
					trLens3 = ' (' + trMin3 + '–' + trMax3 + ':1)';
					pjRange3 = pjRmin3.toLocaleString() + '–' + pjRmax3.toLocaleString() + ' millimeters';
					pjRange3Ft = pjRmin3Ft.toLocaleString() + '–' + pjRmax3Ft.toLocaleString() + ' feet';
				}

			}

		}

		// fixed lens or no suitable lens

		else if ( pjRmin1 != 0 ) {
			trLens1 = ' (' + trMin1 + ':1)';
			pjRange1 = pjRmin1 + ' millimeters';
			pjRange1Ft = pjRmin1Ft + ' feet';
		}


	var	stLensH2= document.getElementById('option-lens-title');
		stLensDiv1 = document.getElementById('option-lens-1'),
		stLensDiv2 = document.getElementById('option-lens-2'),
		stLensDiv3 = document.getElementById('option-lens-3'),
		throwRatioDiv = document.getElementById('calculated-throw-ratio'),
		pjRangeDiv = document.getElementById('projection-range-title'),
		pjRangeDiv1 = document.getElementById('projection-range-1'),
		pjRangeDiv2 = document.getElementById('projection-range-2'),
		pjRangeDiv3 = document.getElementById('projection-range-3'),
		elBr1 = document.createElement('br'),
		elBr2 = document.createElement('br'),
		elBr3 = document.createElement('br'),
		aLens1 = document.createElement('a'),
		aLens2 = document.createElement('a'),
		aLens3 = document.createElement('a'),
		// for recalculation
		stLensOldTitle = document.getElementById('option-lens-title').firstChild,
		stLensOldText1 = document.getElementById('option-lens-1').firstChild,
		stLensOldText2 = document.getElementById('option-lens-2').firstChild,
		stLensOldText3 = document.getElementById('option-lens-3').firstChild,
		throwRatioOldText = document.getElementById('calculated-throw-ratio').firstChild,
		pjRangeOldTitle = document.getElementById('projection-range-title').firstChild,
		pjRangeOldText1 = document.getElementById('projection-range-1').firstChild,
		pjRangeOldText2 = document.getElementById('projection-range-2').firstChild,
		pjRangeOldText3 = document.getElementById('projection-range-3').firstChild,
		// results
		stLensTitle = document.createTextNode('Suitable Lens: ');
		if ( stLens1 == 'ET-ELW03' ) {
			var	stLensText1 = document.createTextNode('The ' + stLens1 + ' can be suitable.');
		} else {
			var	stLensText1 = document.createTextNode(stLens1);
		}
	var	stLensText2 = document.createTextNode(stLens2),
		stLensText3 = document.createTextNode(stLens3),
		// link to throw distance calculator
		linkCalc1 = '../largevenue/ex16k' + linkLens1 + '.html?' + encodeURIComponent(scrnSize) + '&' + encodeURIComponent(aspectRatio) + '&' + encodeURIComponent(scrnUnit) + '&' + encodeURIComponent(scrnPortion),
		linkCalc2 = '../largevenue/ex16k' + linkLens2 + '.html?' + encodeURIComponent(scrnSize) + '&' + encodeURIComponent(aspectRatio) + '&' + encodeURIComponent(scrnUnit) + '&' + encodeURIComponent(scrnPortion),
		linkCalc3 = '../largevenue/ex16k' + linkLens3 + '.html?' + encodeURIComponent(scrnSize) + '&' + encodeURIComponent(aspectRatio) + '&' + encodeURIComponent(scrnUnit) + '&' + encodeURIComponent(scrnPortion);

		aLens1.href = linkCalc1;
		aLens2.href = linkCalc2,
		aLens3.href = linkCalc3;
		throwRatioText = document.createTextNode('Approximate throw ratio of this condition: ' + (Math.round(throwRatio * 10) / 10).toFixed(1) + ':1');
		pjRangeTitle = document.createTextNode('Projection distance for the requested image size: ');
		lensModel1 = document.createTextNode(stLens1 + trLens1 + ': ');
		pjRangeText1 = document.createTextNode(pjRange1 +'; ' + pjRange1Ft);
		lensModel2 = document.createTextNode(stLens2 + trLens2 + ': ');
		pjRangeText2 = document.createTextNode(pjRange2 +'; ' + pjRange2Ft);
		lensModel3 = document.createTextNode(stLens3 + trLens3 + ': ');
		pjRangeText3 = document.createTextNode(pjRange3 +'; ' + pjRange3Ft);


	// reset on change

	if ( stLensOldText1 != null ) {

		stLensH2.removeChild(stLensOldTitle);
		stLensDiv1.removeChild(stLensOldText1);
		throwRatioDiv.removeChild(throwRatioOldText);

		if ( pjRangeOldTitle != null ) {
		pjRangeDiv.removeChild(pjRangeOldTitle);

			while ( pjRangeDiv1.lastChild ) {
			  pjRangeDiv1.removeChild(pjRangeDiv1.lastChild);
			}

		}

		if ( stLensOldText2 != null ) {

			stLensDiv2.removeChild(stLensOldText2);

			while ( pjRangeDiv2.lastChild ) {
			  pjRangeDiv2.removeChild(pjRangeDiv2.lastChild);

			}

		}
		if ( stLensOldText3 != null ) {

			stLensDiv3.removeChild(stLensOldText3);

			while ( pjRangeDiv3.lastChild ) {
			  pjRangeDiv3.removeChild(pjRangeDiv3.lastChild);

			}

		}

	}


	// OUTPUT ////////////

	stLensH2.appendChild(stLensTitle);	// Suitable Lens:
	throwRatioDiv.appendChild(throwRatioText);
	if ( stLens1 == 'No lens was found.' ) {

		stLensDiv1.appendChild(aLens1);		// lens model with link 1
		aLens1.appendChild(stLensText1);	// lens model 1

	} else if ( stLens1 != '' ) {

		stLensDiv1.appendChild(aLens1);		// lens model with link 1
		aLens1.appendChild(stLensText1);	// lens model 1
		pjRangeDiv.appendChild(pjRangeTitle);
		pjRangeDiv1.appendChild(lensModel1);
		pjRangeDiv1.appendChild(elBr1);
		pjRangeDiv1.appendChild(pjRangeText1);

		if ( stLens2 != '' ) {

			stLensDiv2.appendChild(aLens2);		// lens model with link 2
			aLens2.appendChild(stLensText2);	// lens model 2
			pjRangeDiv2.appendChild(lensModel2);
			pjRangeDiv2.appendChild(elBr2);
			pjRangeDiv2.appendChild(pjRangeText2);

			if ( stLens3 != '' ) {

				stLensDiv3.appendChild(aLens3);		// lens model with link 3
				aLens3.appendChild(stLensText3);	// lens model 3
				pjRangeDiv3.appendChild(lensModel3);
				pjRangeDiv3.appendChild(elBr3);
				pjRangeDiv3.appendChild(pjRangeText3);

			}

		}

	}



}