/* =================================
	THROW DISTANCE METER (CANVAS) - version 9 - @2x
================================= */

// preparation ===========

window.addEventListener('load', eventWindowLoaded, false);

function eventWindowLoaded() {
   canvasApp();
}

// definition for optional lens ===========

function canvasApp() {

	var	theCanvas = document.getElementById('throw-ratio-meter'),
		context = theCanvas.getContext('2d'),
		canvasHeight = parseInt(trRange.length) * 32 + 32,
		// for ET-DLE170/ELS20
		pjModel = document.getElementById('model-pj'),
		trBarLength = 1,	// magnification of throw ratio bar length
		wboxStart = 160;		// white box left position

	// supplied lens / ET-DLE170/ELS20

	switch ( pjModel.innerHTML ) {

		case 'PT-RZ970':
		case 'PT-RW930':
		case 'PT-RX110':
		case 'PT-RZ770':
		case 'PT-RW730':
		case 'PT-RZ670':
		case 'PT-RW630':
		case 'PT-RZ660':
		case 'PT-RW620':
		case 'PT-DZ870':
		case 'PT-DW830':
		case 'PT-DX100':
		case 'PT-DZ780':
		case 'PT-DW750':
		case 'PT-DX820':
		case 'PT-DZ770':
		case 'PT-DW740':
		case 'PT-DX810':
		case 'PT-DW730':
		case 'PT-DX800':
		case 'PT-DZ680':
		case 'PT-DW640':
		case 'PT-DX610':
		case 'PT-DZ6710/DZ6700':
		case 'PT-DW6300':
		case 'PT-D6000':
		case 'PT-D5000':
		case 'PT-EZ770Z':
		case 'PT-EW730Z':
		case 'PT-EX800Z':
		case 'PT-EZ580':
		case 'PT-EW640':
		case 'PT-EW540':
		case 'PT-EX610':
		case 'PT-EX510':

		trBarLength = 0.85;
		wboxStart = 240;

		break;

	}

	theCanvas.width = 760;
	theCanvas.height = canvasHeight;

	// throw ratio bar length adjustment

	var trBarMagn = parseFloat( 580 / trRangeBar[trRangeBar.length - 1][1] * trBarLength );

	// white box

	function drawWhiteBox() {

		// white box
		context.beginPath();
		context.fillStyle = '#ffffff';
		context.fillRect( wboxStart, 0, 600, canvasHeight );

	}

	// lens projection range

	function drawLensRange() {

		context.beginPath();
		context.lineWidth = 20;
		context.strokeStyle = '#003399';

		for ( var i = 0; i < trRangeBar.length; i++ ) {

			if ( !trRangeBar[i][1] ) {
				context.moveTo( trRangeBar[i][0] * trBarMagn + wboxStart, 32 + 32 * i );
				context.lineTo( trRangeBar[i][0] * trBarMagn + wboxStart + 2.4, 32 + 32 * i );
			}
			else {
				context.moveTo( trRangeBar[i][0] * trBarMagn + wboxStart, 32 + 32 * i );
				context.lineTo( trRangeBar[i][1] * trBarMagn + wboxStart, 32 + 32 * i );
			}

		}

		// lens model
	
		context.textBaseline = 'alphabetic';
		context.font = '24px helvetica';

		for ( var i = 0; i < trRangeBar.length; i++ ) {

			context.fillStyle = '#000000';		// lens model text color
			context.fillText(optLens[i], 0, 44 + 32 * i);

		}
	
		context.stroke();
		context.closePath();

	}

	// indicator

	function drawIndicator() {

		context.beginPath();

		context.lineWidth = 2;
		context.strokeStyle = '#ff0033';
		context.moveTo(throwRatio * trBarMagn + wboxStart, 0);
		context.lineTo(throwRatio * trBarMagn + wboxStart, canvasHeight);

		context.stroke();
		context.closePath();

	}

	drawWhiteBox();
	drawLensRange();
	drawIndicator();

}

