/* =================================
	COEFFICIENT FOR LENS FINDER CALCULATION
	PT-RW730
================================= */


// definition for optional lens ===========

var	optLens030 = 'ET-DLE030',	/*	0.4 (0.397-0.399)	trBp01 to trBp02	*/
	optLens055 = 'ET-DLE055',	/*	0.8 (0.808-0.844)	trBp03 to trBp04	*/
	optLens085 = 'ET-DLE085',	/*	0.8	to	1.0 (0.805-1.050)	trBp03 to trBp06	*/
	optLens105 = 'ET-DLE105',	/*	1.1	to	1.5 (1.010-1.416)	trBp05 to trBp08	*/
	optLens150 = 'ET-DLE150',	/*	1.4	to	2.0 (1.344-2.008)	trBp07 to trBp10	*/
	optLensStd = 'Supplied/ET-DLE170',	/*	1.8	to	2.5 (1.776-2.572)	trBp09 to trBp12	*/
	optLens250 = 'ET-DLE250',	/*	2.4	to	3.8 (2.361-3.841)	trBp11 to trBp14	*/
	optLens350 = 'ET-DLE350',	/*	3.8	to	5.7 (3.713-5.791)	trBp13 to trBp16	*/
	optLens450 = 'ET-DLE450';	/*	5.6	to	9.0 (5.531-9.165)	trBp15 to trBp17	*/


// coefficient for projection range ===========

var	optLens = [ 'ET-DLE030', 'ET-DLE055', 'ET-DLE085', 'ET-DLE150', 'Supplied/ET-DLE170', 'ET-DLE250', 'ET-DLE350', 'ET-DLE450' ];

var	coefAmin = [
		[ 8.547, 18.38, 18.31, 22.785, 30.028, 39.754, 52.448, 82.676, 125.164 ],	// 16:10
		[ 8.785, 18.9, 18.818, 23.4185, 30.864, 40.86, 53.906, 84.976, 128.644 ]	// 16:9
	 ],
	coefBmin = [
		[ -4.667, 47.6, 47.086, 51.1, 53.8, 74.4, 79.8, 134.6, 301.4 ],
		[ -4.667, 47.6, 46.8, 51.1, 54.4, 75, 79.8, 135.6, 301.7 ]
	 ],
	coefAmax = [
		[  , , 22.666, 30.555, 43.32, 55.51, 82.836, 124.93, 197.874 ],
		[  , , 23.296, 31.4045, 44.524, 57.054, 85.138, 128.404, 203.374 ]
	 ],
	coefBmax = [
		[  , , 44.221, 47.2, 50, 72, 79.6, 134, 299.4 ],
		[  , , 44.221, 47.2, 49.4, 72.4, 78.8, 134.4, 299.4 ]
	 ];


// link to throw distance calculator ===========

var	linkLens = [ 'dle030', 'dle055', 'dle085', 'dle105', 'dle150', '', 'dle250', 'dle350', 'dle450' ],
	linkLens1,
	linkLens2;


// option lens throw ratio range ===========

var	trRange = [
	[ '0.4',  ],
	[ '0.8',  ],
	[ '0.8', '1.0' ],
	[ '1.1', '1.5' ],
	[ '1.4', '2.0' ],
	[ '1.8', '2.5' ],
	[ '2.4', '3.8' ],
	[ '3.8', '5.7' ],
	[ '5.6', '9.0' ]
	];


// break point of projection range (throw ratio break point) ===========

		// 'No lens found'
var	trBp01 = 0.397;
		// (optLens030)
	trBp02 = 0.399;
		// 'No lens found'
	trBp03 = 0.805;
		// optLens055 + optLens085
	trBp04 = 0.844;
		// optLens085
	trBp05 = 1.010;
		// optLens085 + optLens0105
	trBp06 = 1.050;
		// optLens0105
	trBp07 = 1.344;
		// optLens105 + optLens150
	trBp08 = 1.416;
		// optLens150
	trBp09 = 1.776;
		// optLens150 + optLensStd
	trBp10 = 2.008;
		// optLensStd
	trBp11 = 2.361;
		// optLensStd + optLens250
	trBp12 = 2.572;
		// optLens250
	trBp13 = 3.713;
		// optLens250 + optLens350
	trBp14 = 3.841;
		// optLens350
	trBp15 = 5.531;
		// optLens350 + optLens450
	trBp16 = 5.791;
		// optLens450
	trBp17 = 9.165;
		// 'No lens found'


// option lens throw ratio range for canvas indicator ===========

var	trRangeBar = trRange
/*
var	trRangeBar = [
	[ trBp01, trBp02 ],
	[ trBp03, trBp04 ],
	[ trBp03, trBp06 ],
	[ trBp05, trBp08 ],
	[ trBp07, trBp10 ],
	[ trBp09, trBp12 ],
	[ trBp11, trBp14 ],
	[ trBp13, trBp16 ],
	[ trBp15, trBp17 ]
	];
*/


// size limitation ===========

var	scrnSizeMin = 50,
	scrnSizeMax = 600,
	scrnSizeMinMm = scrnSizeMin * 25.4,
	scrnSizeMaxMm = scrnSizeMax * 25.4;

	scrnSizeMax = String( scrnSizeMax ).replace( /(\d)(?=(\d\d\d)+(?!\d))/g, '$1,' );
	scrnSizeMinMm = String( scrnSizeMinMm ).replace( /(\d)(?=(\d\d\d)+(?!\d))/g, '$1,' );
	scrnSizeMaxMm = String( scrnSizeMaxMm ).replace( /(\d)(?=(\d\d\d)+(?!\d))/g, '$1,' );



// CALCULATION FOR SUITABLE LENS /////////////////////////


function lensFinder() {



	var	stLens1 = '',
		stLens2 = '',
		trMin1 = 0,
		trMax1 = 0,
		trLens1 = 0,
		trMin2 = 0,
		trMax2 = 0,
		trLens2 = 0,
		coefAmin1 = 0,
		coefBmin1 = 0,
		coefAmax1 = 0,
		coefBmax1 = 0,
		coefAmin2 = 0,
		coefBmin2 = 0,
		coefAmax2 = 0,
		coefBmax2 = 0;


	// aspect ratio

	var	aspectRatio = (function() {

		var	aspect = document.getElementsByName('aspect');

		for ( var i = 0; i < aspect.length; i++ ) {

			if ( aspect[i].checked == true ) {
				var	aspectRatio = aspect[i].value;
				return aspectRatio;		// ESSENTIAL
			}
		}

	}());


	// calculation

	if ( throwRatio < trBp01 ) {
		stLens1 = 'No lens was found.';
		linkLens1 = linkLens[0];
	} else if ( throwRatio <= trBp02 ) {
		// ET-DLE030: Screen size limitaion
		if ( Math.round(scrnWidth) < Math.round( 100 / coefScrnPortion * 25.4 ) || Math.round( 350 / coefScrnPortion * 25.4 ) < Math.round(scrnWidth) ) {
			stLens1 = 'No lens was found.';
			linkLens1 = linkLens[0];
		} else {
			stLens1 = optLens030;
			linkLens1 = linkLens[0];
			trMin1 = trRange[0][0];
			if ( aspectRatio == 1610 ) {
				coefAmin1 = coefAmin[0][0];
				coefBmin1 = coefBmin[0][0];
			}
			else if ( aspectRatio == 169 ) {
				coefAmin1 = coefAmin[1][0];
				coefBmin1 = coefBmin[1][0];
			}
		}
	} else if ( throwRatio < trBp03 ) {
		stLens1 = 'No lens was found.';
		linkLens1 = linkLens[0];
	} else if ( throwRatio <= trBp04 ) {
		// lens1
		stLens1 = optLens085;
		linkLens1 = linkLens[2];
		trMin1 = trRange[2][0];
		trMax1 = trRange[2][1];
		coefAmin1 = coefAmin[0][2];
		coefBmin1 = coefBmin[0][2];
		coefAmax1 = coefAmax[0][2];
		coefBmax1 = coefBmax[0][2];
		if ( aspectRatio == 169 ) {
			coefAmin1 = coefAmin[1][2];
			coefBmin1 = coefBmin[1][2];
			coefAmax1 = coefAmax[1][2];
			coefBmax1 = coefBmax[1][2];
		}
		// lens2
		stLens2 = optLens055;
		linkLens2 = linkLens[1];
		trMin2 = trRange[1][0];
		coefAmin2 = coefAmin[0][1];
		coefBmin2 = coefBmin[0][1];
		if ( aspectRatio == 169 ) {
			coefAmin2 = coefAmin[1][1];
			coefBmin2 = coefBmin[1][1];
		}
	} else if ( throwRatio <= trBp05 ) {
		stLens1 = optLens085;
		linkLens1 = linkLens[2];
		trMin1 = trRange[2][0];
		trMax1 = trRange[2][1];
		coefAmin1 = coefAmin[0][2];
		coefBmin1 = coefBmin[0][2];
		coefAmax1 = coefAmax[0][2];
		coefBmax1 = coefBmax[0][2];
		if ( aspectRatio == 169 ) {
			coefAmin1 = coefAmin[1][2];
			coefBmin1 = coefBmin[1][2];
			coefAmax1 = coefAmax[1][2];
			coefBmax1 = coefBmax[1][2];
		}
	} else if ( throwRatio < trBp06 ) {
		// lens1
		stLens1 = optLens085;
		linkLens1 = linkLens[2];
		trMin1 = trRange[2][0];
		trMax1 = trRange[2][1];
		coefAmin1 = coefAmin[0][2];
		coefBmin1 = coefBmin[0][2];
		coefAmax1 = coefAmax[0][2];
		coefBmax1 = coefBmax[0][2];
		if ( aspectRatio == 169 ) {
			coefAmin1 = coefAmin[1][2];
			coefBmin1 = coefBmin[1][2];
			coefAmax1 = coefAmax[1][2];
			coefBmax1 = coefBmax[1][2];
		}
		// lens2
		stLens2 = optLens105;
		linkLens2 = linkLens[3];
		trMin2 = trRange[3][0];
		trMax2 = trRange[3][1];
		coefAmin2 = coefAmin[0][3];
		coefBmin2 = coefBmin[0][3];
		coefAmax2 = coefAmax[0][3];
		coefBmax2 = coefBmax[0][3];
		if ( aspectRatio == 169 ) {
			coefAmin2 = coefAmin[1][3];
			coefBmin2 = coefBmin[1][3];
			coefAmax2 = coefAmax[1][3];
			coefBmax2 = coefBmax[1][3];
		}
	} else if ( throwRatio <= trBp07 ) {
		stLens1 = optLens105;
		linkLens1 = linkLens[3];
		trMin1 = trRange[3][0];
		trMax1 = trRange[3][1];
		coefAmin1 = coefAmin[0][3];
		coefBmin1 = coefBmin[0][3];
		coefAmax1 = coefAmax[0][3];
		coefBmax1 = coefBmax[0][3];
		if ( aspectRatio == 169 ) {
			coefAmin1 = coefAmin[1][3];
			coefBmin1 = coefBmin[1][3];
			coefAmax1 = coefAmax[1][3];
			coefBmax1 = coefBmax[1][3];
		}
	} else if ( throwRatio <= trBp08 ) {
		// lens1
		stLens1 = optLens105;
		linkLens1 = linkLens[3];
		trMin1 = trRange[3][0];
		trMax1 = trRange[3][1];
		coefAmin1 = coefAmin[0][3];
		coefBmin1 = coefBmin[0][3];
		coefAmax1 = coefAmax[0][3];
		coefBmax1 = coefBmax[0][3];
		if ( aspectRatio == 169 ) {
			coefAmin1 = coefAmin[1][3];
			coefBmin1 = coefBmin[1][3];
			coefAmax1 = coefAmax[1][3];
			coefBmax1 = coefBmax[1][3];
		}
		// lens2
		stLens2 = optLens150;
		linkLens2 = linkLens[4];
		trMin2 = trRange[4][0];
		trMax2 = trRange[4][1];
		coefAmin2 = coefAmin[0][4];
		coefBmin2 = coefBmin[0][4];
		coefAmax2 = coefAmax[0][4];
		coefBmax2 = coefBmax[0][4];
		if ( aspectRatio == 169 ) {
			coefAmin2 = coefAmin[1][4];
			coefBmin2 = coefBmin[1][4];
			coefAmax2 = coefAmax[1][4];
			coefBmax2 = coefBmax[1][4];
		}
	} else if ( throwRatio <= trBp09 ) {
		stLens1 = optLens150;
		linkLens1 = linkLens[4];
		trMin1 = trRange[4][0];
		trMax1 = trRange[4][1];
		coefAmin1 = coefAmin[0][4];
		coefBmin1 = coefBmin[0][4];
		coefAmax1 = coefAmax[0][4];
		coefBmax1 = coefBmax[0][4];
		if ( aspectRatio == 169 ) {
			coefAmin1 = coefAmin[1][4];
			coefBmin1 = coefBmin[1][4];
			coefAmax1 = coefAmax[1][4];
			coefBmax1 = coefBmax[1][4];
		}
	} else if ( throwRatio <= trBp10 ) {
		// lens1
		stLens1 = optLens150;
		linkLens1 = linkLens[4];
		trMin1 = trRange[4][0];
		trMax1 = trRange[4][1];
		coefAmin1 = coefAmin[0][4];
		coefBmin1 = coefBmin[0][4];
		coefAmax1 = coefAmax[0][4];
		coefBmax1 = coefBmax[0][4];
		if ( aspectRatio == 169 ) {
			coefAmin1 = coefAmin[1][4];
			coefBmin1 = coefBmin[1][4];
			coefAmax1 = coefAmax[1][4];
			coefBmax1 = coefBmax[1][4];
		}
		// lens2
		stLens2 = optLensStd;
		linkLens2 = linkLens[5];
		trMin2 = trRange[5][0];
		trMax2 = trRange[5][1];
		coefAmin2 = coefAmin[0][5];
		coefBmin2 = coefBmin[0][5];
		coefAmax2 = coefAmax[0][5];
		coefBmax2 = coefBmax[0][5];
		if ( aspectRatio == 169 ) {
			coefAmin2 = coefAmin[1][5];
			coefBmin2 = coefBmin[1][5];
			coefAmax2 = coefAmax[1][5];
			coefBmax2 = coefBmax[1][5];
		}
	} else if ( throwRatio <= trBp11 ) {
		stLens1 = optLensStd;
		linkLens1 = linkLens[5];
		trMin1 = trRange[5][0];
		trMax1 = trRange[5][1];
		coefAmin1 = coefAmin[0][5];
		coefBmin1 = coefBmin[0][5];
		coefAmax1 = coefAmax[0][5];
		coefBmax1 = coefBmax[0][5];
		if ( aspectRatio == 169 ) {
			coefAmin1 = coefAmin[1][5];
			coefBmin1 = coefBmin[1][5];
			coefAmax1 = coefAmax[1][5];
			coefBmax1 = coefBmax[1][5];
		}
	} else if ( throwRatio <= trBp12 ) {
		// lens1
		stLens1 = optLensStd;
		linkLens1 = linkLens[5];
		trMin1 = trRange[5][0];
		trMax1 = trRange[5][1];
		coefAmin1 = coefAmin[0][5];
		coefBmin1 = coefBmin[0][5];
		coefAmax1 = coefAmax[0][5];
		coefBmax1 = coefBmax[0][5];
		if ( aspectRatio == 169 ) {
			coefAmin1 = coefAmin[1][5];
			coefBmin1 = coefBmin[1][5];
			coefAmax1 = coefAmax[1][5];
			coefBmax1 = coefBmax[1][5];
		}
		// lens2
		stLens2 = optLens250;
		linkLens2 = linkLens[6];
		trMin2 = trRange[6][0];
		trMax2 = trRange[6][1];
		coefAmin2 = coefAmin[0][6];
		coefBmin2 = coefBmin[0][6];
		coefAmax2 = coefAmax[0][6];
		coefBmax2 = coefBmax[0][6];
		if ( aspectRatio == 169 ) {
			coefAmin2 = coefAmin[1][6];
			coefBmin2 = coefBmin[1][6];
			coefAmax2 = coefAmax[1][6];
			coefBmax2 = coefBmax[1][6];
		}
	} else if ( throwRatio <= trBp13 ) {
		stLens1 = optLens250;
		linkLens1 = linkLens[6];
		trMin1 = trRange[6][0];
		trMax1 = trRange[6][1];
		coefAmin1 = coefAmin[0][6];
		coefBmin1 = coefBmin[0][6];
		coefAmax1 = coefAmax[0][6];
		coefBmax1 = coefBmax[0][6];
		if ( aspectRatio == 169 ) {
			coefAmin1 = coefAmin[1][6];
			coefBmin1 = coefBmin[1][6];
			coefAmax1 = coefAmax[1][6];
			coefBmax1 = coefBmax[1][6];
		}
	} else if ( throwRatio <= trBp14 ) {
		// lens1
		stLens1 = optLens250;
		linkLens1 = linkLens[6];
		trMin1 = trRange[6][0];
		trMax1 = trRange[6][1];
		coefAmin1 = coefAmin[0][6];
		coefBmin1 = coefBmin[0][6];
		coefAmax1 = coefAmax[0][6];
		coefBmax1 = coefBmax[0][6];
		if ( aspectRatio == 169 ) {
			coefAmin1 = coefAmin[1][6];
			coefBmin1 = coefBmin[1][6];
			coefAmax1 = coefAmax[1][6];
			coefBmax1 = coefBmax[1][6];
		}
		// lens2
		stLens2 = optLens350;
		linkLens2 = linkLens[7];
		trMin2 = trRange[7][0];
		trMax2 = trRange[7][1];
		coefAmin2 = coefAmin[0][7];
		coefBmin2 = coefBmin[0][7];
		coefAmax2 = coefAmax[0][7];
		coefBmax2 = coefBmax[0][7];
		if ( aspectRatio == 169 ) {
			coefAmin2 = coefAmin[1][7];
			coefBmin2 = coefBmin[1][7];
			coefAmax2 = coefAmax[1][7];
			coefBmax2 = coefBmax[1][7];
		}
	} else if ( throwRatio <= trBp15 ) {
		stLens1 = optLens350;
		linkLens1 = linkLens[7];
		trMin1 = trRange[7][0];
		trMax1 = trRange[7][1];
		coefAmin1 = coefAmin[0][7];
		coefBmin1 = coefBmin[0][7];
		coefAmax1 = coefAmax[0][7];
		coefBmax1 = coefBmax[0][7];
		if ( aspectRatio == 169 ) {
			coefAmin1 = coefAmin[1][7];
			coefBmin1 = coefBmin[1][7];
			coefAmax1 = coefAmax[1][7];
			coefBmax1 = coefBmax[1][7];
		}
	} else if ( throwRatio <= trBp16 ) {
		// lens1
		stLens1 = optLens350;
		linkLens1 = linkLens[7];
		trMin1 = trRange[7][0];
		trMax1 = trRange[7][1];
		coefAmin1 = coefAmin[0][7];
		coefBmin1 = coefBmin[0][7];
		coefAmax1 = coefAmax[0][7];
		coefBmax1 = coefBmax[0][7];
		if ( aspectRatio == 169 ) {
			coefAmin1 = coefAmin[1][7];
			coefBmin1 = coefBmin[1][7];
			coefAmax1 = coefAmax[1][7];
			coefBmax1 = coefBmax[1][7];
		}
		// lens2
		stLens2 = optLens450;
		linkLens2 = linkLens[8];
		trMin2 = trRange[8][0];
		trMax2 = trRange[8][1];
		coefAmin2 = coefAmin[0][8];
		coefBmin2 = coefBmin[0][8];
		coefAmax2 = coefAmax[0][8];
		coefBmax2 = coefBmax[0][8];
		if ( aspectRatio == 169 ) {
			coefAmin2 = coefAmin[1][8];
			coefBmin2 = coefBmin[1][8];
			coefAmax2 = coefAmax[1][8];
			coefBmax2 = coefBmax[1][8];
		}
	} else if ( throwRatio <= trBp17 ) {
		stLens1 = optLens450;
		linkLens1 = linkLens[8];
		trMin1 = trRange[8][0];
		trMax1 = trRange[8][1];
		coefAmin1 = coefAmin[0][8];
		coefBmin1 = coefBmin[0][8];
		coefAmax1 = coefAmax[0][8];
		coefBmax1 = coefBmax[0][8];
		if ( aspectRatio == 169 ) {
			coefAmin1 = coefAmin[1][8];
			coefBmin1 = coefBmin[1][8];
			coefAmax1 = coefAmax[1][8];
			coefBmax1 = coefBmax[1][8];
		}
	}
	else {
		stLens1 = 'No lens was found.';
		linkLens1 = linkLens[8];
	}

	var	pjRange1 = 0,
		pjRange1Ft = 0,
		pjRmin1 = 0,
		pjRmin1Ft = 0,
		pjRmax1 = 0,
		pjRmax1Ft = 0,
		pjRange2 = 0,
		pjRange2Ft = 0,
		pjRmin2 = 0,
		pjRmin2Ft = 0,
		pjRmax2 = 0,
		pjRmax2Ft = 0;

	// projection range

		pjRmin1 = Math.round( scrnDiag / 25.4 * coefAmin1 - coefBmin1 );
		pjRmin1Ft = Math.round(( scrnDiag / 25.4 * coefAmin1 - coefBmin1 ) / 25.4 / 12 * 100 ) / 100;
		pjRmax1 = Math.round( scrnDiag / 25.4 * coefAmax1 - coefBmax1 );
		pjRmax1Ft = Math.round(( scrnDiag / 25.4 * coefAmax1 - coefBmax1 ) / 25.4 / 12 * 100 ) / 100;
		pjRmin2 = Math.round( scrnDiag / 25.4 * coefAmin2 - coefBmin2 );
		pjRmin2Ft = Math.round(( scrnDiag / 25.4 * coefAmin2 - coefBmin2 ) / 25.4 / 12 * 100 ) / 100;
		pjRmax2 = Math.round( scrnDiag / 25.4 * coefAmax2 - coefBmax2 );
		pjRmax2Ft = Math.round(( scrnDiag / 25.4 * coefAmax2 - coefBmax2 ) / 25.4 / 12 * 100 ) / 100;

		// zoom lens

		if ( pjRmax1 != 0 ) {

			trLens1 = ' (' + trMin1 + '–' + trMax1 + ':1)';
			pjRange1 = pjRmin1.toLocaleString() + '–' + pjRmax1.toLocaleString() + ' millimeters';
			pjRange1Ft = pjRmin1Ft.toLocaleString() + '–' + pjRmax1Ft.toLocaleString() + ' feet';

			if ( pjRmax2 != 0 ) {
				trLens2 = ' (' + trMin2 + '–' + trMax2 + ':1)';
				pjRange2 = pjRmin2.toLocaleString() + '–' + pjRmax2.toLocaleString() + ' millimeters';
				pjRange2Ft = pjRmin2Ft.toLocaleString() + '–' + pjRmax2Ft.toLocaleString() + ' feet';
			}

			else if ( pjRmin2 != 0 ) {
				trLens2 = ' (' + trMin2 + ':1)';
				pjRange2 = pjRmin2 + ' millimeters';
				pjRange2Ft = pjRmin2Ft + ' feet';
			}

		}

		// fixed lens or no suitable lens

		else if ( pjRmin1 != 0 ) {
			trLens1 = ' (' + trMin1 + ':1)';
			pjRange1 = pjRmin1 + ' millimeters';
			pjRange1Ft = pjRmin1Ft + ' feet';
		}


	var	stLensH2= document.getElementById('option-lens-title');
		stLensDiv1 = document.getElementById('option-lens-1'),
		stLensDiv2 = document.getElementById('option-lens-2'),
		throwRatioDiv = document.getElementById('calculated-throw-ratio'),
		pjRangeDiv = document.getElementById('projection-range-title'),
		pjRangeDiv1 = document.getElementById('projection-range-1'),
		pjRangeDiv2 = document.getElementById('projection-range-2'),
		elBr1 = document.createElement('br'),
		elBr2 = document.createElement('br'),
		aLens1 = document.createElement('a'),
		aLens2 = document.createElement('a'),
		// for recalculation
		stLensOldTitle = document.getElementById('option-lens-title').firstChild,
		stLensOldText1 = document.getElementById('option-lens-1').firstChild,
		stLensOldText2 = document.getElementById('option-lens-2').firstChild,
		throwRatioOldText = document.getElementById('calculated-throw-ratio').firstChild,
		pjRangeOldTitle = document.getElementById('projection-range-title').firstChild,
		pjRangeOldText1 = document.getElementById('projection-range-1').firstChild,
		pjRangeOldText2 = document.getElementById('projection-range-2').firstChild,
		// results
		stLensTitle = document.createTextNode('Suitable Lens: ');
		if ( stLens1 == 'ET-DLE055' ) {
			var	stLensText1 = document.createTextNode('The ' + stLens1 + ' can be suitable.');
		} else {
			var	stLensText1 = document.createTextNode(stLens1);
		}
		if ( stLens2 == 'ET-DLE055' ) {
			var	stLensText2 = document.createTextNode('The ' + stLens2 + ' can be suitable.');
		} else {
			var	stLensText2 = document.createTextNode(stLens2);
		}

		// link to throw distance calculator
	var	linkCalc1 = '../installation/rw730' + linkLens1 + '.html?' + encodeURIComponent(scrnSize) + '&' + encodeURIComponent(aspectRatio) + '&' + encodeURIComponent(scrnUnit) + '&' + encodeURIComponent(scrnPortion),
		linkCalc2 = '../installation/rw730' + linkLens2 + '.html?' + encodeURIComponent(scrnSize) + '&' + encodeURIComponent(aspectRatio) + '&' + encodeURIComponent(scrnUnit) + '&' + encodeURIComponent(scrnPortion);

		aLens1.href = linkCalc1;
		aLens2.href = linkCalc2;
		throwRatioText = document.createTextNode('Approximate throw ratio of this condition: ' + (Math.round(throwRatio * 10) / 10).toFixed(1) + ':1');
		pjRangeTitle = document.createTextNode('Projection distance for the requested image size: ');
		lensModel1 = document.createTextNode(stLens1 + trLens1 + ': ');
		pjRangeText1 = document.createTextNode(pjRange1 +'; ' + pjRange1Ft);
		lensModel2 = document.createTextNode(stLens2 + trLens2 + ': ');
		pjRangeText2 = document.createTextNode(pjRange2 +'; ' + pjRange2Ft);


	// reset on change

	if ( stLensOldText1 != null ) {

		stLensH2.removeChild(stLensOldTitle);
		stLensDiv1.removeChild(stLensOldText1);
		throwRatioDiv.removeChild(throwRatioOldText);

		if ( pjRangeOldTitle != null ) {
		pjRangeDiv.removeChild(pjRangeOldTitle);

			while ( pjRangeDiv1.lastChild ) {
			  pjRangeDiv1.removeChild(pjRangeDiv1.lastChild);
			}

			if ( stLensOldText2 != null ) {
				stLensDiv2.removeChild(stLensOldText2);
				while ( pjRangeDiv2.lastChild ) {
				  pjRangeDiv2.removeChild(pjRangeDiv2.lastChild);
				}

			}

		}

	}


	// OUTPUT ////////////

	stLensH2.appendChild(stLensTitle);	// Suitable Lens:
	throwRatioDiv.appendChild(throwRatioText);
	if ( stLens1 == 'No lens was found.' ) {

		stLensDiv1.appendChild(aLens1);		// lens model with link 1
		aLens1.appendChild(stLensText1);	// lens model 1

	} else if ( stLens1 != '' ) {

		stLensDiv1.appendChild(aLens1);		// lens model with link 1
		aLens1.appendChild(stLensText1);	// lens model 1
		pjRangeDiv.appendChild(pjRangeTitle);
		pjRangeDiv1.appendChild(lensModel1);
		pjRangeDiv1.appendChild(elBr1);
		pjRangeDiv1.appendChild(pjRangeText1);

		if ( stLens2 != '' ) {

			stLensDiv2.appendChild(aLens2);		// lens model with link 2
			aLens2.appendChild(stLensText2);	// lens model 2
			pjRangeDiv2.appendChild(lensModel2);
			pjRangeDiv2.appendChild(elBr2);
			pjRangeDiv2.appendChild(pjRangeText2);

		}

	}



}