/* =================================
	COEFFICIENT FOR LENS FINDER CALCULATION
	PT-RX110
================================= */


// definition for optional lens ===========

var	optLens030 = 'ET-DLE030',	/*	0.4 (0.392-0.394)	trBp01 to trBp02	*/
	optLens055 = 'ET-DLE055',	/*	0.8 (0.795-0.831)	trBp03 to trBp04	*/
	optLens085 = 'ET-DLE085',	/*	0.8	to	1.0 (0.793-1.035)	trBp03 to trBp06	*/
	optLens105 = 'ET-DLE105',	/*	0.9	to	1.3 (0.994-1.396)	trBp05 to trBp08	*/
	optLens150 = 'ET-DLE150',	/*	1.3	to	2.0 (1.322-1.981)	trBp07 to trBp10	*/
	optLensStd = 'Supplied/ET-DLE170',	/*	1.8	to	2.5 (1.748-2.538)	trBp09 to trBp12	*/
	optLens250 = 'ET-DLE250',	/*	2.4	to	3.7 (2.324-3.789)	trBp11 to trBp14	*/
	optLens350 = 'ET-DLE350',	/*	3.7	to	5.6 (3.654-5.713)	trBp13 to trBp16	*/
	optLens450 = 'ET-DLE450';	/*	5.5	to	8.9 (5.437-9.042)	trBp15 to trBp17	*/


// coefficient for projection range ===========

var	optLens = [ 'ET-DLE030', 'ET-DLE055', 'ET-DLE085', 'ET-DLE105', 'ET-DLE150', 'Supplied/ET-DLE170', 'ET-DLE250', 'ET-DLE350', 'ET-DLE450' ];

var	coefAmin = [ 7.957, 17.113, 17.05, 21.2125, 27.96, 37.01, 48.828, 76.97, 116.526 ],
	coefBmin = [ -4.667, 47.6, 47.1, 51.1, 54, 75, 79.8, 135.1, 301.6 ],
	coefAmax = [  , , 21.1, 28.4462, 40.33, 51.68, 77.12, 116.31, 184.216 ],
	coefBmax = [  , , 44.2, 47.2, 49.8, 72, 78.8, 134.6, 298.6 ];


// link to throw distance calculator ===========

var	linkLens = [ 'dle030', 'dle055', 'dle085', 'dle105', 'dle150', '', 'dle250', 'dle350', 'dle450' ],
	linkLens1,
	linkLens2;


// option lens throw ratio range ===========

var	trRange = [
	[ '0.4',  ],
	[ '0.8',  ],
	[ '0.8', '1.0' ],
	[ '0.9', '1.3' ],
	[ '1.3', '2.0' ],
	[ '1.8', '2.5' ],
	[ '2.4', '3.7' ],
	[ '3.7', '5.6' ],
	[ '5.5', '8.9' ]
	];


// break point of projection range (throw ratio break point) ===========

		// 'No lens found'
var	trBp01 = 0.392;
		// (optLens030)
	trBp02 = 0.394;
		// 'No lens found'
	trBp03 = 0.793;
		// optLens055 + optLens085
	trBp04 = 0.831;
		// optLens085
	trBp05 = 0.994;
		// optLens085 + optLens105
	trBp06 = 1.035;
		// optLens105
	trBp07 = 1.322;
		// optLens105 + optLens150
	trBp08 = 1.396;
		// optLens150
	trBp09 = 1.748;
		// optLens150 + optLensStd
	trBp10 = 1.981;
		// optLensStd
	trBp11 = 2.324;
		// optLensStd + optLens250
	trBp12 = 2.538;
		// optLens250
	trBp13 = 3.654;
		// optLens250 + optLens350
	trBp14 = 3.789;
		// optLens350
	trBp15 = 5.437;
		// optLens350 + optLens450
	trBp16 = 5.713;
		// optLens450
	trBp17 = 9.042;
		// 'No lens found'


// option lens throw ratio range for canvas indicator ===========

var	trRangeBar = trRange
/*
var	trRangeBar = [
	[ trBp01, trBp02 ],
	[ trBp03, trBp04 ],
	[ trBp03, trBp06 ],
	[ trBp05, trBp08 ],
	[ trBp07, trBp10 ],
	[ trBp09, trBp12 ],
	[ trBp11, trBp14 ],
	[ trBp13, trBp16 ],
	[ trBp15, trBp17 ]
	];
*/


// size limitation ===========

var	scrnSizeMin = 50,
	scrnSizeMax = 600,
	scrnSizeMinMm = scrnSizeMin * 25.4,
	scrnSizeMaxMm = scrnSizeMax * 25.4;

	scrnSizeMax = String( scrnSizeMax ).replace( /(\d)(?=(\d\d\d)+(?!\d))/g, '$1,' );
	scrnSizeMinMm = String( scrnSizeMinMm ).replace( /(\d)(?=(\d\d\d)+(?!\d))/g, '$1,' );
	scrnSizeMaxMm = String( scrnSizeMaxMm ).replace( /(\d)(?=(\d\d\d)+(?!\d))/g, '$1,' );



// CALCULATION FOR SUITABLE LENS /////////////////////////


function lensFinder() {



	var	stLens1 = '',
		stLens2 = '',
		trMin1 = 0,
		trMax1 = 0,
		trLens1 = 0,
		trMin2 = 0,
		trMax2 = 0,
		trLens2 = 0,
		coefAmin1 = 0,
		coefBmin1 = 0,
		coefAmax1 = 0,
		coefBmax1 = 0,
		coefAmin2 = 0,
		coefBmin2 = 0,
		coefAmax2 = 0,
		coefBmax2 = 0;


	// aspect ratio

	var	aspectRatio = (function() {

		var	aspect = document.getElementsByName('aspect');

		for ( var i = 0; i < aspect.length; i++ ) {

			if ( aspect[i].checked == true ) {
				var	aspectRatio = aspect[i].value;
				return aspectRatio;		// ESSENTIAL
			}
		}

	}());


	// calculation

	if ( throwRatio < trBp01 ) {
		stLens1 = 'No lens was found.';
		linkLens1 = linkLens[0];
	} else if ( throwRatio <= trBp02 ) {
		// ET-DLE030: Screen size limitaion
		if ( Math.round(scrnWidth) < Math.round( 100 / coefScrnPortion * 25.4 ) || Math.round( 350 / coefScrnPortion * 25.4 ) < Math.round(scrnWidth) ) {
			stLens1 = 'No lens was found.';
			linkLens1 = linkLens[0];
		} else {
			stLens1 = optLens030;
			linkLens1 = linkLens[0];
			trMin1 = trRange[0][0];
			coefAmin1 = coefAmin[0];
			coefBmin1 = coefBmin[0];
		}
	} else if ( throwRatio < trBp03 ) {
		stLens1 = 'No lens was found.';
		linkLens1 = linkLens[0];
	} else if ( throwRatio <= trBp04 ) {
		// lens1
		stLens1 = optLens085;
		linkLens1 = linkLens[2];
		trMin1 = trRange[2][0];
		trMax1 = trRange[2][1];
		coefAmin1 = coefAmin[2];
		coefBmin1 = coefBmin[2];
		coefAmax1 = coefAmax[2];
		coefBmax1 = coefBmax[2];
		// lens2
		stLens2 = optLens055;
		linkLens2 = linkLens[1];
		trMin2 = trRange[1][0];
		coefAmin2 = coefAmin[1];
		coefBmin2 = coefBmin[1];
	} else if ( throwRatio <= trBp05 ) {
		stLens1 = optLens085;
		linkLens1 = linkLens[2];
		trMin1 = trRange[2][0];
		trMax1 = trRange[2][1];
		coefAmin1 = coefAmin[2];
		coefBmin1 = coefBmin[2];
		coefAmax1 = coefAmax[2];
		coefBmax1 = coefBmax[2];
	} else if ( throwRatio < trBp06 ) {
		// lens1
		stLens1 = optLens085;
		linkLens1 = linkLens[2];
		trMin1 = trRange[2][0];
		trMax1 = trRange[2][1];
		coefAmin1 = coefAmin[2];
		coefBmin1 = coefBmin[2];
		coefAmax1 = coefAmax[2];
		coefBmax1 = coefBmax[2];
		// lens2
		stLens2 = optLens105;
		linkLens2 = linkLens[3];
		trMin2 = trRange[3][0];
		trMax2 = trRange[3][1];
		coefAmin2 = coefAmin[3];
		coefBmin2 = coefBmin[3];
		coefAmax2 = coefAmax[3];
		coefBmax2 = coefBmax[3];
	} else if ( throwRatio <= trBp07 ) {
		stLens1 = optLens105;
		linkLens1 = linkLens[3];
		trMin1 = trRange[3][0];
		trMax1 = trRange[3][1];
		coefAmin1 = coefAmin[3];
		coefBmin1 = coefBmin[3];
		coefAmax1 = coefAmax[3];
		coefBmax1 = coefBmax[3];
	} else if ( throwRatio <= trBp08 ) {
		// lens1
		stLens1 = optLens105;
		linkLens1 = linkLens[3];
		trMin1 = trRange[3][0];
		trMax1 = trRange[3][1];
		coefAmin1 = coefAmin[3];
		coefBmin1 = coefBmin[3];
		coefAmax1 = coefAmax[3];
		coefBmax1 = coefBmax[3];
		// lens2
		stLens2 = optLens150;
		linkLens2 = linkLens[4];
		trMin2 = trRange[4][0];
		trMax2 = trRange[4][1];
		coefAmin2 = coefAmin[4];
		coefBmin2 = coefBmin[4];
		coefAmax2 = coefAmax[4];
		coefBmax2 = coefBmax[4];
	} else if ( throwRatio <= trBp09 ) {
		stLens1 = optLens150;
		linkLens1 = linkLens[4];
		trMin1 = trRange[4][0];
		trMax1 = trRange[4][1];
		coefAmin1 = coefAmin[4];
		coefBmin1 = coefBmin[4];
		coefAmax1 = coefAmax[4];
		coefBmax1 = coefBmax[4];
	} else if ( throwRatio <= trBp10 ) {
		// lens1
		stLens1 = optLens150;
		linkLens1 = linkLens[4];
		trMin1 = trRange[4][0];
		trMax1 = trRange[4][1];
		coefAmin1 = coefAmin[4];
		coefBmin1 = coefBmin[4];
		coefAmax1 = coefAmax[4];
		coefBmax1 = coefBmax[4];
		// lens2
		stLens2 = optLensStd;
		linkLens2 = linkLens[5];
		trMin2 = trRange[5][0];
		trMax2 = trRange[5][1];
		coefAmin2 = coefAmin[5];
		coefBmin2 = coefBmin[5];
		coefAmax2 = coefAmax[5];
		coefBmax2 = coefBmax[5];
	} else if ( throwRatio <= trBp11 ) {
		stLens1 = optLensStd;
		linkLens1 = linkLens[5];
		trMin1 = trRange[5][0];
		trMax1 = trRange[5][1];
		coefAmin1 = coefAmin[5];
		coefBmin1 = coefBmin[5];
		coefAmax1 = coefAmax[5];
		coefBmax1 = coefBmax[5];
	} else if ( throwRatio <= trBp12 ) {
		// lens1
		stLens1 = optLensStd;
		linkLens1 = linkLens[5];
		trMin1 = trRange[5][0];
		trMax1 = trRange[5][1];
		coefAmin1 = coefAmin[5];
		coefBmin1 = coefBmin[5];
		coefAmax1 = coefAmax[5];
		coefBmax1 = coefBmax[5];
		// lens2
		stLens2 = optLens250;
		linkLens2 = linkLens[6];
		trMin2 = trRange[6][0];
		trMax2 = trRange[6][1];
		coefAmin2 = coefAmin[6];
		coefBmin2 = coefBmin[6];
		coefAmax2 = coefAmax[6];
		coefBmax2 = coefBmax[6];
	} else if ( throwRatio <= trBp13 ) {
		stLens1 = optLens250;
		linkLens1 = linkLens[6];
		trMin1 = trRange[6][0];
		trMax1 = trRange[6][1];
		coefAmin1 = coefAmin[6];
		coefBmin1 = coefBmin[6];
		coefAmax1 = coefAmax[6];
		coefBmax1 = coefBmax[6];
	} else if ( throwRatio <= trBp14 ) {
		// lens1
		stLens1 = optLens250;
		linkLens1 = linkLens[6];
		trMin1 = trRange[6][0];
		trMax1 = trRange[6][1];
		coefAmin1 = coefAmin[6];
		coefBmin1 = coefBmin[6];
		coefAmax1 = coefAmax[6];
		coefBmax1 = coefBmax[6];
		// lens2
		stLens2 = optLens350;
		linkLens2 = linkLens[7];
		trMin2 = trRange[7][0];
		trMax2 = trRange[7][1];
		coefAmin2 = coefAmin[7];
		coefBmin2 = coefBmin[7];
		coefAmax2 = coefAmax[7];
		coefBmax2 = coefBmax[7];
	} else if ( throwRatio <= trBp15 ) {
		stLens1 = optLens350;
		linkLens1 = linkLens[7];
		trMin1 = trRange[7][0];
		trMax1 = trRange[7][1];
		coefAmin1 = coefAmin[7];
		coefBmin1 = coefBmin[7];
		coefAmax1 = coefAmax[7];
		coefBmax1 = coefBmax[7];
	} else if ( throwRatio <= trBp16 ) {
		// lens1
		stLens1 = optLens350;
		linkLens1 = linkLens[7];
		trMin1 = trRange[7][0];
		trMax1 = trRange[7][1];
		coefAmin1 = coefAmin[7];
		coefBmin1 = coefBmin[7];
		coefAmax1 = coefAmax[7];
		coefBmax1 = coefBmax[7];
		// lens2
		stLens2 = optLens450;
		linkLens2 = linkLens[8];
		trMin2 = trRange[8][0];
		trMax2 = trRange[8][1];
		coefAmin2 = coefAmin[8];
		coefBmin2 = coefBmin[8];
		coefAmax2 = coefAmax[8];
		coefBmax2 = coefBmax[8];
	} else if ( throwRatio <= trBp17 ) {
		stLens1 = optLens450;
		linkLens1 = linkLens[8];
		trMin1 = trRange[8][0];
		trMax1 = trRange[8][1];
		coefAmin1 = coefAmin[8];
		coefBmin1 = coefBmin[8];
		coefAmax1 = coefAmax[8];
		coefBmax1 = coefBmax[8];
	}
	else {
		stLens1 = 'No lens was found.';
		linkLens1 = linkLens[8];
	}

	var	pjRange1 = 0,
		pjRange1Ft = 0,
		pjRmin1 = 0,
		pjRmin1Ft = 0,
		pjRmax1 = 0,
		pjRmax1Ft = 0,
		pjRange2 = 0,
		pjRange2Ft = 0,
		pjRmin2 = 0,
		pjRmin2Ft = 0,
		pjRmax2 = 0,
		pjRmax2Ft = 0;

	// projection range

		pjRmin1 = Math.round( scrnDiag / 25.4 * coefAmin1 - coefBmin1 );
		pjRmin1Ft = Math.round(( scrnDiag / 25.4 * coefAmin1 - coefBmin1 ) / 25.4 / 12 * 100 ) / 100;
		pjRmax1 = Math.round( scrnDiag / 25.4 * coefAmax1 - coefBmax1 );
		pjRmax1Ft = Math.round(( scrnDiag / 25.4 * coefAmax1 - coefBmax1 ) / 25.4 / 12 * 100 ) / 100;
		pjRmin2 = Math.round( scrnDiag / 25.4 * coefAmin2 - coefBmin2 );
		pjRmin2Ft = Math.round(( scrnDiag / 25.4 * coefAmin2 - coefBmin2 ) / 25.4 / 12 * 100 ) / 100;
		pjRmax2 = Math.round( scrnDiag / 25.4 * coefAmax2 - coefBmax2 );
		pjRmax2Ft = Math.round(( scrnDiag / 25.4 * coefAmax2 - coefBmax2 ) / 25.4 / 12 * 100 ) / 100;

		// zoom lens

		if ( pjRmax1 != 0 ) {

			trLens1 = ' (' + trMin1 + '–' + trMax1 + ':1)';
			pjRange1 = pjRmin1.toLocaleString() + '–' + pjRmax1.toLocaleString() + ' millimeters';
			pjRange1Ft = pjRmin1Ft.toLocaleString() + '–' + pjRmax1Ft.toLocaleString() + ' feet';

			if ( pjRmax2 != 0 ) {
				trLens2 = ' (' + trMin2 + '–' + trMax2 + ':1)';
				pjRange2 = pjRmin2.toLocaleString() + '–' + pjRmax2.toLocaleString() + ' millimeters';
				pjRange2Ft = pjRmin2Ft.toLocaleString() + '–' + pjRmax2Ft.toLocaleString() + ' feet';
			}

			else if ( pjRmin2 != 0 ) {
				trLens2 = ' (' + trMin2 + ':1)';
				pjRange2 = pjRmin2 + ' millimeters';
				pjRange2Ft = pjRmin2Ft + ' feet';
			}

		}

		// fixed lens or no suitable lens

		else if ( pjRmin1 != 0 ) {
			trLens1 = ' (' + trMin1 + ':1)';
			pjRange1 = pjRmin1 + ' millimeters';
			pjRange1Ft = pjRmin1Ft + ' feet';
		}


	var	stLensH2= document.getElementById('option-lens-title');
		stLensDiv1 = document.getElementById('option-lens-1'),
		stLensDiv2 = document.getElementById('option-lens-2'),
		throwRatioDiv = document.getElementById('calculated-throw-ratio'),
		pjRangeDiv = document.getElementById('projection-range-title'),
		pjRangeDiv1 = document.getElementById('projection-range-1'),
		pjRangeDiv2 = document.getElementById('projection-range-2'),
		elBr1 = document.createElement('br'),
		elBr2 = document.createElement('br'),
		aLens1 = document.createElement('a'),
		aLens2 = document.createElement('a'),
		// for recalculation
		stLensOldTitle = document.getElementById('option-lens-title').firstChild,
		stLensOldText1 = document.getElementById('option-lens-1').firstChild,
		stLensOldText2 = document.getElementById('option-lens-2').firstChild,
		throwRatioOldText = document.getElementById('calculated-throw-ratio').firstChild,
		pjRangeOldTitle = document.getElementById('projection-range-title').firstChild,
		pjRangeOldText1 = document.getElementById('projection-range-1').firstChild,
		pjRangeOldText2 = document.getElementById('projection-range-2').firstChild,
		// results
		stLensTitle = document.createTextNode('Suitable Lens: ');
		if ( stLens1 == 'ET-DLE055' ) {
			var	stLensText1 = document.createTextNode('The ' + stLens1 + ' can be suitable.');
		} else {
			var	stLensText1 = document.createTextNode(stLens1);
		}
		if ( stLens2 == 'ET-DLE055' ) {
			var	stLensText2 = document.createTextNode('The ' + stLens2 + ' can be suitable.');
		} else {
			var	stLensText2 = document.createTextNode(stLens2);
		}

		// link to throw distance calculator
	var	linkCalc1 = '../installation/rx110' + linkLens1 + '.html?' + encodeURIComponent(scrnSize) + '&' + encodeURIComponent(aspectRatio) + '&' + encodeURIComponent(scrnUnit) + '&' + encodeURIComponent(scrnPortion),
		linkCalc2 = '../installation/rx110' + linkLens2 + '.html?' + encodeURIComponent(scrnSize) + '&' + encodeURIComponent(aspectRatio) + '&' + encodeURIComponent(scrnUnit) + '&' + encodeURIComponent(scrnPortion);

		aLens1.href = linkCalc1;
		aLens2.href = linkCalc2;
		throwRatioText = document.createTextNode('Approximate throw ratio of this condition: ' + (Math.round(throwRatio * 10) / 10).toFixed(1) + ':1');
		pjRangeTitle = document.createTextNode('Projection distance for the requested image size: ');
		lensModel1 = document.createTextNode(stLens1 + trLens1 + ': ');
		pjRangeText1 = document.createTextNode(pjRange1 +'; ' + pjRange1Ft);
		lensModel2 = document.createTextNode(stLens2 + trLens2 + ': ');
		pjRangeText2 = document.createTextNode(pjRange2 +'; ' + pjRange2Ft);


	// reset on change

	if ( stLensOldText1 != null ) {

		stLensH2.removeChild(stLensOldTitle);
		stLensDiv1.removeChild(stLensOldText1);
		throwRatioDiv.removeChild(throwRatioOldText);

		if ( pjRangeOldTitle != null ) {
		pjRangeDiv.removeChild(pjRangeOldTitle);

			while ( pjRangeDiv1.lastChild ) {
			  pjRangeDiv1.removeChild(pjRangeDiv1.lastChild);
			}

			if ( stLensOldText2 != null ) {
				stLensDiv2.removeChild(stLensOldText2);
				while ( pjRangeDiv2.lastChild ) {
				  pjRangeDiv2.removeChild(pjRangeDiv2.lastChild);
				}

			}

		}

	}


	// OUTPUT ////////////

	stLensH2.appendChild(stLensTitle);	// Suitable Lens:
	throwRatioDiv.appendChild(throwRatioText);
	if ( stLens1 == 'No lens was found.' ) {

		stLensDiv1.appendChild(aLens1);		// lens model with link 1
		aLens1.appendChild(stLensText1);	// lens model 1

	} else if ( stLens1 != '' ) {

		stLensDiv1.appendChild(aLens1);		// lens model with link 1
		aLens1.appendChild(stLensText1);	// lens model 1
		pjRangeDiv.appendChild(pjRangeTitle);
		pjRangeDiv1.appendChild(lensModel1);
		pjRangeDiv1.appendChild(elBr1);
		pjRangeDiv1.appendChild(pjRangeText1);

		if ( stLens2 != '' ) {

			stLensDiv2.appendChild(aLens2);		// lens model with link 2
			aLens2.appendChild(stLensText2);	// lens model 2
			pjRangeDiv2.appendChild(lensModel2);
			pjRangeDiv2.appendChild(elBr2);
			pjRangeDiv2.appendChild(pjRangeText2);

		}

	}



}