/* =================================
	COEFFICIENT FOR LENS FINDER CALCULATION
================================= */

var	aspectLength,
	formPortion,
	scrnPortion,
	formScrnUnit,
	scrnUnit,
	formDistUnit,
	distUnit,
	aspectRatio,
	scrnSize,
	pjDist,
	throwRatio,
	coefScrnUnit,
	coefScrnPortion,
	coefDistUnit,
	scrnWidth,
	scrnDiag;


/* =================================
	THROW RATIO CALCULATION
================================= */

function calcThrowRatio() {

	// aspect ratio
	aspectLength = document.getElementsByName('aspect').length;
	formPortion = document.getElementById('scrnprtn').options.selectedIndex;
	// screen portion
	scrnPortion = document.getElementById('scrnprtn').options[formPortion].value;
	// screen unit
	formScrnUnit = document.getElementById('scrnunit');
	scrnUnit = formScrnUnit.options[document.getElementById('scrnunit').selectedIndex].value;
	// distance unit
	formDistUnit = document.getElementById('distunit');
	distUnit = formDistUnit.options[document.getElementById('distunit').selectedIndex].value;
	// calculating magnification
	scrnSize = document.getElementById('scrnsize').value;
	pjDist = document.getElementById('distance').value;

	// aspect ratio
	var	aspectRatio = (function() {

		for ( var i = 0 ; i < aspectLength ; i++ ) {

			if ( document.getElementsByName('aspect')[i].checked == true ) {
				var	aspectRatio = document.getElementsByName('aspect')[i].value;
				return aspectRatio;	
			}
		}

	}());


	// coefficiency

	/* coefScrnPortion ///
	16:10 - 1 (width), 0.625 (height), 1.17925 (diagonal)
	16:9 - 1 (width), 0.5625 (height), 1.14735 (diagonal)
	4:3 - 1 (width), 0.75 (height), 1.25 (diagonal)
	distUnit - 1 (mm), 304.8 (ft), 25.4 (in)
	/// */

	if ( aspectRatio == 1610 ) {

		// diagonal
		if ( scrnPortion == 'diag' && scrnUnit == 'in' && distUnit == 'mm' ) {
			coefScrnPortion = 1.17925, coefScrnUnit = 25.4, coefDistUnit = 1;
		} else if ( scrnPortion == 'diag' && scrnUnit == 'mm' && distUnit == 'mm' ) {
			coefScrnPortion = 1.17925, coefScrnUnit = 1, coefDistUnit = 1;
		} else if ( scrnPortion == 'diag' && scrnUnit == 'in' && distUnit == 'ft' ) {
			coefScrnPortion = 1.17925, coefScrnUnit = 25.4, coefDistUnit = 304.8;
		} else if ( scrnPortion == 'diag' && scrnUnit == 'mm' && distUnit == 'ft' ) {
			coefScrnPortion = 1.17925, coefScrnUnit = 1, coefDistUnit = 304.8;
		}

		// height
		else if ( scrnPortion == 'height' && scrnUnit == 'in' && distUnit == 'mm' ) {
			coefScrnPortion = 0.625, coefScrnUnit = 25.4, coefDistUnit = 1;
		} else if ( scrnPortion == 'height' && scrnUnit == 'mm' && distUnit == 'mm' ) {
			coefScrnPortion = 0.625, coefScrnUnit = 1, coefDistUnit = 1;
		} else if ( scrnPortion == 'height' && scrnUnit == 'in' && distUnit == 'ft' ) {
			coefScrnPortion = 0.625, coefScrnUnit = 25.4, coefDistUnit = 304.8;
		} else if ( scrnPortion == 'height' && scrnUnit == 'mm' && distUnit == 'ft' ) {
			coefScrnPortion = 0.625, coefScrnUnit = 1, coefDistUnit = 304.8;
		}

		// width
		else if ( scrnPortion == 'width' && scrnUnit == 'in' && distUnit == 'mm' ) {
			coefScrnPortion = 1, coefScrnUnit = 25.4, coefDistUnit = 1;
		} else if ( scrnPortion == 'width' && scrnUnit == 'mm' && distUnit == 'mm' ) {
			coefScrnPortion = 1, coefScrnUnit = 1, coefDistUnit = 1;
		} else if ( scrnPortion == 'width' && scrnUnit == 'in' && distUnit == 'ft' ) {
			coefScrnPortion = 1, coefScrnUnit = 25.4, coefDistUnit = 304.8;
		} else if ( scrnPortion == 'width' && scrnUnit == 'mm' && distUnit == 'ft' ) {
			coefScrnPortion = 1, coefScrnUnit = 1, coefDistUnit = 304.8;
		}

	}

	else if ( aspectRatio == 169 ) {

		// diagonal
		if ( scrnPortion == 'diag' && scrnUnit == 'in' && distUnit == 'mm' ) {
			coefScrnPortion = 1.14735, coefScrnUnit = 25.4, coefDistUnit = 1;
		} else if ( scrnPortion == 'diag' && scrnUnit == 'mm' && distUnit == 'mm' ) {
			coefScrnPortion = 1.14735, coefScrnUnit = 1, coefDistUnit = 1;
		} else if ( scrnPortion == 'diag' && scrnUnit == 'in' && distUnit == 'ft' ) {
			coefScrnPortion = 1.14735, coefScrnUnit = 25.4, coefDistUnit = 304.8;
		} else if ( scrnPortion == 'diag' && scrnUnit == 'mm' && distUnit == 'ft' ) {
			coefScrnPortion = 1.14735, coefScrnUnit = 1, coefDistUnit = 304.8;
		}

		// height
		else if ( scrnPortion == 'height' && scrnUnit == 'in' && distUnit == 'mm' ) {
			coefScrnPortion = 0.5625, coefScrnUnit = 25.4, coefDistUnit = 1;
		} else if ( scrnPortion == 'height' && scrnUnit == 'mm' && distUnit == 'mm' ) {
			coefScrnPortion = 0.5625, coefScrnUnit = 1, coefDistUnit = 1;
		} else if ( scrnPortion == 'height' && scrnUnit == 'in' && distUnit == 'ft' ) {
			coefScrnPortion = 0.5625, coefScrnUnit = 25.4, coefDistUnit = 304.8;
		} else if ( scrnPortion == 'height' && scrnUnit == 'mm' && distUnit == 'ft' ) {
			coefScrnPortion = 0.5625, coefScrnUnit = 1, coefDistUnit = 304.8;
		}

		// width
		else if ( scrnPortion == 'width' && scrnUnit == 'in' && distUnit == 'mm' ) {
			coefScrnPortion = 1, coefScrnUnit = 25.4, coefDistUnit = 1;
		} else if ( scrnPortion == 'width' && scrnUnit == 'mm' && distUnit == 'mm' ) {
			coefScrnPortion = 1, coefScrnUnit = 1, coefDistUnit = 1;
		} else if ( scrnPortion == 'width' && scrnUnit == 'in' && distUnit == 'ft' ) {
			coefScrnPortion = 1, coefScrnUnit = 25.4, coefDistUnit = 304.8;
		} else if ( scrnPortion == 'width' && scrnUnit == 'mm' && distUnit == 'ft' ) {
			coefScrnPortion = 1, coefScrnUnit = 1, coefDistUnit = 304.8;
		}

	}

	else if ( aspectRatio == 43 ) {

		// diagonal
		if ( scrnPortion == 'diag' && scrnUnit == 'in' && distUnit == 'mm' ) {
			coefScrnPortion = 1.25, coefScrnUnit = 25.4, coefDistUnit = 1;
		} else if ( scrnPortion == 'diag' && scrnUnit == 'mm' && distUnit == 'mm' ) {
			coefScrnPortion = 1.25, coefScrnUnit = 1, coefDistUnit = 1;
		} else if ( scrnPortion == 'diag' && scrnUnit == 'in' && distUnit == 'ft' ) {
			coefScrnPortion = 1.25, coefScrnUnit = 25.4, coefDistUnit = 304.8;
		} else if ( scrnPortion == 'diag' && scrnUnit == 'mm' && distUnit == 'ft' ) {
			coefScrnPortion = 1.25, coefScrnUnit = 1, coefDistUnit = 304.8;
		}

		// height
		else if ( scrnPortion == 'height' && scrnUnit == 'in' && distUnit == 'mm' ) {
			coefScrnPortion = 0.75, coefScrnUnit = 25.4, coefDistUnit = 1;
		} else if ( scrnPortion == 'height' && scrnUnit == 'mm' && distUnit == 'mm' ) {
			coefScrnPortion = 0.75, coefScrnUnit = 1, coefDistUnit = 1;
		} else if ( scrnPortion == 'height' && scrnUnit == 'in' && distUnit == 'ft' ) {
			coefScrnPortion = 0.75, coefScrnUnit = 25.4, coefDistUnit = 304.8;
		} else if ( scrnPortion == 'height' && scrnUnit == 'mm' && distUnit == 'ft' ) {
			coefScrnPortion = 0.75, coefScrnUnit = 1, coefDistUnit = 304.8;
		}

		// width
		else if ( scrnPortion == 'width' && scrnUnit == 'in' && distUnit == 'mm' ) {
			coefScrnPortion = 1, coefScrnUnit = 25.4, coefDistUnit = 1;
		} else if ( scrnPortion == 'width' && scrnUnit == 'mm' && distUnit == 'mm' ) {
			coefScrnPortion = 1, coefScrnUnit = 1, coefDistUnit = 1;
		} else if ( scrnPortion == 'width' && scrnUnit == 'in' && distUnit == 'ft' ) {
			coefScrnPortion = 1, coefScrnUnit = 25.4, coefDistUnit = 304.8;
		} else if ( scrnPortion == 'width' && scrnUnit == 'mm' && distUnit == 'ft' ) {
			coefScrnPortion = 1, coefScrnUnit = 1, coefDistUnit = 304.8;
		}

	}


	// Screen size limitaion

	scrnWidth = scrnSize * coefScrnUnit / coefScrnPortion;	// screen width in mm

	if (scrnWidth != 0) {

		if (scrnWidth < ( scrnSizeMin / coefScrnPortion * 25.4 ) || ( scrnSizeMax / coefScrnPortion * 25.4 ) < scrnWidth) {

			var	scrnSizeAlert = 'You entered an improper value.\nScreen size should be between '+scrnSizeMin+' and '+scrnSizeMax+' inches* diagonally.\nPlease enter a new value.\n\n\t* between '+scrnSizeMinMm+' and '+scrnSizeMaxMm+' millimeters.';
			alert(scrnSizeAlert);
			resetFinder();

		}
	
	}
	

	// projection distance limitation

	if ( aspectRatio == 1610 ) {

		if ( window.maxDistMm1610 != undefined && ( pjDist * coefDistUnit ) > maxDistMm1610 ) {

			alert('The picture quality of a projection distance exceeding '+maxDistMm1610Str+' millimeters ('+maxDistFt1610+' feet) cannot be assured.');

		}

	}

	if ( aspectRatio == 169 ) {

		if ( window.maxDistMm169 != undefined && ( pjDist * coefDistUnit ) > maxDistMm169 ) {

			alert('The picture quality of a projection distance exceeding '+maxDistMm169Str+' millimeters ('+maxDistFt169+' feet) cannot be assured.');

		}

	}

	if ( aspectRatio == 43 ) {

		if ( window.maxDistMm43 != undefined && ( pjDist * coefDistUnit ) > maxDistMm43 ) {

			alert('The picture quality of a projection distance exceeding '+maxDistMm43Str+' millimeters ('+maxDistFt43+' feet) cannot be assured.');

		}

	}


	// throw ratio

	throwRatio = Math.round ( ( pjDist * coefDistUnit ) / ( scrnSize * coefScrnUnit / coefScrnPortion ) * 1000 ) / 1000;

	// screen size for projection range: screen size diag in mm

	if ( aspectRatio == 1610 ) {
		scrnDiag = scrnSize * coefScrnUnit * 1.17925 / coefScrnPortion;

	}
	else if ( aspectRatio == 169 ) {
		scrnDiag = scrnSize * coefScrnUnit * 1.14735 / coefScrnPortion;

	}
	else if ( aspectRatio == 43 ) {
		scrnDiag = scrnSize * coefScrnUnit * 1.25 / coefScrnPortion;

	}

}


// CHECKING AND CALCULATION

function chkvalue(form){

	scrnSize = document.getElementById('scrnsize').value;
	pjDist = document.getElementById('distance').value;

	if ( eval(scrnSize) != null || eval(pjDist) != null ){

		calcThrowRatio();
		lensFinder();
		canvasApp();
		lensResultBorder();

	}

	else {

		window.alert('Please input values for both \nimage size and projection distance.');
		link = '#';

	}

}


// CALCULATOR LINK

function goLens(){
	location.href = link;
}


/* =================================
	LENS FINDER - RESULT STYLE
================================= */

function lensResultBorder() {

	var	lensSpecArea = document.getElementById('option-lens-spec');

	if ( screen.width >= 420 ) {

		lensSpecArea.style.width = '358px';
		lensSpecArea.style.margin = '8px auto';
		lensSpecArea.style.padding = '16px';
		lensSpecArea.style.border = 'solid 1px';

	}

	else {

		lensSpecArea.style.width = '296px';
		lensSpecArea.style.margin = '4px auto';
		lensSpecArea.style.padding = '8px';
		lensSpecArea.style.border = 'solid 1px';

	}

}


/* =================================
	RESET FOR LENS FINDER
================================= */


function resetFinder() {

	if ( throwRatio != null ) {
		throwRatio = null;
		canvasApp();
	}

	// user-input - getting back to default
	document.getElementById('selector-input').reset();

	// clearing results
//	document.getElementById('selector-result-area').reset();

	var	stLensH2= document.getElementById('option-lens-title');
		stLensDiv1 = document.getElementById('option-lens-1'),
		stLensDiv2 = document.getElementById('option-lens-2'),
		throwRatioDiv = document.getElementById('calculated-throw-ratio'),
		pjRangeDiv = document.getElementById('projection-range-title'),
		pjRangeDiv1 = document.getElementById('projection-range-1'),
		pjRangeDiv2 = document.getElementById('projection-range-2'),
		elBr1 = document.createElement('br'),
		elBr2 = document.createElement('br'),
		// for recalculation
		stLensOldTitle = document.getElementById('option-lens-title').firstChild,
		stLensOldText1 = document.getElementById('option-lens-1').firstChild,
		stLensOldText2 = document.getElementById('option-lens-2').firstChild,
		throwRatioOldText = document.getElementById('calculated-throw-ratio').firstChild,
		pjRangeOldTitle = document.getElementById('projection-range-title').firstChild,
		pjRangeOldText1 = document.getElementById('projection-range-1').firstChild,
		pjRangeOldText2 = document.getElementById('projection-range-2').firstChild,
		lensSpecArea = document.getElementById('option-lens-spec');

	// reset result border
	
	lensSpecArea.style.width = '0';
	lensSpecArea.style.margin = '0';
	lensSpecArea.style.padding = '0';
	lensSpecArea.style.border = '0';


	// reset lens spec

	if ( stLensOldText1 != null ) {

		stLensH2.removeChild(stLensOldTitle);
		stLensDiv1.removeChild(stLensOldText1);
		throwRatioDiv.removeChild(throwRatioOldText);

		if ( pjRangeOldTitle != null ) {
		pjRangeDiv.removeChild(pjRangeOldTitle);

			while ( pjRangeDiv1.lastChild ) {
			  pjRangeDiv1.removeChild(pjRangeDiv1.lastChild);
			}

			if ( stLensOldText2 != null ) {
				stLensDiv2.removeChild(stLensOldText2);
				while ( pjRangeDiv2.lastChild ) {
				  pjRangeDiv2.removeChild(pjRangeDiv2.lastChild);
				}

			}

		}

	}

}
